n = int(input())
participants = []
participants.sort(reverse=True)
class Olympiad:
    def __init__(self, name, condition, count):
        self.name = name
        self.condition = condition
        self.count = count

    def print_participants(self, participants):
        print(self.name)
        printed = 0
        for _, id, gender, grade, age in sorted(participants, key=lambda x: x[1]):
            if self.condition(gender, grade, age):
                print(id)
                printed += 1
            if printed == self.count:
                break
for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append((int(score), int(id), gender, int(grade), int(age)))


olympiads = {
    'IOI': Olympiad('IOI', lambda gender, grade, age: True, 4),
    'CEOI': Olympiad('CEOI', lambda gender, grade, age: True, 4),
    'EGOI': Olympiad('EGOI', lambda gender, grade, age: gender == 'female', 4),
    'EJOI': Olympiad('EJOI', lambda gender, grade, age: age <= 15, 4),
    'BaltOI': Olympiad('BaltOI', lambda gender, grade, age: True, 6),
    'BalkOI': Olympiad('BalkOI', lambda gender, grade, age: grade != 11, 4),
    'JBOI': Olympiad('JBOI', lambda gender, grade, age: grade not in [10, 11], 4),
}

m = int(input())
for _ in range(m):
    olympiad_name = input().strip()
    olympiad = olympiads[olympiad_name]
    olympiad.print_participants(participants)
