from collections import defaultdict


def determine_team(olympiad, participants):
    team = []
    if olympiad == "IOI":
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "CEOI":
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == 'female']
        team = sorted(female_participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "EJOI":
        under_15_participants = [p for p in participants if p[3] <= 15]
        team = sorted(under_15_participants, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "BaltOI":
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:6]
    elif olympiad == "BalkOI":
        not_11th_graders = [p for p in participants if p[2] != 11]
        team = sorted(not_11th_graders, key=lambda x: x[4], reverse=True)[:4]
    elif olympiad == "JBOI":
        not_11th_10th_graders = [p for p in participants if p[2] not in {10, 11}]
        team = sorted(not_11th_10th_graders, key=lambda x: x[4], reverse=True)[:4]
    return team



n = int(input())
participants = []

for _ in range(n):
    data = input().split()
    participants.append((int(data[0]), data[1], int(data[2]), int(data[3]), int(data[4])))

m = int(input())
olympiads = [input() for _ in range(m)]


participants_by_olympiad = defaultdict(list)
for olympiad in olympiads:
    participants_by_olympiad[olympiad] = determine_team(olympiad, participants)

for olympiad in olympiads:
    print(olympiad)
    for participant in sorted(participants_by_olympiad[olympiad]):
        print(participant[0])