# Define a function to calculate a participant's score based on their gender, age, and results
def calculate_score(gender, age, result):
    return age + (result * (1 if gender == 'male' else 0.5))

# Define a function to determine if a participant meets the requirements for an Olympiad
def meets_requirements(participant, olympiad):
    return True # Assuming all Olympiads are open to all participants for simplicity

# Read the number of Olympiads and participants
m, n = map(int, input().split())

# Initiate a dictionary with Olympiad names as keys and empty lists as values
olympiads = {olympiad: [] for olympiad in input().split()}

# For each row of participants' data
for _ in range(n):
    id, gender, age, result = input().split()
    id = int(id)
    result = int(result)

    # Calculate the participant's score
    score = calculate_score(gender, age, result)

    # If the participant meets the requirements for any Olympiad
    for olympiad in olympiads:
        if meets_requirements((id, score), olympiad):
            # Append the participant's id to the corresponding list in the dictionary
            olympiads[olympiad].append(id)

# For each Olympiad
for olympiad in olympiads:
    # Sort the list of participant ids in ascending order
    olympiads[olympiad].sort()

    # Print the Olympiad name followed by the sorted list of participant ids
    print(olympiad, *olympiads[olympiad])
