#include <iostream>
#include <vector>
#include <algorithm>

struct Participant {
    int id, grade, age, score;
    std::string gender;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.score > p2.score;
}

int main() {
    int n, m;
    std::cin >> n;

    std::vector<Participant> participants;
    for (int i = 0; i < n; ++i) {
        Participant p;
        std::cin >> p.id >> p.gender >> p.grade >> p.age >> p.score;
        participants.push_back(p);
    }

    std::sort(participants.begin(), participants.end(), compareParticipants);

    std::cin >> m;
    for (int i = 0; i < m; ++i) {
        std::string olympiad;
        std::cin >> olympiad;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            for (int j = 0; j < std::min(4, n); ++j) {
                std::cout << olympiad << "\n" << participants[j].id << "\n";
            }
        } else if (olympiad == "EGOI") {
            int count = 0;
            for (const Participant& p : participants) {
                if (p.gender == "female" && count < 4) {
                    std::cout << olympiad << "\n" << p.id << "\n";
                    ++count;
                }
            }
        } else if (olympiad == "EJOI") {
            int count = 0;
            for (const Participant& p : participants) {
                if (p.age <= 15 && count < 4) {
                    std::cout << olympiad << "\n" << p.id << "\n";
                    ++count;
                }
            }
        } else if (olympiad == "BalkOI") {
            int count = 0;
            for (const Participant& p : participants) {
                if (p.grade != 11 && count < 4) {
                    std::cout << olympiad << "\n" << p.id << "\n";
                    ++count;
                }
            }
        } else if (olympiad == "JBOI") {
            int count = 0;
            for (const Participant& p : participants) {
                if (p.grade != 11 && p.grade != 10 && count < 4) {
                    std::cout << olympiad << "\n" << p.id << "\n";
                    ++count;
                }
            }
        }
    }

    return 0;
}