#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
    int id;
    string gender;
    int age;
    int height;
    int score;
};

bool compareParticipants(const Participant& a, const Participant& b) {
    return a.score > b.score;
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].age
            >> participants[i].height >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int k;
    cin >> k;

    for (int i = 0; i < k; ++i) {
        string category;
        cin >> category;

        cout << category << endl;

        vector<int> selected_ids;

        if (category == "IOI") {
            for (const Participant& participant : participants) {
                if (participant.score >= 400) {
                    selected_ids.push_back(participant.id);
                    if (selected_ids.size() == 4) {
                        break;
                    }
                }
            }
        } else if (category == "EGOI") {
            for (const Participant& participant : participants) {
                if (participant.gender == "female" && participant.score >= 350) {
                    selected_ids.push_back(participant.id);
                    if (selected_ids.size() == 3) {
                        break;
                    }
                }
            }
        } else if (category == "BaltOI") {
            for (const Participant& participant : participants) {
                selected_ids.push_back(participant.id);
                if (selected_ids.size() == 6) {
                    break;
                }
            }
        }

        for (int j : selected_ids) {
            cout << j << endl;
        }
    }

    return 0;
}
