from collections import defaultdict
def determine_team(olympiad, participants):
    teams = defaultdict(list)
    if olympiad == 'IOI' or olympiad == 'CEOI':
        participants.sort(key=lambda x: x[4], reverse=True)
        teams[olympiad] = [participant[0] for participant in participants[:4]]
    elif olympiad == 'EGOI':
        female_participants = [participant for participant in participants if participant[1] == 'female']
        female_participants.sort(key=lambda x: x[4], reverse=True)
        teams[olympiad] = [participant[0] for participant in female_participants[:4]]
    elif olympiad == 'EJOI':
        under_15_participants = [participant for participant in participants if participant[3] <= 15]
        under_15_participants.sort(key=lambda x: x[4], reverse=True)
        teams[olympiad] = [participant[0] for participant in under_15_participants[:4]]
    elif olympiad == 'BaltOI':
        participants.sort(key=lambda x: x[4], reverse=True)
        teams[olympiad] = [participant[0] for participant in participants[:6]]
    elif olympiad == 'BalkOI':
        not_11th_grade_participants = [participant for participant in participants if participant[2] != 11]
        not_11th_grade_participants.sort(key=lambda x: x[4], reverse=True)
        teams[olympiad] = [participant[0] for participant in not_11th_grade_participants[:4]]
    elif olympiad == 'JBOI':
        not_11th_10th_grade_participants = [participant for participant in participants if participant[2] != 11 and participant[2] != 10]
        not_11th_10th_grade_participants.sort(key=lambda x: x[4], reverse=True)
        teams[olympiad] = [participant[0] for participant in not_11th_10th_grade_participants[:4]]
    return teams
n = int(input())
participants = []
for _ in range(n):
    participant_info = list(input().split())
    participant_info[0] = int(participant_info[0])  # Перетворення id учасника на ціле число
    participant_info[3] = int(participant_info[3])  # Перетворення віку учасника на ціле число
    participant_info[4] = int(participant_info[4])  # Перетворення кількості балів на ціле число
    participants.append(participant_info)
m = int(input())
olympiads = []
for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)
for olympiad in olympiads:
    teams = determine_team(olympiad, participants)
    for participant_id in teams[olympiad]:
        print(f"{olympiad} {participant_id}")