# Read input values
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Calculate the initial weights of the boxes
box_weights = [0, 0]
for i in range(4):
    box_weights[boxes[i] - 1] += weights[i]

# Check if it is optimal to not change anything
if max(box_weights) >= sum(weights) - max(weights):
    print("-1")
else:
    # Initialize variables to track the optimal move
    optimal_move = -1
    min_max_weight = float('inf')

    # Iterate through each item and check if moving it minimizes the maximum weight
    for i in range(4):
        other_box = 3 - (boxes[i] - 1)  # Calculate the index of the other box
        new_max_weight = max(box_weights[other_box] + weights[i] - box_weights[boxes[i] - 1],
                             box_weights[boxes[i] - 1] - weights[i] + box_weights[other_box])

        # If moving the item improves the distribution, update the optimal move
        if new_max_weight < min_max_weight:
            min_max_weight = new_max_weight
            optimal_move = i + 1

    # Print the final answer
    print(optimal_move)
