#include <iostream>
#include <vector>
#include <algorithm>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.score > p2.score || (p1.score == p2.score && p1.id < p2.id);
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::vector<std::string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> olympiads[i];
    }

    std::sort(participants.begin(), participants.end(), compareParticipants);

    for (const auto& olympiad : olympiads) {
        std::cout << olympiad << std::endl;

        if (olympiad == "IOI") {
            for (const auto& participant : participants) {
                if (participant.grade >= 1 && participant.grade <= 12) {
                    std::cout << participant.id << std::endl;
                }
            }
        } else if (olympiad == "CEOI") {
            for (const auto& participant : participants) {
                if (participant.grade >= 1 && participant.grade <= 12) {
                    std::cout << participant.id << std::endl;
                }
            }
        } else if (olympiad == "EGOI") {
            int femaleCount = 0;
            for (const auto& participant : participants) {
                if (participant.gender == "female" && femaleCount < 4) {
                    std::cout << participant.id << std::endl;
                    ++femaleCount;
                }
            }
        } else if (olympiad == "EJOI") {
            int youngCount = 0;
            for (const auto& participant : participants) {
                if (participant.age <= 15 && youngCount < 4) {
                    std::cout << participant.id << std::endl;
                    ++youngCount;
                }
            }
        } else if (olympiad == "BaltOI") {
            for (const auto& participant : participants) {
                if (participant.grade >= 1 && participant.grade <= 12) {
                    std::cout << participant.id << std::endl;
                }
            }
        } else if (olympiad == "BalkOI") {
            int nonElevenCount = 0;
            for (const auto& participant : participants) {
                if (participant.grade != 11 && nonElevenCount < 4) {
                    std::cout << participant.id << std::endl;
                    ++nonElevenCount;
                }
            }
        } else if (olympiad == "JBOI") {
            int nonTenElevenCount = 0;
            for (const auto& participant : participants) {
                if (participant.grade != 10 && participant.grade != 11 && nonTenElevenCount < 4) {
                    std::cout << participant.id << std::endl;
                    ++nonTenElevenCount;
                }
            }
        }
    }

    return 0;
}
