#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric> // Додано для accumulate

using namespace std;

long long countSubarrays(long long mid, const vector<long long>& colors) {
    long long count = 0;
    long long last_index = -1;

    for (int i = 0; i < colors.size(); ++i) {
        if (colors[i] <= mid) {
            count += (i - last_index) * (colors.size() - i);
            last_index = i;
        }
    }

    return count;
}

long long findMaxSubarrayLength(int n, long long m, const vector<long long>& colors) {
    long long left = 0, right = *max_element(colors.begin(), colors.end());

    while (left < right) {
        long long mid = (left + right + 1) / 2;
        long long count = countSubarrays(mid, colors);

        if (count < m) {
            left = mid;
        } else {
            right = mid - 1;
        }
    }

    return left;
}

int main() {
    int n;
    long long m;
    cin >> n >> m;

    vector<long long> colors(n);
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    long long result = findMaxSubarrayLength(n, m, colors);
    cout << result << endl;

    return 0;
}
