#include <iostream>
#include <vector>
#include <algorithm>

long long findMaxUnmarkedSubarray(const std::vector<long long>& colors) {
    long long n = colors.size();
    long long maxLength = 0;
    long long currentLength = 0;

    for (long long color : colors) {
        if (color % 2 == 1) {
            currentLength += color;
        } else {
            maxLength = std::max(maxLength, currentLength);
            currentLength = 0;
        }
    }

    maxLength = std::max(maxLength, currentLength);

    return maxLength;
}

int main() {
    long long n, m;
    std::cin >> n >> m;

    std::vector<long long> a(n);
    for (long long& color : a) {
        std::cin >> color;
    }

    long long maxUnmarkedSubarray = findMaxUnmarkedSubarray(a);
    std::cout << maxUnmarkedSubarray << std::endl;

    return 0;
}
