using System;

class Program
{
    static void Main()
    {
        string[] input = Console.ReadLine().Split();
        int n = int.Parse(input[0]);
        long m = long.Parse(input[1]);

        long[] a = Array.ConvertAll(Console.ReadLine().Split(), long.Parse);

        long maxSubsegmentLength = GetMaxSubsegmentLength(n, m, a);
        Console.WriteLine(maxSubsegmentLength);
    }

    static long GetMaxSubsegmentLength(int n, long m, long[] a)
    {
        long maxSubsegmentLength = 0;

        if (n == 1)
        {
            maxSubsegmentLength = a[0] - 1;
        }
        else
        {
            long[] prefixSum = new long[n];
            prefixSum[0] = a[0] - 1;

            for (int i = 1; i < n; i++)
            {
                prefixSum[i] = prefixSum[i - 1] + a[i] - 1;
            }

            for (int i = 0; i < n; i++)
            {
                long remainingColors = m - prefixSum[i];

                if (remainingColors <= 0)
                {
                    maxSubsegmentLength = Math.Max(maxSubsegmentLength, a[i] - 1 + m);
                }
                else
                {
                    long subsegmentLength = a[i] - 1;

                    if (i > 0)
                    {
                        subsegmentLength += (remainingColors % 2 == 0) ? a[i - 1] : a[i];
                    }

                    maxSubsegmentLength = Math.Max(maxSubsegmentLength, subsegmentLength);
                }
            }
        }

        return maxSubsegmentLength;
    }
}
