from collections import defaultdict

def get_team_for_olympiad(participants, olympiad, required_count):
    team = []
    if olympiad == 'IOI' or olympiad == 'CEOI':
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:required_count]
    elif olympiad == 'EGOI':
        team = sorted([p for p in participants if p[1] == 'female'], key=lambda x: x[4], reverse=True)[:required_count]
    elif olympiad == 'EJOI':
        team = sorted([p for p in participants if p[3] <= 15], key=lambda x: x[4], reverse=True)[:required_count]
    elif olympiad == 'BaltOI':
        team = sorted(participants, key=lambda x: x[4], reverse=True)[:required_count]
    elif olympiad == 'BalkOI':
        team = sorted([p for p in participants if p[3] != 11], key=lambda x: x[4], reverse=True)[:required_count]
    elif olympiad == 'JBOI':
        team = sorted([p for p in participants if p[3] != 11 and p[3] != 10], key=lambda x: x[4], reverse=True)[:required_count]
    return sorted([p[0] for p in team])

def main():
    n = int(input())
    participants = [tuple(map(int, input().split())) for _ in range(n)]

    m = int(input())
    olympiads = [input() for _ in range(m)]

    teams = defaultdict(list)
    for olympiad in olympiads:
        required_count = 4 if olympiad != 'BaltOI' else 6
        teams[olympiad] = get_team_for_olympiad(participants, olympiad, required_count)

    for olympiad in olympiads:
        print(olympiad)
        for participant_id in teams[olympiad]:
            print(participant_id)

if __name__ == "__main__":
    main()
