def form_team(results, participants):
    teams = {}

    for olympiad, criteria in results.items():
        participants_copy = participants.copy()

        if olympiad in participants_copy:
            del participants_copy[olympiad]

        teams[olympiad] = []

        for criterion in criteria:
            if criterion == 'girls':
                girls_participants = [p for p in participants_copy[olympiad] if p['gender'] == 'female']
                teams[olympiad].extend(sorted(girls_participants, key=lambda x: x['score'], reverse=True)[:4])
            elif criterion == 'under_15':
                under_15_participants = [p for p in participants_copy[olympiad] if p['age'] < 15]
                teams[olympiad].extend(sorted(under_15_participants, key=lambda x: x['score'], reverse=True)[:4])
            elif criterion == 'not_11th_grade':
                not_11th_grade_participants = [p for p in participants_copy[olympiad] if p['grade'] != 11]
                teams[olympiad].extend(sorted(not_11th_grade_participants, key=lambda x: x['score'], reverse=True)[:4])
            else:
                teams[olympiad].extend(sorted(participants_copy[olympiad], key=lambda x: x['score'], reverse=True)[:criteria[criterion]])

    return teams

# Приклад вхідних даних:
results = {
    'IOI': 4,
    'CEOI': 4,
    'EGOI': {'girls': 4},
    'EJOI': {'under_15': 4},
    'BaltOI': 6,
    'BalkOI': {'not_11th_grade': 4},
    'JBOI': {'not_11th_grade': 4}
}

participants = {
    'IOI': [
        {'name': 'Alice', 'score': 90, 'gender': 'female', 'age': 16, 'grade': 11},
        # Додайте інші учасниці IOI
    ],
    'CEOI': [
        {'name': 'Bob', 'score': 85, 'gender': 'male', 'age': 17, 'grade': 12},
        # Додайте інші учасники CEOI
    ],
    # Аналогічно додайте інші учасники для решти олімпіад
}

teams = form_team(results, participants)

# Виведення результатів
for olympiad, team in teams.items():
    print(f"Team for {olympiad}:")
    for member in team:
        print(f"{member['name']} - {member['score']} points")
    print()
