# Зчитування вхідних даних
n = int(input())
participants = []

for _ in range(n):
    id, gender, grade, age, score = map(int, input().split())
    participants.append({'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score})

m = int(input())
selected_olympiads = [input().strip() for _ in range(m)]

# Функція для формування команди на основі критеріїв олімпіади
def form_team(olympiad, criteria):
    sorted_participants = sorted(participants, key=lambda x: x['score'], reverse=True)
    team = [p['id'] for p in sorted_participants[:criteria]]
    return sorted(team)

# Виведення результатів
for olympiad in selected_olympiads:
    team = []
    if olympiad == 'IOI':
        team = form_team('IOI', 4)
    elif olympiad == 'CEOI':
        team = form_team('CEOI', 4)
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p['gender'] == 'female']
        team = form_team('EGOI', min(4, len(female_participants)))
    elif olympiad == 'EJOI':
        young_participants = [p for p in participants if p['age'] <= 15]
        team = form_team('EJOI', min(4, len(young_participants)))
    elif olympiad == 'BaltOI':
        team = form_team('BaltOI', 6)
    elif olympiad == 'BalkOI':
        non_11th_graders = [p for p in participants if p['grade'] != 11]
        team = form_team('BalkOI', min(4, len(non_11th_graders)))
    elif olympiad == 'JBOI':
        non_11th_10th_graders = [p for p in participants if p['grade'] not in {10, 11}]
        team = form_team('JBOI', min(4, len(non_11th_10th_graders)))

    print(olympiad)
    for participant_id in team:
        print(participant_id)
    print()
