def form_teams(n, participants, m, olympiads):
    teams = {}

    for olympiad in olympiads:
        if olympiad == "IOI":
            teams["IOI"] = get_top_participants(participants, 4)
        elif olympiad == "CEOI":
            teams["CEOI"] = get_top_participants(participants, 4)
        elif olympiad == "EGOI":
            female_participants = [p for p in participants if p["gender"] == "female"]
            teams["EGOI"] = get_top_participants(female_participants, 4)
        elif olympiad == "EJOI":
            young_participants = [p for p in participants if p["age"] <= 15]
            teams["EJOI"] = get_top_participants(young_participants, 4)
        elif olympiad == "BaltOI":
            teams["BaltOI"] = get_top_participants(participants, 6)
        elif olympiad == "BalkOI":
            non_11th_graders = [p for p in participants if p["grade"] != 11]
            teams["BalkOI"] = get_top_participants(non_11th_graders, 4)
        elif olympiad == "JBOI":
            non_11th_10th_graders = [p for p in participants if p["grade"] != 11 and p["grade"] != 10]
            teams["JBOI"] = get_top_participants(non_11th_10th_graders, 4)

    result = []
    for olympiad in olympiads:
        team = teams.get(olympiad, [])
        team_ids = [str(p["id"]) for p in team]
        result.append(f"{olympiad}\n{' '.join(team_ids)}")

    return result

def get_top_participants(participants, num):
    sorted_participants = sorted(participants, key=lambda x: x["score"], reverse=True)
    return sorted_participants[:num]

# Зчитування вхідних даних
n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participant = {
        "id": int(participant_info[0]),
        "gender": participant_info[1],
        "grade": int(participant_info[2]),
        "age": int(participant_info[3]),
        "score": int(participant_info[4]),
    }
    participants.append(participant)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Формування команд
result = form_teams(n, participants, m, olympiads)

# Виведення результату
for line in result:
    print(line)