def calculate_weights(weights, boxes):
    current_weights = [0, 0]
    for w, b in zip(weights, boxes):
        current_weights[b - 1] += w
    return current_weights

def find_item_to_move(weights, boxes):
    current_weights = calculate_weights(weights, boxes)
    
    min_max_weight = float('inf')
    item_to_move = -1

    for i, (w, b) in enumerate(zip(weights, boxes)):
        current_weights[b - 1] -= w
        current_weights[1 - (b - 1)] += w

        max_weight = max(current_weights)
        if max_weight < min_max_weight:
            min_max_weight = max_weight
            item_to_move = i + 1

        current_weights[1 - (b - 1)] -= w
        current_weights[b - 1] += w

    return item_to_move

# Example Input
weights = [4, 2, 3, 7]
boxes = [2, 1, 1, 2]

# Find the item to move
result = find_item_to_move(weights, boxes)

# Output the result
print(result)
