def calculate_weights(weights, boxes):
    current_weights = [0, 0]
    for w, b in zip(weights, boxes):
        current_weights[b - 1] += w
    return current_weights

def find_item_to_move(weights, boxes):
    n = len(weights)
    items_to_move = []

    current_weights = calculate_weights(weights, boxes)

    # Move all items from boxes with only one item
    for i in range(n):
        if weights[i] == current_weights[boxes[i] - 1]:
            items_to_move.append(i + 1)

    # If all items have been moved, return the list of items to move
    if len(items_to_move) == n:
        return items_to_move

    min_max_weight = float('inf')
    item_to_move = -1

    # Move each remaining item and calculate the maximum weight of the boxes
    for i in range(n):
        if i + 1 not in items_to_move:
            current_weights[boxes[i] - 1] -= weights[i]
            current_weights[1 - (boxes[i] - 1)] += weights[i]

            max_weight = max(current_weights)
            if max_weight < min_max_weight:
                min_max_weight = max_weight
                item_to_move = i + 1

            current_weights[1 - (boxes[i] - 1)] -= weights[i]
            current_weights[boxes[i] - 1] += weights[i]

    items_to_move.append(item_to_move)
    return items_to_move

# Example Input
weights = [4, 2, 3, 7]
boxes = [2, 1, 1, 2]

# Find the item to move
result = find_item_to_move(weights, boxes)

# Output the result
print(result)