def generate_ornament(n, m):
    ornament = [['.'] * m for _ in range(n)]

    # Traverse from top-left to bottom-right
    x, y = 0, 0
    while x < n and y < m:
        ornament[x][y] = 'x'

        # Reflect the ray when it touches the vertical edge
        if y == m - 1:
            x += 1
            y -= 1
        else:
            x += 1
            y += 1

    # Traverse from top-right to bottom-left
    x, y = n - 1, 0
    while x >= 0 and y < m:
        ornament[x][y] = 'x'

        # Reflect the ray when it touches the vertical edge
        if y == m - 1:
            x -= 1
            y -= 1
        else:
            x -= 1
            y += 1

    return ornament

def main():
    n, m = map(int, input().split())
    ornament = generate_ornament(n, m)
    for row in ornament:
        print(''.join(row))

main()