from heapq import nlargest
from collections import defaultdict

def main():
    # Input
    n = int(input())
    participants = []
    for _ in range(n):
        participant_info = input().split()
        participants.append({
            'id': int(participant_info[0]),
            'gender': participant_info[1],
            'grade': int(participant_info[2]),
            'age': int(participant_info[3]),
            'score': int(participant_info[4])
        })

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    # Process participants based on olympiad criteria
    results = defaultdict(list)
    for olympiad in olympiads:
        if olympiad == 'IOI' or olympiad == 'CEOI':
            top_participants = nlargest(4, participants, key=lambda x: x['score'])
        elif olympiad == 'EGOI':
            top_females = nlargest(4, filter(lambda x: x['gender'] == 'female', participants), key=lambda x: x['score'])
            top_participants = top_females
        elif olympiad == 'EJOI':
            top_under_15 = nlargest(4, filter(lambda x: x['age'] < 15, participants), key=lambda x: x['score'])
            top_participants = top_under_15
        elif olympiad == 'BaltOI':
            top_participants = nlargest(6, participants, key=lambda x: x['score'])
        elif olympiad == 'BalkOI':
            top_non_11th = nlargest(4, filter(lambda x: x['grade'] != 11, participants), key=lambda x: x['score'])
            top_participants = top_non_11th
        elif olympiad == 'JBOI':
            top_non_10th_11th = nlargest(4, filter(lambda x: x['grade'] not in {10, 11}, participants), key=lambda x: x['score'])
            top_participants = top_non_10th_11th

        for participant in top_participants:
            results[olympiad].append(participant['id'])

    # Output results
    for olympiad in olympiads:
        print(olympiad)
        for participant_id in sorted(results[olympiad]):
            print(participant_id)

if __name__ == "__main__":
    main()
