#include <iostream>
#include <vector>
#include <algorithm>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.score > p2.score;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; i++) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    for (int i = 0; i < m; i++) {
        std::string olympiad;
        std::cin >> olympiad;

        std::vector<Participant> team;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            std::sort(participants.begin(), participants.end(), compareParticipants);
            int teamSize = (olympiad == "BaltOI") ? 6 : 4;
            for (int j = 0; j < teamSize && j < n; j++) {
                team.push_back(participants[j]);
            }
        } else if (olympiad == "EGOI") {
            std::vector<Participant> females;
            for (const auto& participant : participants) {
                if (participant.gender == "female") {
                    females.push_back(participant);
                }
            }
            std::sort(females.begin(), females.end(), compareParticipants);
            int teamSize = std::min(4, static_cast<int>(females.size()));
            for (int j = 0; j < teamSize; j++) {
                team.push_back(females[j]);
            }
        } else if (olympiad == "EJOI") {
            std::vector<Participant> youngParticipants;
            for (const auto& participant : participants) {
                if (participant.age <= 15) {
                    youngParticipants.push_back(participant);
                }
            }
            std::sort(youngParticipants.begin(), youngParticipants.end(), compareParticipants);
            int teamSize = std::min(4, static_cast<int>(youngParticipants.size()));
            for (int j = 0; j < teamSize; j++) {
                team.push_back(youngParticipants[j]);
            }
        } else if (olympiad == "BalkOI") {
            std::vector<Participant> non11thGraders;
            for (const auto& participant : participants) {
                if (participant.grade != 11) {
                    non11thGraders.push_back(participant);
                }
            }
            std::sort(non11thGraders.begin(), non11thGraders.end(), compareParticipants);
            int teamSize = std::min(4, static_cast<int>(non11thGraders.size()));
            for (int j = 0; j < teamSize; j++) {
                team.push_back(non11thGraders[j]);
            }
        } else if (olympiad == "JBOI") {
            std::vector<Participant> non11thOr10thGraders;
            for (const auto& participant : participants) {
                if (participant.grade != 11 && participant.grade != 10) {
                    non11thOr10thGraders.push_back(participant);
                }
            }
            std::sort(non11thOr10thGraders.begin(), non11thOr10thGraders.end(), compareParticipants);
            int teamSize = std::min(4, static_cast<int>(non11thOr10thGraders.size()));
            for (int j = 0; j < teamSize; j++) {
                team.push_back(non11thOr10thGraders[j]);
            }
        }

        std::cout << olympiad << std::endl;
        for (const auto& participant : team) {
            std::cout << participant.id << std::endl;
        }
    }

    return 0;
}
