import heapq

def choose_colors(n, m, a):
    # Create a max heap to store the lengths of the sequences of unmarked colors for each color wheel.
    lengths = []
    for ai in a:
        heapq.heappush(lengths, -ai)

    # Keep choosing the longest sequence of unmarked colors until Miss M has chosen all the colors she wants.
    while m > 0:
        # Get the length of the longest sequence of unmarked colors.
        max_length = -heapq.heappop(lengths)

        # If the length of the longest sequence is odd, choose the color in the middle.
        if max_length % 2 == 1:
            middle = max_length // 2
            heapq.heappush(lengths, -middle)
            heapq.heappush(lengths, -(middle + 1))
        # Otherwise, choose one of the two middle colors.
        else:
            middle = max_length // 2 - 1
            heapq.heappush(lengths, -middle)
            heapq.heappush(lengths, -(middle + 1))
            heapq.heappush(lengths, -(middle + 2))

        m -= 1

    # Return the maximum length of the sequence of unmarked colors before Miss M selects the (m+1)-th color.
    return -max(lengths)

def main():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    answer = choose_colors(n, m, a)
    print(answer)

if __name__ == '__main__':
    main()
