#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int choose_colors(int n, int m, vector<int>& a) {
    // Create a max heap to store the lengths of the sequences of unmarked colors for each color wheel.
    priority_queue<int> lengths;
    for (int ai : a) {
        lengths.push(-ai);
    }

    // Keep choosing the longest sequence of unmarked colors until Miss M has chosen all the colors she wants.
    while (m > 0) {
        // Get the length of the longest sequence of unmarked colors.
        int max_length = -lengths.top();
        lengths.pop();

        // If the length of the longest sequence is odd, choose the color in the middle.
        if (max_length % 2 == 1) {
            int middle = max_length / 2;
            lengths.push(-middle);
            lengths.push(-(middle + 1));
        }
        // Otherwise, choose one of the two middle colors.
        else {
            int middle = max_length / 2 - 1;
            lengths.push(-middle);
            lengths.push(-(middle + 1));
            lengths.push(-(middle + 2));
        }

        m -= 1;
    }

    // Return the maximum length of the sequence of unmarked colors before Miss M selects the (m+1)-th color.
    return -lengths.top();
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int answer = choose_colors(n, m, a);
    cout << answer << endl;

    return 0;
}
