function organizeTShirts(n, m, sizes, available, k, requests) {
  const sizesMap = { 'XS': 0, 'S': 1, 'M': 2, 'L': 3, 'XL': 4, '2XL': 5 };
  const sizesArr = sizes.split(' ');

  const remaining = Array.from({ length: n }, () => Array(m).fill(0));
  const needed = Array.from({ length: n }, () => Array(m).fill(0));
  const given = Array.from({ length: n }, () => Array(m).fill(0));

  for (let i = 0; i < n; i++) {
    for (let j = 0; j < m; j++) {
      remaining[i][j] = available[i][j];
    }
  }

  for (let i = 0; i < k; i++) {
    const [color, size] = requests[i];
    const sizeIndex = sizesMap[size] - 1;

    if (remaining[color - 1][sizeIndex] > 0) {
      remaining[color - 1][sizeIndex]--;
      given[color - 1][sizeIndex]++;
    } else {
      let found = false;
      for (let s = sizeIndex + 1; s < m; s++) {
        if (remaining[color - 1][s] > 0) {
          remaining[color - 1][s]--;
          given[color - 1][s]++;
          needed[color - 1][sizeIndex]++;
          found = true;
          break;
        }
      }

      if (!found) {
        for (let s = 0; s < sizeIndex; s++) {
          if (remaining[color - 1][s] > 0) {
            remaining[color - 1][s]--;
            given[color - 1][s]++;
            needed[color - 1][sizeIndex]++;
            found = true;
            break;
          }
        }
      }

      if (!found) {
        for (let s = sizeIndex + 1; s < m; s++) {
          if (needed[color - 1][s] > 0) {
            needed[color - 1][s]++;
            found = true;
            break;
          }
        }
      }
    }
  }

  console.log(remaining.map(row => row.join(' ')).join('\n'));
  console.log(needed.map(row => row.join(' ')).join('\n'));
}

const inputSizes = '2 3';
const inputAvailable = [
  [1, 3, 0],
  [3, 0, 3],
];
const inputRequests = [
  [1, 'S'],
  [2, 'XL'],
  [1, 'M'],
  [2, 'XL'],
  [1, 'M'],
  [2, 'M'],
  [1, 'M'],
  [2, 'S'],
  [1, 'XL'],
];
organizeTShirts(2, 3, inputSizes, inputAvailable, 9, inputRequests);


