#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    map<string, int> sizes;
    vector<vector<int>> tshirts(n, vector<int>(m, 0));
    vector<vector<int>> requested(n, vector<int>(m, 0));

    string size_names[6] = {"XS", "S", "M", "L", "XL", "2XL"};
    for (int i = 0; i < m; ++i) {
        sizes[size_names[i]] = i;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> tshirts[i][j];
        }
    }

    int k;
    cin >> k;

    while (k--) {
        int c;
        string s;
        cin >> c >> s;

        requested[c - 1][sizes[s]]++;
    }

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < m; ++j) {
            if (requested[i][j] > 0) {
                if (tshirts[i][j] >= requested[i][j]) {
                    tshirts[i][j] -= requested[i][j];
                    requested[i][j] = 0;
                } else {
                    requested[i][j] -= tshirts[i][j];
                    tshirts[i][j] = 0;
                }
            }
        }
    }

    for (const auto& row : tshirts) {
        for (const auto& val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    for (const auto& row : requested) {
        for (const auto& val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    return 0;
}
