#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m));
    vector<vector<int>> to_order(n, vector<int>(m));

    for (int i = 0; i < k; ++i) {
        int color_index;
        char size;
        cin >> color_index >> size;

        int size_index = find(sizes.begin(), sizes.end(), string(1, size)) - sizes.begin();

        bool found = false;

        for (int s = size_index; s < m; ++s) {
            if (available[color_index - 1][s] > 0) {
                available[color_index - 1][s]--;
                found = true;
                break;
            }
        }

        if (!found) {
            for (int s = size_index + 1; s < m; ++s) {
                if (remaining[color_index - 1][s] > 0) {
                    to_order[color_index - 1][s]++;
                    remaining[color_index - 1][s]--;
                    found = true;
                    break;
                }
            }
        }

        if (!found) {
            for (int s = size_index; s < m; ++s) {
                if (available[color_index - 1][s] == 0) {
                    to_order[color_index - 1][s]++;
                    break;
                }
            }
        }
    }

    for (const auto& row : available) {
        for (int val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    for (const auto& row : to_order) {
        for (int val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    return 0;
}
