#include <iostream>
#include <vector>

std::vector<std::vector<char>> createOrnament(int n, int m) {
    int index = 0;
    int reverse = 0;
    std::vector<std::vector<char>> ornament(n, std::vector<char>(m, '.'));

    for (int i = 0; i < n; ++i) {
        if (reverse == 0) {
            index += 1;
        } else {
            index -= 1;
        }

        if (index == m / 2 + 1 && m % 2 != 0) {
            ornament[i][index - 1] = 'x';
        } else if (index != m / 2 + 1) {
            ornament[i][index - 1] = 'x';
            ornament[i][m - index] = 'x';
        } else {
            ornament[i][index - 1] = 'x';
            ornament[i][m - index] = 'x';
            reverse = 1;
            index = m / 2;
            continue;
        }

        if (index > m / 2) {
            reverse = 1;
        }

        if (index == 1) {
            reverse = 0;
        }
    }

    return ornament;
}

void printOrnament(const std::vector<std::vector<char>>& ornament) {
    for (const auto& row : ornament) {
        for (char ch : row) {
            std::cout << ch;
        }
        std::cout << std::endl;
    }
}

int main() {
    int n, m;
    std::cin >> n >> m;

    auto ornament = createOrnament(n, m);
    printOrnament(ornament);

    return 0;
}
