def process_requests(n, m, sizes, t_shirts, k, requests):
    remaining_t_shirts = [[t_shirts[i][j] for j in range(m)] for i in range(n)]
    needed_t_shirts = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = requests[i]
        color -= 1  # Adjusting color index to 0-based

        found = False

        # Check if the requested size is available in the specified color
        if remaining_t_shirts[color][sizes.index(size)] > 0:
            remaining_t_shirts[color][sizes.index(size)] -= 1
            found = True

        # If not, look for T-shirts of the same size but different color
        elif any(remaining_t_shirts[j][sizes.index(size)] > 0 for j in range(n)):
            for j in range(n):
                if remaining_t_shirts[j][sizes.index(size)] > 0:
                    remaining_t_shirts[j][sizes.index(size)] -= 1
                    found = True
                    break

        # If still not found, look for T-shirts of larger sizes
        else:
            size_index = sizes.index(size)
            for j in range(size_index + 1, m):
                for i in range(n):
                    if remaining_t_shirts[i][j] > 0:
                        remaining_t_shirts[i][j] -= 1
                        found = True
                        break
                if found:
                    break

        # If no suitable T-shirts found, record it as needed
        if not found:
            needed_t_shirts[color][size_index] += 1

    return remaining_t_shirts, needed_t_shirts


def main():
    n, m = map(int, input().split())
    sizes = input().split()
    t_shirts = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    requests = [map(str, input().split()) for _ in range(k)]

    remaining, needed = process_requests(n, m, sizes, t_shirts, k, requests)

    for row in remaining:
        print(" ".join(map(str, row)))

    for row in needed:
        print(" ".join(map(str, row)))


if __name__ == "__main__":
    main()
