def get_team_composition(participants, olympiad):
    if olympiad == "IOI" or olympiad == "CEOI":
        team_size = 4
    elif olympiad == "EGOI":
        team_size = 4
        participants = [p for p in participants if p["gender"] == "female"]
    elif olympiad == "EJOI":
        team_size = 4
        participants = [p for p in participants if p["age"] <= 15]
    elif olympiad == "BaltOI":
        team_size = 6
    elif olympiad == "BalkOI":
        team_size = 4
        participants = [p for p in participants if p["grade"] < 11]
    elif olympiad == "JBOI":
        team_size = 4
        participants = [p for p in participants if p["grade"] < 11 and p["grade"] < 10]

    team = participants[:team_size]
    team_ids = [str(p["id"]) for p in team]
    return team_ids


def main():
    n = int(input())
    participants = []
    for _ in range(n):
        participant_info = input().split()
        participant = {
            "id": int(participant_info[0]),
            "gender": participant_info[1],
            "grade": int(participant_info[2]),
            "age": int(participant_info[3]),
            "score": int(participant_info[4]),
        }
        participants.append(participant)

    participants.sort(key=lambda x: x["score"], reverse=True)

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    for olympiad in olympiads:
        team_ids = get_team_composition(participants, olympiad)
        print(olympiad)
        for team_id in sorted(team_ids):
            print(team_id)


if __name__ == "__main__":
    main()
