#include <iostream>
#include <vector>
#include <algorithm>

int maxFlowers(std::vector<std::vector<int>>& flowerCounts) {
    int n = flowerCounts.size();
    int m = flowerCounts[0].size();

    // Створюємо динамічний масив для зберігання кількості квітів
    std::vector<std::vector<int>> dp(n, std::vector<int>(m, 0));

    // Ініціалізуємо базовий випадок для верхнього лівого кута
    dp[0][0] = flowerCounts[0][0];

    // Рахуємо кількість квітів для першого рядка
    for (int j = 1; j < m; j++) {
        dp[0][j] = dp[0][j - 1] + flowerCounts[0][j];
    }

    // Рахуємо кількість квітів для першого стовпчика
    for (int i = 1; i < n; i++) {
        dp[i][0] = dp[i - 1][0] + flowerCounts[i][0];
    }

    // Заповнюємо решту динамічного масиву
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < m; j++) {
            dp[i][j] = std::max(dp[i - 1][j], dp[i][j - 1]) + flowerCounts[i][j];
        }
    }

    // Повертаємо максимальну кількість квітів
    return dp[n - 1][m - 1];
}

int main() {
    // Введення розмірів клумби та кількості квітів у кожній клітинці
    int n, m;
    std::cin >> n >> m;

    std::vector<std::vector<int>> flowerCounts(n, std::vector<int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            std::cin >> flowerCounts[i][j];
        }
    }

    // Обчислюємо та виводимо максимальну кількість квітів
    std::cout << "Максимальна кількість квітів: " << maxFlowers(flowerCounts) << std::endl;

    return 0;
}