 from collections import defaultdict

def process_requests(colors, sizes, initial, winners):
    remaining = defaultdict(lambda: defaultdict(int))
    needed = defaultdict(lambda: defaultdict(int))
    
    # Distribute initial T-shirts
    for i in range(colors):
        for j in range(sizes):
            remaining[i][j] = initial[i][j]
    
    for winner in winners:
        color, size = winner
        color -= 1  # Adjust color index to 0-based
        size = sizes.index(size)  # Get the index of the size
        
        # Check if the requested T-shirt is available
        if remaining[color][size] > 0:
            remaining[color][size] -= 1
        else:
            found_alternative = False
            
            # Look for an alternative color of the same size
            for alt_color in range(colors):
                if alt_color != color and remaining[alt_color][size] > 0:
                    remaining[alt_color][size] -= 1
                    found_alternative = True
                    break
            
            if not found_alternative:
                # Look for the next larger size with priority for the requested color
                for alt_size in range(size + 1, sizes):
                    if remaining[color][alt_size] > 0:
                        remaining[color][alt_size] -= 1
                        found_alternative = True
                        break
                        
                # If no T-shirt found with the requested color, choose the minimum color
                if not found_alternative:
                    for alt_color in range(colors):
                        for alt_size in range(size + 1, sizes):
                            if remaining[alt_color][alt_size] > 0:
                                remaining[alt_color][alt_size] -= 1
                                found_alternative = True
                                break
                        if found_alternative:
                            break
            
            if not found_alternative:
                # Record the T-shirt as absent
                needed[color][size] += 1
    
    return remaining, needed

# Input
colors, sizes = map(int, input().split())
size_labels = input().split()
initial = [list(map(int, input().split())) for _ in range(colors)]
num_winners = int(input())
winners = [tuple(map(str, input().split())) for _ in range(num_winners)]

# Process requests
remaining, needed = process_requests(colors, size_labels, initial, winners)

# Output remaining T-shirts
for i in range(colors):
    print(*[remaining[i][j] for j in range(sizes)])

# Output T-shirts to be ordered
for i in range(colors):
    print(*[needed[i][j] for j in range(sizes)])
