#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    // Initialize vectors to store the number of colors and the chosen colors
    vector<int> colors(n);
    vector<int> chosenColors(n, 1); // Marking the initial color as used

    // Input the number of colors for each wheel
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    // Calculate the maximum length of the sequence of unmarked colors
    int maxUnmarkedLength = 0;
    for (int i = 0; i < n; ++i) {
        maxUnmarkedLength += colors[i] - chosenColors[i];
    }

    // Choose m more colors
    for (int step = 0; step < m; ++step) {
        // Find the longest sequence of unmarked colors
        int maxSeqLength = 0;
        int maxSeqIdx = -1;

        for (int i = 0; i < n; ++i) {
            int seqLength = 0;
            for (int j = 0; j < colors[i]; ++j) {
                if (j < chosenColors[i] || j >= chosenColors[i] + colors[i] - 1) {
                    seqLength++;
                }
            }

            if (seqLength > maxSeqLength) {
                maxSeqLength = seqLength;
                maxSeqIdx = i;
            }
        }

        // Mark the chosen color
        if (maxSeqLength % 2 == 1) {
            chosenColors[maxSeqIdx]++;
        } else {
            chosenColors[maxSeqIdx] += maxSeqLength / 2;
        }
    }

    // Output the maximum length of the sequence of unmarked colors
    cout << maxUnmarkedLength << endl;

    return 0;
}
