def find_max_length(n, m, a):
    # Step 1: Read input

    # Step 2: Calculate the initial unmarked colors
    total_unmarked = sum(a) - n

    # Step 3: Find the maximum length of the unmarked sequence
    a.sort()  # Sort the array in non-decreasing order

    # Binary search to find the maximum possible length
    left = 1
    right = total_unmarked
    max_length = 0

    while left <= right:
        mid = (left + right) // 2

        # Simulate the process of selecting colors
        count = 0
        for i in range(n):
            count += max(0, a[i] - mid)

        # Check if Miss M can select the (m+1)-th color
        if count >= m:
            max_length = mid
            left = mid + 1
        else:
            right = mid - 1

    # Step 4: Output the result
    return max_length

# Example usage
n, m = map(int, input().split())
a = list(map(int, input().split()))

result = find_max_length(n, m, a)
print(result)