#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.id < p2.id;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; i++) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::map<std::string, std::vector<int>> teams;
    for (int i = 0; i < m; i++) {
        std::string olympiad;
        std::cin >> olympiad;

        std::vector<Participant> selectedParticipants;
        if (olympiad == "IOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });
            selectedParticipants.assign(participants.begin(), participants.begin() + 4);
        } else if (olympiad == "CEOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });
            selectedParticipants.assign(participants.begin(), participants.begin() + 4);
        } else if (olympiad == "EGOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });
            for (const auto& participant : participants) {
                if (participant.gender == "female") {
                    selectedParticipants.push_back(participant);
                }
                if (selectedParticipants.size() == 4) {
                    break;
                }
            }
        } else if (olympiad == "EJOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });
            for (const auto& participant : participants) {
                if (participant.age <= 15) {
                    selectedParticipants.push_back(participant);
                }
                if (selectedParticipants.size() == 4) {
                    break;
                }
            }
        } else if (olympiad == "BaltOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });
            selectedParticipants.assign(participants.begin(), participants.begin() + 6);
        } else if (olympiad == "BalkOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });
            for (const auto& participant : participants) {
                if (participant.grade != 11) {
                    selectedParticipants.push_back(participant);
                }
                if (selectedParticipants.size() == 4) {
                    break;
                }
            }
        } else if (olympiad == "JBOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant& p1, const Participant& p2) {
                return p1.score > p2.score;
            });
            for (const auto& participant : participants) {
                if (participant.grade != 11 && participant.grade != 10) {
                    selectedParticipants.push_back(participant);
                }
                if (selectedParticipants.size() == 4) {
                    break;
                }
            }
        }

        std::sort(selectedParticipants.begin(), selectedParticipants.end(), compareParticipants);
        std::vector<int> teamIds;
        for (const auto& participant : selectedParticipants) {
            teamIds.push_back(participant.id);
        }
        teams[olympiad] = teamIds;
    }

    for (const auto& team : teams) {
        std::cout << team.first << std::endl;
        for (const auto& id : team.second) {
            std::cout << id << std::endl;
        }
    }

    return 0;
}
