from operator import itemgetter

def select_team(participants, olympiad):
    if olympiad == 'IOI':
        return sorted([p for p in participants], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'CEOI':
        return sorted([p for p in participants], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'EGOI':
        return sorted([p for p in participants if p['gender'] == 'female'], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'EJOI':
        return sorted([p for p in participants if p['age'] <= 15], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'BaltOI':
        return sorted([p for p in participants], key=itemgetter('score'), reverse=True)[:6]
    elif olympiad == 'BalkOI':
        return sorted([p for p in participants if p['grade'] != 11], key=itemgetter('score'), reverse=True)[:4]
    elif olympiad == 'JBOI':
        return sorted([p for p in participants if p['grade'] not in [10, 11]], key=itemgetter('score'), reverse=True)[:4]
    else:
        return []

num_participants = int(input())
participant_list = []
for _ in range(num_participants):
    participant_info = input().split()
    participant_list.append({'id': int(participant_info[0]), 'gender': participant_info[1], 'grade': int(participant_info[2]), 'age': int(participant_info[3]), 'score': int(participant_info[4])})

num_olympiads = int(input())
olympiad_list = [input() for _ in range(num_olympiads)]

for olympiad in olympiad_list:
    selected_team = select_team(participant_list, olympiad)
    print(olympiad)
    for participant in sorted(selected_team, key=itemgetter('id')):
        print(participant['id'])