using System;
using System.Collections.Generic;
using System.Linq;

class Program
{
    static void Main()
    {
        int n = int.Parse(Console.ReadLine());
        List<Participant> participants = new List<Participant>();

        for (int i = 0; i < n; i++)
        {
            string[] input = Console.ReadLine().Split();
            participants.Add(new Participant
            {
                Id = int.Parse(input[0]),
                Gender = input[1],
                Grade = int.Parse(input[2]),
                Age = int.Parse(input[3]),
                Score = int.Parse(input[4])
            });
        }

        int m = int.Parse(Console.ReadLine());

        List<string> olympiads = new List<string>();
        for (int i = 0; i < m; i++)
        {
            olympiads.Add(Console.ReadLine());
        }

        Dictionary<string, List<int>> teams = new Dictionary<string, List<int>>();

        foreach (var olympiad in olympiads)
        {
            List<int> teamParticipants = GetTeamParticipants(olympiad, participants);
            teamParticipants.Sort();
            teams[olympiad] = teamParticipants;
        }

        foreach (var olympiad in olympiads)
        {
            Console.WriteLine(olympiad);
            foreach (int participantId in teams[olympiad])
            {
                Console.WriteLine(participantId);
            }
        }
    }

    static List<int> GetTeamParticipants(string olympiad, List<Participant> participants)
    {
        if (olympiad == "IOI" || olympiad == "CEOI")
        {
            return participants
                .OrderByDescending(p => p.Score)
                .ThenBy(p => p.Id)
                .Take(4)
                .Select(p => p.Id)
                .ToList();
        }
        else if (olympiad == "EGOI")
        {
            return participants
                .Where(p => p.Gender == "female")
                .OrderByDescending(p => p.Score)
                .ThenBy(p => p.Id)
                .Take(4)
                .Select(p => p.Id)
                .ToList();
        }
        else if (olympiad == "EJOI")
        {
            return participants
                .Where(p => p.Age <= 15)
                .OrderByDescending(p => p.Score)
                .ThenBy(p => p.Id)
                .Take(4)
                .Select(p => p.Id)
                .ToList();
        }
        else if (olympiad == "BaltOI")
        {
            return participants
                .OrderByDescending(p => p.Score)
                .ThenBy(p => p.Id)
                .Take(6)
                .Select(p => p.Id)
                .ToList();
        }
        else if (olympiad == "BalkOI")
        {
            return participants
                .Where(p => p.Grade != 11)
                .OrderByDescending(p => p.Score)
                .ThenBy(p => p.Id)
                .Take(4)
                .Select(p => p.Id)
                .ToList();
        }
        else if (olympiad == "JBOI")
        {
            return participants
                .Where(p => p.Grade != 11 && p.Grade != 10)
                .OrderByDescending(p => p.Score)
                .ThenBy(p => p.Id)
                .Take(4)
                .Select(p => p.Id)
                .ToList();
        }

        return new List<int>();
    }
}

class Participant
{
    public int Id { get; set; }
    public string Gender { get; set; }
    public int Grade { get; set; }
    public int Age { get; set; }
    public int Score { get; set; }
}




