using System;
using System.Linq;

class Program
{
    static void Main()
    {
        // Зчитування вхідних даних
        int[] nm = Console.ReadLine().Split().Select(int.Parse).ToArray();
        int n = nm[0];
        long m = nm[1];

        long[] colors = Console.ReadLine().Split().Select(long.Parse).ToArray();

        // Бінарний пошук
        long left = 1;
        long right = colors.Max();

        while (left < right)
        {
            long mid = (left + right + 1) / 2;

            if (Check(colors, n, m, mid))
                left = mid;
            else
                right = mid - 1;
        }

        // Виведення результату
        Console.WriteLine(left);
    }

    // Функція для перевірки, чи можна отримати підвідрізок довжиною mid
    static bool Check(long[] colors, int n, long m, long mid)
    {
        long segments = 0;

        for (int i = 0; i < n; i++)
        {
            segments += (colors[i] - 1) / mid;

            // Якщо кількість вибраних кольорів перевищує m, повертаємо false
            if (segments > m)
                return false;
        }

        // Якщо кількість вибраних кольорів не менша за m, повертаємо true
        return segments >= m;
    }
}
