using System;
using System.Linq;

class Program
{
    static void Main()
    {
        // Зчитування вхідних даних
        int[] nm = Console.ReadLine().Split().Select(int.Parse).ToArray();
        int n = nm[0];
        long m = nm[1];

        long[] colors = Console.ReadLine().Split().Select(long.Parse).ToArray();

        // Знаходимо максимальну довжину підпослідовності
        long maxSubsequenceLength = MaxSubsequenceLength(colors, n, m);

        // Виведення результату
        Console.WriteLine(maxSubsequenceLength);
    }

    // Функція для знаходження максимальної довжини підпослідовності
    static long MaxSubsequenceLength(long[] colors, int n, long m)
    {
        long maxSubsequenceLength = 0;
        long currentSubsequenceLength = 0;

        for (int i = 0; i < n; i++)
        {
            // Якщо поточний колір є незакресленим, збільшуємо довжину підпослідовності
            if (colors[i] <= m)
            {
                currentSubsequenceLength++;
            }
            else
            {
                // Якщо поточний колір є закресленим, оновлюємо максимальну довжину та обнуляємо поточну
                maxSubsequenceLength = Math.Max(maxSubsequenceLength, currentSubsequenceLength);
                currentSubsequenceLength = 0;
            }
        }

        // Перевіряємо останню підпослідовність після останнього закресленого колору
        maxSubsequenceLength = Math.Max(maxSubsequenceLength, currentSubsequenceLength);

        return maxSubsequenceLength;
    }
}
