using System;
using System.Linq;

class Program
{
    static void Main()
    {
        // Зчитуємо вхідні дані
        string[] input1 = Console.ReadLine().Split();
        int n = int.Parse(input1[0]);
        long m = long.Parse(input1[1]);

        int[] a = Console.ReadLine().Split().Select(int.Parse).ToArray();

        // Викликаємо функцію та виводимо результат
        long result = ChooseColors(n, m, a);
        Console.WriteLine(result);
    }

    static long ChooseColors(int n, long m, int[] a)
    {
        // Ініціалізуємо список для зберігання кольорів
        int[] colors = new int[n];

        // Знаходимо максимальний неперервний підвідрізок
        long maxSubarray = 0;
        long currentSubarray = 0;
        for (int i = 0; i < n; i++)
        {
            currentSubarray += a[i];
            if (currentSubarray < 0)
            {
                currentSubarray = 0;
            }
            maxSubarray = Math.Max(maxSubarray, currentSubarray);
        }

        // Додаємо максимальний підвідрізок до загальної кількості кольорів
        long totalColors = maxSubarray * m;

        // Додаємо залишкові кольори, якщо m менше, ніж кількість кольорів у підвідрізку
        if (m < maxSubarray)
        {
            totalColors -= (maxSubarray - m);
        }

        return totalColors;
    }
}
