using System;
using System.Linq;

class Program
{
    static void Main()
    {
        var nm = Console.ReadLine().Split().Select(int.Parse).ToArray();
        var n = nm[0];
        var m = nm[1];

        var sizes = Console.ReadLine().Split();
        var sizeToIndex = sizes.Select((s, i) => (s, i)).ToDictionary(x => x.s, x => x.i);

        var tshirts = new int[n, m];
        for (var i = 0; i < n; i++)
        {
            var line = Console.ReadLine().Split().Select(int.Parse).ToArray();
            for (var j = 0; j < m; j++)
            {
                tshirts[i, j] = line[j];
            }
        }

        var k = int.Parse(Console.ReadLine());
        var requests = new (int, string)[k];
        for (var i = 0; i < k; i++)
        {
            var line = Console.ReadLine().Split();
            requests[i] = (int.Parse(line[0]) - 1, line[1]);
        }

        var remaining = (int[,])tshirts.Clone();
        var needed = new int[n, m];

        foreach (var (color, size) in requests)
        {
            var sizeIndex = sizeToIndex[size];
            if (remaining[color, sizeIndex] > 0)
            {
                remaining[color, sizeIndex]--;
                continue;
            }

            for (var i = sizeIndex; i < m; i++)
            {
                if (remaining[color, i] > 0)
                {
                    remaining[color, i]--;
                    goto nextRequest;
                }
            }

            for (var i = sizeIndex + 1; i < m; i++)
            {
                for (var j = 0; j < n; j++)
                {
                    if (remaining[j, i] > 0)
                    {
                        remaining[j, i]--;
                        goto nextRequest;
                    }
                }
            }

            needed[color, sizeIndex]++;

            nextRequest:
            continue;
        }

        for (var i = 0; i < n; i++)
        {
            Console.WriteLine(string.Join(" ", Enumerable.Range(0, m).Select(j => remaining[i, j])));
        }

        for (var i = 0; i < n; i++)
        {
            Console.WriteLine(string.Join(" ", Enumerable.Range(0, m).Select(j => needed[i, j])));
        }
    }
}
