using System;
using System.Linq;
using System.Collections.Generic;

class Program
{
    static void Main()
    {
        int n = int.Parse(Console.ReadLine());
        var participants = new List<(int id, string gender, int grade, int age, int score)>();
        for (int i = 0; i < n; i++)
        {
            var parts = Console.ReadLine().Split();
            int id = int.Parse(parts[0]);
            string gender = parts[1];
            int grade = int.Parse(parts[2]);
            int age = int.Parse(parts[3]);
            int score = int.Parse(parts[4]);
            participants.Add((id, gender, grade, age, score));
        }

        int m = int.Parse(Console.ReadLine());
        var olympiads = new List<string>();
        for (int i = 0; i < m; i++)
        {
            olympiads.Add(Console.ReadLine());
        }

        var sortedParticipants = participants.OrderByDescending(p => p.score).ThenBy(p => p.id).ToList();

        foreach (var olympiad in olympiads)
        {
            Console.WriteLine(olympiad);
            var selectedParticipants = new List<int>();
            switch (olympiad)
            {
                case "IOI":
                case "CEOI":
                    selectedParticipants = sortedParticipants.Take(4).Select(p => p.id).ToList();
                    break;
                case "EGOI":
                    selectedParticipants = sortedParticipants.Where(p => p.gender == "female").Take(4).Select(p => p.id).ToList();
                    break;
                case "EJOI":
                    selectedParticipants = sortedParticipants.Where(p => p.age <= 15).Take(4).Select(p => p.id).ToList();
                    break;
                case "BaltOI":
                    selectedParticipants = sortedParticipants.Take(6).Select(p => p.id).ToList();
                    break;
                case "BalkOI":
                    selectedParticipants = sortedParticipants.Where(p => p.grade != 11).Take(4).Select(p => p.id).ToList();
                    break;
                case "JBOI":
                    selectedParticipants = sortedParticipants.Where(p => p.grade != 10 && p.grade != 11).Take(4).Select(p => p.id).ToList();
                    break;
            }
            foreach (var id in selectedParticipants.OrderBy(id => id))
            {
                Console.WriteLine(id);
            }
        }
    }
}
