#include <iostream>
#include <vector>
#include <algorithm>

bool isPossible(std::vector<long long>& colors, int length, int m) {
    int n = colors.size();
    long long current = 0;
    int count = 0;

    for (int i = 0; i < n; ++i) {
        if (colors[i] <= current) {
            ++count;
        } else {
            count = 0;
        }
        if (count >= length) {
            ++m;
            count = 0;
        }
    }
    return m > 0;
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<long long> colors(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> colors[i];
    }

    long long left = 0, right = 1e18;
    long long result = 0;

    while (left <= right) {
        long long mid = left + (right - left) / 2;
        if (isPossible(colors, mid, m)) {
            result = mid;
            left = mid + 1;
        } else {
            right = mid - 1;
        }
    }

    std::cout << result << std::endl;

    return 0;
}
