import heapq

def max_unmarked_colors(n, m, wheels):
    max_length = 0
    heap = []

    for wheel in wheels:
        wheel.sort()
        wheel.reverse()
        max_length = max(max_length, len(wheel))
        if len(wheel) % 2 == 0:
            heapq.heappush(heap, (-len(wheel)//2, wheel))
        else:
            heapq.heappush(heap, (-(len(wheel)//2 + 1), wheel))

    for _ in range(m):
        length, wheel = heapq.heappop(heap)
        length = -length
        if length > 1:
            new_length = length // 2
            if length % 2 == 0:
                heapq.heappush(heap, (-new_length, wheel[:new_length]))
                heapq.heappush(heap, (-new_length, wheel[new_length:]))
            else:
                heapq.heappush(heap, (-(new_length + 1), wheel[:new_length]))
                heapq.heappush(heap, (-new_length, wheel[new_length+1:]))
        max_length = max(max_length, length)
    
    return max_length

# Reading input
n, m = map(int, input().split())
wheels = []
for _ in range(n):
    wheel = list(map(int, input().split()))
    wheels.append(wheel)

result = max_unmarked_colors(n, m, wheels)
print(result)
