def is_eligible(participant, olympiad):
    if olympiad in ['IOI', 'CEOI', 'BaltOI']:
        return True
    elif olympiad == 'EGOI':
        return participant[1] == 'female'
    elif olympiad == 'EJOI':
        return participant[3] <= 15
    elif olympiad == 'BalkOI':
        return participant[2] != 11
    elif olympiad == 'JBOI':
        return participant[2] not in {10, 11}

def create_teams(participants, olympiad, team_size):
    participants.sort(key=lambda x: (-x[4], x[0]))

    teams = [p[0] for p in participants if is_eligible(p, olympiad)][:team_size]

    return teams

n = int(input())
participants = [list(map(lambda x: int(x) if x.isdigit() else x, input().split())) for _ in range(n)]

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    teams = create_teams(participants, olympiad, 4)
    print(f"{olympiad}\n{' '.join(map(str, sorted(teams)))}")