using System;
using System.Collections.Generic;
using System.Linq;

class Program
{
    static void Main()
    {
       
        int n = int.Parse(Console.ReadLine());

       
        List<Participant> participants = new List<Participant>();

        
        for (int i = 0; i < n; i++)
        {
            string[] input = Console.ReadLine().Split();
            int id = int.Parse(input[0]);
            string gender = input[1];
            int grade = int.Parse(input[2]);
            int age = int.Parse(input[3]);
            int score = int.Parse(input[4]);

            participants.Add(new Participant(id, gender, grade, age, score));
        }

        int m = int.Parse(Console.ReadLine());

        
        Dictionary<string, List<int>> olympiadParticipants = new Dictionary<string, List<int>>();

       
        for (int i = 0; i < m; i++)
        {
            string olympiad = Console.ReadLine();
            List<int> qualifiedParticipants = GetQualifiedParticipants(participants, olympiad);
            olympiadParticipants.Add(olympiad, qualifiedParticipants);
        }

      
        foreach (var kvp in olympiadParticipants)
        {
            Console.WriteLine(kvp.Key);
            foreach (var id in kvp.Value)
            {
                Console.WriteLine(id);
            }
        }
    }

    
    static List<int> GetQualifiedParticipants(List<Participant> participants, string olympiad)
    {
        List<int> qualifiedParticipants = new List<int>();

        switch (olympiad)
        {
            case "IOI":
            case "CEOI":
                qualifiedParticipants = participants
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "EGOI":
                qualifiedParticipants = participants
                    .Where(p => p.Gender == "female")
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "EJOI":
                qualifiedParticipants = participants
                    .Where(p => p.Age <= 15)
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "BaltOI":
            case "JBOI":
                qualifiedParticipants = participants
                    .OrderByDescending(p => p.Score)
                    .Take(6)
                    .Select(p => p.Id)
                    .ToList();
                break;

            case "BalkOI":
                qualifiedParticipants = participants
                    .Where(p => p.Grade != 11)
                    .OrderByDescending(p => p.Score)
                    .Take(4)
                    .Select(p => p.Id)
                    .ToList();
                break;
        }

        return qualifiedParticipants;
    }
}

class Participant
{
    public int Id { get; }
    public string Gender { get; }
    public int Grade { get; }
    public int Age { get; }
    public int Score { get; }

    public Participant(int id, string gender, int grade, int age, int score)
    {
        Id = id;
        Gender = gender;
        Grade = grade;
        Age = age;
        Score = score;
    }
}