def max_subsequence_length(colors, m):
    n = len(colors)
    left, right = 1, sum(colors)

    def can_use_middle(mid):
        count = 0
        for a in colors:
            count += min(a, mid)
        return count >= m

    result = 0
    while left <= right:
        mid = (left + right) // 2
        if can_use_middle(mid):
            result = mid
            right = mid - 1
        else:
            left = mid + 1

    return result

def main():
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    max_length = max_subsequence_length(colors, m)
    print(max_length)

if __name__ == "__main__":
    main()