def max_subsequence_length(colors, m):
    n = len(colors)
    prefix_sum = [0] * (n + 1)

    for i in range(n):
        prefix_sum[i + 1] = prefix_sum[i] + colors[i]

    result = 0
    for i in range(1, n + 1):
        for j in range(i, n + 1):
            current_sum = prefix_sum[j] - prefix_sum[i - 1]
            if current_sum <= m and (j - i + 1) % 2 == 1:
                result = max(result, j - i + 1)

    return result

def main():
    n, m = map(int, input().split())
    colors = list(map(int, input().split()))

    max_length = max_subsequence_length(colors, m)
    print(max_length)

if __name__ == "__main__":
    main()