def process_gifts(n, m, sizes, quantities, winners):
    remaining_shirts = [[quantities[i][j] for j in range(m)] for i in range(n)]
    ordered_shirts = [[0 for j in range(m)] for i in range(n)]

    for winner in winners:
        color_index, size = winner
        size_index = sizes.index(size)

        if remaining_shirts[color_index - 1][size_index] > 0:
            remaining_shirts[color_index - 1][size_index] -= 1
        else:
            alt_color = min(
                [(i, remaining_shirts[i][size_index]) for i in range(n) if i != color_index - 1 and remaining_shirts[i][size_index] > 0],
                key=lambda x: x[0]
            )[0]
            remaining_shirts[alt_color][size_index] -= 1
            ordered_shirts[alt_color][size_index] += 1

    return remaining_shirts, ordered_shirts


def print_table(table):
    for row in table:
        print(" ".join(map(str, row)))

n, m = map(int, input().split())
sizes = input().split()
quantities = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(input().split()) for _ in range(k)]

remaining_shirts, ordered_shirts = process_gifts(n, m, sizes, quantities, winners)

print_table(remaining_shirts)
print_table(ordered_shirts)