from collections import defaultdict

# Функція для визначення складу команд для кожної олімпіади
def determine_teams(participants, olympiads):
    teams = defaultdict(list)

    # Сортуємо учасників за балами у зворотньому порядку
    sorted_participants = sorted(participants, key=lambda x: x[4], reverse=True)

    # Визначаємо команди для кожної олімпіади
    for olympiad in olympiads:
        if olympiad == 'IOI':
            teams[olympiad] = sorted_participants[:4]
        elif olympiad == 'CEOI':
            teams[olympiad] = sorted_participants[:4]
        elif olympiad == 'EGOI':
            female_participants = [p for p in sorted_participants if p[1] == 'female']
            teams[olympiad] = female_participants[:4]
        elif olympiad == 'EJOI':
            junior_participants = [p for p in sorted_participants if p[3] <= 15]
            teams[olympiad] = junior_participants[:4]
        elif olympiad == 'BaltOI':
            teams[olympiad] = sorted_participants[:6]
        elif olympiad == 'BalkOI':
            non_11th_graders = [p for p in sorted_participants if p[2] != 11]
            teams[olympiad] = non_11th_graders[:4]
        elif olympiad == 'JBOI':
            non_10_11_graders = [p for p in sorted_participants if p[2] not in {10, 11}]
            teams[olympiad] = non_10_11_graders[:4]

    return teams

# Зчитуємо вхідні дані
n = int(input())
participants = [tuple(input().split()) for _ in range(n)]

m = int(input())
olympiads = [input() for _ in range(m)]

# Визначаємо склад команд для кожної олімпіади
teams = determine_teams(participants, olympiads)

# Виводимо результат
for olympiad in olympiads:
    print(olympiad)
    for participant in teams[olympiad]:
        print(participant[0])