# Function to calculate the maximum weight of the boxes after moving an item
def max_box_weight(weights, boxes, item_to_move, new_box):
    new_boxes = boxes.copy()
    new_boxes[item_to_move - 1] = new_box
    box_weights = [0, 0]
    for i in range(4):
        box_weights[new_boxes[i] - 1] += weights[i]
    return max(box_weights)

# Input
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Initial maximum box weight without moving any item
max_initial_weight = max(sum(weights[:2]), sum(weights[2:]))

# Check if it's optimal to not change anything
if max_initial_weight == max(weights):
    print("-1")
else:
    min_max_weight = float('inf')
    move_to_make = -1

    # Try moving each item one by one and find the move that minimizes the maximum box weight
    for i in range(1, 5):
        for j in range(1, 3):
            if boxes[i - 1] != j:
                max_weight_after_move = max_box_weight(weights, boxes, i, j)
                if max_weight_after_move < min_max_weight:
                    min_max_weight = max_weight_after_move
                    move_to_make = i

    print(move_to_make)
