def process_gifts(n, m, sizes, available, winners):
    remaining = [[available[i][j] for j in range(m)] for i in range(n)]
    needed = [[0] * m for _ in range(n)]

    for i in range(len(winners)):
        color, size = map(int, winners[i])
        size_index = sizes.index(size)

        # Check if the requested T-shirt is available
        if remaining[color - 1][size_index] > 0:
            remaining[color - 1][size_index] -= 1
        else:
            # Find a suitable replacement according to the algorithm
            found = False
            for s in range(size_index + 1, m):
                if remaining[color - 1][s] > 0:
                    remaining[color - 1][s] -= 1
                    needed[color - 1][s] += 1
                    found = True
                    break

            if not found:
                for s in range(size_index + 1, m):
                    for c in range(n):
                        if remaining[c][s] > 0:
                            remaining[c][s] -= 1
                            needed[c][s] += 1
                            found = True
                            break
                    if found:
                        break

                if not found:
                    # If no suitable replacement found, mark the T-shirt as absent
                    needed[color - 1][size_index] += 1

    return remaining, needed

# Read input
n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]

k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]

# Process gifts
remaining, needed = process_gifts(n, m, sizes, available, winners)

# Output remaining T-shirts
for row in remaining:
    print(*row)

# Output T-shirts needed to be purchased
for row in needed:
    print(*row)
