const readline = require('readline');

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout
});

function processTShirts(colors, sizes, inventory, winners) {
  // Initialize remaining inventory
  let remainingInventory = JSON.parse(JSON.stringify(inventory));
  
  // Initialize required purchases
  let requiredPurchases = Array.from(Array(colors), () => Array(sizes).fill(0));

  for (let i = 0; i < winners.length; i++) {
    const [colorIndex, sizeIndex] = winners[i];
    
    // Check if the requested T-shirt is available
    if (remainingInventory[colorIndex - 1][sizeIndex - 1] > 0) {
      // Decrease the remaining inventory
      remainingInventory[colorIndex - 1][sizeIndex - 1]--;
    } else {
      // If not available, add it to the required purchases
      requiredPurchases[colorIndex - 1][sizeIndex - 1]++;
    }
  }

  // Output remaining inventory
  for (let i = 0; i < colors; i++) {
    console.log(remainingInventory[i].join(' '));
  }

  // Output required purchases
  for (let i = 0; i < colors; i++) {
    console.log(requiredPurchases[i].join(' '));
  }
}

// Read input values
let colors, sizes;
let sizesArray, inventory;
let winnersCount, winners;

rl.question('', (nm) => {
  [colors, sizes] = nm.split(' ').map(Number);

  rl.question('', (sizesInput) => {
    sizesArray = sizesInput.split(' ');

    rl.question('', () => {
      inventory = [];
      for (let i = 0; i < colors; i++) {
        inventory.push(rl.line.trim().split(' ').map(Number));
      }

      rl.question('', (k) => {
        winnersCount = Number(k);

        winners = [];
        for (let i = 0; i < winnersCount; i++) {
          winners.push(rl.line.trim().split(' ').map(Number));
        }

        // Process T-shirts
        processTShirts(colors, sizes, inventory, winners);

        rl.close();
      });
    });
  });
});
