#include <iostream>
#include <vector>
#include <algorithm> // Add this line

using namespace std;

void processTShirts(int n, int m, vector<string>& sizesArray, vector<vector<int>>& inventory, int winnersCount, vector<pair<int, char>>& winners) {
    // Initialize remaining inventory
    vector<vector<int>> remainingInventory(n + 1, vector<int>(m + 1, 0));

    // Initialize required purchases
    vector<vector<int>> requiredPurchases(n + 1, vector<int>(m + 1, 0));

    // Process winners' requests
    for (int i = 0; i < winnersCount; i++) {
        int colorIndex = winners[i].first;
        
        // Use std::find from the algorithm header
        auto it = find(sizesArray.begin(), sizesArray.end(), string(1, winners[i].second));
        
        if (it != sizesArray.end()) {
            int sizeIndex = distance(sizesArray.begin(), it);

            // Check if the requested T-shirt is available
            if (remainingInventory[colorIndex][sizeIndex] > 0) {
                // Decrease the remaining inventory
                remainingInventory[colorIndex][sizeIndex]--;
            } else {
                // If not available, add it to the required purchases
                requiredPurchases[colorIndex][sizeIndex]++;
            }
        }
    }

    // Output remaining inventory
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << remainingInventory[i][j] << " ";
        }
        cout << endl;
    }

    // Output required purchases
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cout << requiredPurchases[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    // Rest of the code remains unchanged
}