def team_selection(n, participants, m, olympiads):
    results = {}
    for olympiad in olympiads:
        results[olympiad] = []

    for participant in sorted(participants, key=lambda x: x[4], reverse=True):
        id, gender, grade, age, score = participant
        if "IOI" in results and len(results["IOI"]) < 4:
            results["IOI"].append(id)
        if "CEOI" in results and len(results["CEOI"]) < 4:
            results["CEOI"].append(id)
        if "EGOI" in results and len(results["EGOI"]) < 4 and gender == "female":
            results["EGOI"].append(id)
        if "EJOI" in results and len(results["EJOI"]) < 4 and age <= 15:
            results["EJOI"].append(id)
        if "BaltOI" in results and len(results["BaltOI"]) < 6:
            results["BaltOI"].append(id)
        if "BalkOI" in results and len(results["BalkOI"]) < 4 and grade != 11:
            results["BalkOI"].append(id)
        if "JBOI" in results and len(results["JBOI"]) < 4 and grade not in [10, 11]:
            results["JBOI"].append(id)

    team_compositions = []
    for olympiad in olympiads:
        team_compositions.append([olympiad] + sorted(results[olympiad]))

    return team_compositions


n = 10
participants = [
    (1000001, "female", 10, 16, 400),
    (1000002, "male", 10, 17, 500),
    (1000003, "male", 11, 17, 505),
    (1000004, "male", 11, 16, 405),
    (1000005, "female", 11, 17, 450),
    (1000006, "female", 10, 15, 480),
    (1000007, "male", 9, 15, 445),
    (1000008, "male", 6, 12, 350),
    (1000009, "male", 8, 13, 399),
    (1000010, "male", 10, 16, 430),
]

m = 3
olympiads = ["IOI", "EGOI", "BaltOI"]

result = team_selection(n, participants, m, olympiads)

for team in result:
    print("\n".join(map(str, team)))