
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
	int id;
	string gender;
	int grade;
	int age;
	int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
	return p1.score > p2.score;
}

int main() {
	int n;
	cin >> n;

	vector<Participant> participants(n);

	for (int i = 0; i < n; ++i) {
		cin >> participants[i].id >> participants[i].gender >> participants[i].grade
		    >> participants[i].age >> participants[i].score;
	}

	sort(participants.begin(), participants.end(), compareParticipants);

	int m;
	cin >> m;

	map<string, int> teamSize; // Кількість учасників у команді для кожної олімпіади
	teamSize["IOI"] = 4;
	teamSize["CEOI"] = 4;
	teamSize["EGOI"] = 4;
	teamSize["EJOI"] = 4;
	teamSize["BaltOI"] = 6;
	teamSize["BalkOI"] = 4;
	teamSize["JBOI"] = 4;

	for (int i = 0; i < m; ++i) {
		string olympiad;
		cin >> olympiad;

		int requiredSize = teamSize[olympiad];

		cout << olympiad << endl;

		int currentSize = 0;

		for (const auto& participant : participants) {
			if (olympiad == "EGOI" && participant.gender == "female" && currentSize < requiredSize) {
				cout << participant.id << endl;
				++currentSize;
			} else if (olympiad == "EJOI" && participant.age <= 15 && currentSize < requiredSize) {
				cout << participant.id << endl;
				++currentSize;
			} else if (olympiad == "BalkOI" && participant.grade != 11 && currentSize < requiredSize) {
				cout << participant.id << endl;
				++currentSize;
			} else if (olympiad != "EGOI" && olympiad != "EJOI" && olympiad != "BalkOI" && currentSize < requiredSize) {
				cout << participant.id << endl;
				++currentSize;
			}

			if (currentSize == requiredSize) {
				break;
			}
		}
	}

	return 0;
}