from collections import defaultdict

n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participant = {
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    }
    participants.append(participant)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

participants.sort(key=lambda x: x['score'], reverse=True)

selected_participants = defaultdict(list)

for olympiad in olympiads:
    if olympiad == 'IOI':
        selected_participants[olympiad] = [p['id'] for p in participants[:4]]
    elif olympiad == 'CEOI':
        selected_participants[olympiad] = [p['id'] for p in participants[:4]]
    elif olympiad == 'EGOI':
        selected_participants[olympiad] = [p['id'] for p in participants[:4] if p['gender'] == 'female']
    elif olympiad == 'EJOI':
        selected_participants[olympiad] = [p['id'] for p in participants[:4] if p['age'] <= 15]
    elif olympiad == 'BaltOI':
        selected_participants[olympiad] = [p['id'] for p in participants[:6]]
    elif olympiad == 'BalkOI':
        selected_participants[olympiad] = [p['id'] for p in participants[:4] if p['grade'] != 11]
    elif olympiad == 'JBOI':
        selected_participants[olympiad] = [p['id'] for p in participants[:4] if p['grade'] not in {10, 11}]

for olympiad in olympiads:
    selected_participants[olympiad].sort()

for olympiad in olympiads:
    print(olympiad)
    for participant_id in selected_participants[olympiad]:
        print(participant_id)
