def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0
    
    def is_possible(length):
        needed_colors = 0
        for wheel in a:
            needed_colors += min(wheel, length)
        return needed_colors >= m

    left, right = 1, max(a)
    result = 0

    while left <= right:
        mid = (left + right) // 2
        if is_possible(mid):
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)