def max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0
    
    a.sort(reverse=True)

    def get_remaining_colors(cut):
        return sum(max(0, wheel - cut) for wheel in a)

    left, right = 0, a[0]
    result = 0

    while left <= right:
        mid = (left + right) // 2
        remaining_colors = get_remaining_colors(mid)

        if remaining_colors >= m:
            result = mid
            left = mid + 1
        else:
            right = mid - 1

    return result

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence(n, m, a)
print(result)
