def max_unmarked_sequence(n, m, colors):
    max_sequence = 0

    def get_max_sequence(color_wheel):
        max_seq = 0
        seq = 0
        for color in color_wheel:
            if color == 0:
                seq += 1
                max_seq = max(max_seq, seq)
            else:
                seq = 0
        return max_seq

    for _ in range(m):
        longest_sequence = 0
        wheel_index = 0

        for i in range(n):
            sequence_length = get_max_sequence(colors[i])
            if sequence_length > longest_sequence:
                longest_sequence = sequence_length
                wheel_index = i

        middle_index = (longest_sequence - 1) // 2
        colors[wheel_index][middle_index] = 1
        max_sequence = max(max_sequence, longest_sequence)

    return max_sequence

# Input parsing
n, m = map(int, input().split())
colors = [list(map(int, input().split())) for _ in range(n)]

# Output the result
result = max_unmarked_sequence(n, m, colors)
print(result)


