import heapq

def max_sequence_length(n, m, a):
    total_colors = sum(a)
    max_sequence = 0

    for wheel_size in a:
        remaining_colors = wheel_size - 1
        max_sequence = max(max_sequence, remaining_colors)

    remaining_unmarked_colors = total_colors + m - n

    if remaining_unmarked_colors % 2 == 1:
        max_sequence = max(max_sequence, remaining_unmarked_colors)
    else:
        max_sequence = max(max_sequence, remaining_unmarked_colors + 1)

    return max_sequence

def optimized_max_unmarked_sequence(n, m, a):
    total_length = sum(a)
    if m >= total_length:
        return 0
    
    heap = [-x for x in a]
    heapq.heapify(heap)
    
    for _ in range(m):
        longest_seq = -heapq.heappop(heap)
        mid = longest_seq // 2
        heapq.heappush(heap, -mid)
        if longest_seq % 2 != 0:
            heapq.heappush(heap, -mid)
        else:
            heapq.heappush(heap, -mid - 1)

    return -heapq.heappop(heap)

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Calculate the results
result1 = max_sequence_length(n, m, a)
result2 = optimized_max_unmarked_sequence(n, m, a)

# Output
print(result1)
print(result2)
