# Вхідні дані
n = int(input()) # кількість учасників олімпіади
# Створюємо список, який зберігає інформацію про учасників
participants = []
for i in range(n):
    # Зчитуємо інформацію про учасника
    id, gender, grade, age, score = input().split()
    # Перетворюємо деякі дані в числовий тип
    id = int(id)
    grade = int(grade)
    age = int(age)
    score = int(score)
    # Додаємо учасника до списку
    participants.append((id, gender, grade, age, score))
# Сортуємо список учасників за спаданням балів, а при рівності балів - за зростанням id
participants.sort(key=lambda x: (-x[4], x[0]))
# Зчитуємо кількість міжнародних олімпіад
m = int(input())
# Створюємо словник, який зберігає назви олімпіад та їх критерії відбору
olympiads = {}
for i in range(m):
    # Зчитуємо назву олімпіади
    name = input()
    # Визначаємо критерії відбору в залежності від назви
    if name == "IOI" or name == "CEOI":
        # Найкращі 4 учасники за підсумками балів за всі тури відборів
        limit = 4 # ліміт учасників
        gender = None # без обмеження за статтю
        grade = None # без обмеження за класом
        age = None # без обмеження за віком
    elif name == "EGOI":
        # Найкращі 4 учасники за підсумками балів за всі тури відборів, які є дівчатами
        limit = 4 # ліміт учасників
        gender = "female" # обмеження за статтю
        grade = None # без обмеження за класом
        age = None # без обмеження за віком
    elif name == "EJOI":
        # Найкращі 4 учасники за підсумками балів за всі тури відборів, які не старші 15 років
        limit = 4 # ліміт учасників
        gender = None # без обмеження за статтю
        grade = None # без обмеження за класом
        age = 15 # обмеження за віком
    elif name == "BaltOI":
        # Найкращі 6 учасників за підсумками балів за всі тури відборів
        limit = 6 # ліміт учасників
        gender = None # без обмеження за статтю
        grade = None # без обмеження за класом
        age = None # без обмеження за віком
    elif name == "BalkOI":
        # Найкращі 4 учасники за підсумками балів за всі тури відборів, які не є 11-класниками
        limit = 4 # ліміт учасників
        gender = None # без обмеження за статтю
        grade = 11 # обмеження за класом
        age = None # без обмеження за віком
    elif name == "JBOI":
        # Найкращі 4 учасники за підсумками балів за всі тури відборів, які не є 11 чи 10-класниками
        limit = 4 # ліміт учасників
        gender = None # без обмеження за статтю
        grade = (10, 11) # обмеження за класом
        age = None # без обмеження за віком
    # Додаємо олімпіаду та її критерії до словника
    olympiads[name] = (limit, gender, grade, age)

# Обчислення
# Створюємо словник, який зберігає склад команд учасників для кожної олімпіади
teams = {}
# Проходимо по всіх олімпіадах
for name in olympiads:
    # Отримуємо критерії відбору для цієї олімпіади
    limit, gender, grade, age = olympiads[name]
    # Створюємо список, який зберігає id учасників, які входять до команди
    team = []
    # Проходимо по всіх учасниках
    for id, g, gr, a, s in participants:
        # Перевіряємо, чи учасник відповідає критеріям відбору
        if (gender is None or g == gender) and (grade is None or gr != grade) and (age is None or a <= age) and (grade != (10, 11) or gr not in grade):
            # Якщо так, то додаємо його id до списку
            team.append(id)
            # Якщо ми досягли ліміту учасників, то зупиняємо цикл
            if len(team) == limit:
                break
    # Додаємо команду до словника
    teams[name] = team

# Вихідні дані
# Виводимо склад команд учасників для кожної олімпіади
for name in olympiads:
    # Виводимо назву олімпіади
    print(name, end=' - ')
    # Виводимо id учасників, які входять до команди, у форматі зростання номера id учасників
    print(*sorted(teams[name]))
