
#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes_str(m);
    map<string, int> sizes;

    for (int i = 0; i < m; ++i) {
        cin >> sizes_str[i];
        sizes[sizes_str[i]] = i;
    }

    vector<vector<int>> tshirts(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> tshirts[i][j];
        }
    }

    int k;
    cin >> k;
    vector<pair<int, int>> winners;

    for (int i = 0; i < k; ++i) {
        int ci;
        string si;
        cin >> ci >> si;
        winners.push_back(make_pair(ci - 1, sizes[si]));
    }

    vector<vector<int>> available = tshirts;
    vector<vector<int>> missing(n, vector<int>(m, 0));

    for (auto& winner : winners) {
        bool found = false;
        int color = winner.first;
        int size = winner.second;

        for (int nestSize = size; nestSize < m; ++nestSize) {
            if (found) {
                break;
            }
            if (available[color][nestSize] > 0) {
                available[color][nestSize] -= 1;
                found = true;
                break;
            }
            for (int nestColor = 0; nestColor < n; ++nestColor) {
                if (available[nestColor][nestSize] > 0) {
                    available[nestColor][nestSize] -= 1;
                    found = true;
                    break;
                }
            }
        }
        if (!found) {
            missing[color][size] += 1;
        }
    }

    for (auto& row : available) {
        for (int elem : row) {
            cout << elem << " ";
        }
        cout << endl;
    }

    for (auto& row : missing) {
        for (int elem : row) {
            cout << elem << " ";
        }
        cout << endl;
    }

    return 0;
}