#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m)), to_order(n, vector<int>(m));

    while (k--) {
        int c;
        char s;
        cin >> c >> s;
        --c;

        int size_index = find(sizes.begin(), sizes.end(), string(1, s)) - sizes.begin();

        if (available[c][size_index] > 0) {
            --available[c][size_index];
        } else {
            int color_index = -1;

            for (int j = size_index - 1; j >= 0; --j) {
                if (available[c][j] > 0) {
                    color_index = j;
                    break;
                }
            }

            if (color_index == -1) {
                for (int j = size_index + 1; j < m; ++j) {
                    if (available[c][j] > 0) {
                        color_index = j;
                        break;
                    }
                }
            }

            if (color_index == -1) {
                for (int j = size_index + 1; j < m; ++j) {
                    if (available[c][j] > 0) {
                        color_index = j;
                        break;
                    }
                }
            }

            if (color_index == -1) {
                remaining[c][size_index]++;
            } else {
                --available[c][color_index];
                to_order[c][color_index]++;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << "\n";
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << "\n";
    }

    return 0;
}

