#include <iostream>
#include <vector>
#include <algorithm>

struct Tshirt {
    std::string color;
    std::string size;
    int count;

    Tshirt(const std::string& col, const std::string& siz, int cnt) : color(col), size(siz), count(cnt) {}
};

// Функція порівняння розмірів
bool compareSizes(const std::string& size1, const std::string& size2) {
    std::vector<std::string> sizesOrder = {"XS", "S", "M", "L", "XL", "2XL"};
    auto it1 = std::find(sizesOrder.begin(), sizesOrder.end(), size1);
    auto it2 = std::find(sizesOrder.begin(), sizesOrder.end(), size2);
    return it1 < it2;
}

// Функція обробки запиту переможця
void processWinner(std::vector<Tshirt>& stock, int ci, char si) {
    std::string size(1, si);

    for (auto& tshirt : stock) {
        if (tshirt.size == size && tshirt.count > 0) {
            tshirt.count--;
            std::cout << tshirt.color << " " << tshirt.size << "\n";
            return;
        }
    }

    for (auto& tshirt : stock) {
        if (tshirt.size == size && tshirt.count == 0) {
            continue;
        }

        if (compareSizes(tshirt.size, size)) {
            tshirt.count--;
            std::cout << tshirt.color << " " << tshirt.size << "\n";
            return;
        }
    }

    std::cout << ci << " " << size << "\n";
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<Tshirt> stock;
    std::vector<std::vector<int>> tshirtCount(n, std::vector<int>(m));

    for (int i = 0; i < m; ++i) {
        std::string size;
        std::cin >> size;
        stock.emplace_back("", size, 0);
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> tshirtCount[i][j];
            stock[j].count += tshirtCount[i][j];
        }
    }

    int k;
    std::cin >> k;

    for (int i = 0; i < k; ++i) {
        int ci;
        char si;
        std::cin >> ci >> si;

        processWinner(stock, ci, si);
    }

    return 0;
}





