#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

struct Olympiad {
    std::string name;
    std::vector<int> participants;
};

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.id < p2.id;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    std::sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    std::cin >> m;

    std::map<std::string, Olympiad> olympiads;
    for (int i = 0; i < m; ++i) {
        std::string olympiadName;
        std::cin >> olympiadName;
        olympiads[olympiadName].name = olympiadName;
    }

    for (int i = 0; i < n; ++i) {
        for (auto& entry : olympiads) {
            if (entry.second.name == "IOI" && participants[i].grade >= 7 && participants[i].age <= 18) {
                entry.second.participants.push_back(participants[i].id);
            } else if (entry.second.name == "CEOI" && participants[i].grade >= 9 && participants[i].age <= 20) {
                entry.second.participants.push_back(participants[i].id);
            } else if (entry.second.name == "EGOI" && participants[i].grade >= 8 && participants[i].age <= 19) {
                entry.second.participants.push_back(participants[i].id);
            } // Add conditions for other olympiads
        }
    }

    for (const auto& entry : olympiads) {
        std::cout << entry.second.name << '\n';
        for (int id : entry.second.participants) {
            std::cout << id << ' ';
        }
        std::cout << '\n';
    }

    return 0;
}
