#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> colors(n);
    for (int i = 0; i < n; ++i) {
        cin >> colors[i];
    }

    // Find the maximum length of the unmarked subarray
    int max_unmarked_length = 0;
    int current_unmarked_length = 0;

    for (int i = 0; i < n; ++i) {
        current_unmarked_length += colors[i];

        if (current_unmarked_length > max_unmarked_length) {
            max_unmarked_length = current_unmarked_length;
        }

        // Reset the counter if the sum becomes negative
        if (current_unmarked_length < 0) {
            current_unmarked_length = 0;
        }
    }

    // Output the result
    cout << max_unmarked_length << endl;

    return 0;
}
