def solve_gifts(n, m, sizes, available, k, orders):
    remaining_gifts = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for color in range(n):
        for size in range(m):
            remaining_gifts[color][size] = available[color][size]

    for i in range(k):
        color_index, size = orders[i]
        color = int(color_index) - 1
        size_index = sizes.index(size)

        found = False

        # Check for the same color and sizes equal or larger
        for other_size in range(size_index, m):
            if remaining_gifts[color][other_size] > 0:
                remaining_gifts[color][other_size] -= 1
                found = True
                break

        # Check for the same color and sizes smaller
        if not found:
            for other_size in range(size_index):
                if remaining_gifts[color][other_size] > 0:
                    remaining_gifts[color][other_size] -= 1
                    to_order[color][other_size] += 1
                    found = True
                    break

        # Check for other colors
        if not found:
            for other_color in range(n):
                for other_size in range(m):
                    if remaining_gifts[other_color][other_size] > 0:
                        remaining_gifts[other_color][other_size] -= 1
                        to_order[other_color][other_size] += 1
                        found = True
                        break
                if found:
                    break

    return remaining_gifts, to_order


n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
orders = [input().split() for _ in range(k)]

remaining, to_order = solve_gifts(n, m, sizes, available, k, orders)

for row in remaining:
    print(" ".join(map(str, row)))

for row in to_order:
    print(" ".join(map(str, row)))
