def determine_team(participants, olympiad):
    if olympiad == 'IOI' or olympiad == 'CEOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(4, len(participants))]
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p[1] == 'female']
        return sorted(female_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(female_participants))]
    elif olympiad == 'EJOI':
        young_participants = [p for p in participants if p[3] <= 15]
        return sorted(young_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(young_participants))]
    elif olympiad == 'BaltOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(6, len(participants))]
    elif olympiad == 'BalkOI':
        not_11th_grade = [p for p in participants if p[2] != 11]
        return sorted(not_11th_grade, key=lambda x: (-x[4], x[0]))[:min(4, len(not_11th_grade))]
    elif olympiad == 'JBOI':
        not_11th_10th_grade = [p for p in participants if p[2] not in [11, 10]]
        return sorted(not_11th_10th_grade, key=lambda x: (-x[4], x[0]))[:min(4, len(not_11th_10th_grade))]
    else:
        return []

n = int(input())
participants = []
for _ in range(n):
    data = input().split()
    participant_id = int(data[0])
    gender = data[1]
    grade = int(data[2])
    age = int(data[3])
    score = int(data[4])
    participants.append((participant_id, gender, grade, age, score))

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    team = determine_team(participants, olympiad)
    print(olympiad)
    for member in team:
        print(member[0])
