#include <iostream>
#include <vector>

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Input weights
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    // Input box numbers
    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Initial weights of the boxes
    int weight_box1 = weights[boxes[0] - 1] + weights[boxes[1] - 1];
    int weight_box2 = weights[boxes[2] - 1] + weights[boxes[3] - 1];

    // Check if swapping a single item improves the balance
    for (int i = 0; i < 4; ++i) {
        int current_box = (i < 2) ? 0 : 1; // Determine current box
        int other_box = 1 - current_box;    // Determine the other box

        int new_weight_box1 = weight_box1 + weights[i];
        int new_weight_box2 = weight_box2 - weights[i];

        // Check if the new weights are better
        if (std::min(new_weight_box1, new_weight_box2) > std::max(weight_box1, weight_box2)) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }

    // If no improvement is found
    std::cout << "-1" << std::endl;

    return 0;
}
