# Функція для знаходження оптимального переміщення
def optimal_move(weights, boxes):
    total_weight = sum(weights)
    box_weights = [0, 0]

    for i in range(4):
        box_weights[boxes[i] - 1] += weights[i]

    max_box_weight = max(box_weights)
    min_box_weight = min(box_weights)

    for i in range(4):
        # Спробуємо перемістити річ i в іншу коробку
        new_box = 3 - boxes[i]  # Інша коробка
        new_box_weight = box_weights[new_box] + weights[i]
        old_box_weight = box_weights[boxes[i] - 1] - weights[i]

        # Перевіримо, чи оптимально перемістити річ i
        if max(new_box_weight, min_box_weight + weights[i]) < max_box_weight or \
           min(new_box_weight, max_box_weight - weights[i]) > min_box_weight:
            return i + 1  # Номер речі, яку потрібно перемістити

    return -1  # Немає оптимального переміщення

# Ввід даних
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Знаходимо оптимальне переміщення
result = optimal_move(weights, boxes)

# Вивід результату
print(result)
