#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Gift {
    int color;
    int size;
    bool received;

    Gift(int c, int s) : color(c), size(s), received(false) {}
};

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> quantities(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> quantities[i][j];
        }
    }

    int k;
    cin >> k;

    vector<Gift> gifts;
    for (int i = 0; i < k; ++i) {
        int color;
        string size;
        cin >> color >> size;
        gifts.emplace_back(color - 1, distance(sizes.begin(), find(sizes.begin(), sizes.end(), size)));
    }

    vector<vector<int>> remaining_quantities = quantities;

    for (auto& gift : gifts) {
        if (remaining_quantities[gift.color][gift.size] > 0) {
            remaining_quantities[gift.color][gift.size]--;
            gift.received = true;
        } else {
            for (int i = 0; i < m; ++i) {
                if (remaining_quantities[gift.color][i] > 0) {
                    remaining_quantities[gift.color][i]--;
                    break;
                }
            }
        }
    }

    vector<vector<int>> additional_orders(n, vector<int>(m, 0));

    for (auto& gift : gifts) {
        if (!gift.received) {
            for (int i = gift.size + 1; i < m; ++i) {
                if (remaining_quantities[gift.color][i] > 0) {
                    remaining_quantities[gift.color][i]--;
                    additional_orders[gift.color][i]++;
                    break;
                }
            }

            if (!additional_orders[gift.color][gift.size]) {
                for (int i = gift.size - 1; i >= 0; --i) {
                    if (remaining_quantities[gift.color][i] > 0) {
                        remaining_quantities[gift.color][i]--;
                        additional_orders[gift.color][i]++;
                        break;
                    }
                }
            }
        }
    }

    for (const auto& row : remaining_quantities) {
        for (int val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    for (const auto& row : additional_orders) {
        for (int val : row) {
            cout << val << " ";
        }
        cout << endl;
    }

    return 0;
}
