#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>

using namespace std;

int findItemToMove(const vector<int> &weights, const vector<int> &boxes) {
    int totalWeight = 0;
    for (int w : weights) {
        totalWeight += w;
    }

    int minMaxWeight = INT_MAX;
    int itemToMove = -1;

    // Перевірка кожної речі
    for (int i = 0; i < weights.size(); i++) {
        int box1Weight = 0, box2Weight = 0;

        // Розрахунок ваги кожної коробки, якщо поточну річ i перемістити
        for (int j = 0; j < weights.size(); j++) {
            if (i != j) {
                if (boxes[j] == 1) {
                    box1Weight += weights[j];
                } else {
                    box2Weight += weights[j];
                }
            }
        }

        // Додавання ваги поточної речі до протилежної коробки
        if (boxes[i] == 1) {
            box2Weight += weights[i];
        } else {
            box1Weight += weights[i];
        }

        int currentMaxWeight = max(box1Weight, box2Weight);
        if (currentMaxWeight < minMaxWeight) {
            minMaxWeight = currentMaxWeight;
            itemToMove = i;
        }
    }

    return itemToMove;
}

int main() {
    vector<int> weights(4), boxes(4);
    for (int i = 0; i < 4; i++) {
        cin >> weights[i];
    }
    for (int i = 0; i < 4; i++) {
        cin >> boxes[i];
    }

    int item = findItemToMove(weights, boxes);
    if (item != -1) {
        cout<< item + 1;
    } else {
        cout << "-1" << endl;
    }

    return 0;
}