#include <iostream>
#include <vector>

using namespace std;
void chooseShirt(int n, int m, vector<vector<int>>& shirts, vector<vector<int>>& missing, int desiredColor, int desiredSize) {
    
    if (shirts[desiredColor][desiredSize] > 0) {
        shirts[desiredColor][desiredSize]--;
        return;
    }

    for (int color = 0; color < n; ++color) {
        if (shirts[color][desiredSize] > 0) {
            shirts[color][desiredSize]--;
            return;
        }
    }

    
    for (int size = desiredSize + 1; size < m; ++size) {
        if (shirts[desiredColor][size] > 0) {
            shirts[desiredColor][size]--;
            return;
        }
        for (int color = 0; color < n; ++color) {
            if (shirts[color][size] > 0) {
                shirts[color][size]--;
                return;
            }
        }
    }

    missing[desiredColor][desiredSize]++;
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<int>> shirts(n, vector<int>(m));
    vector<vector<int>> missing(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> shirts[i][j];
        }
    }

    int teams;
    cin >> teams;
    for (int i = 0; i < teams * 3; ++i) {
        int color, size;
        cin >> color >> size;
        chooseShirt(n, m, shirts, missing, color, size);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << shirts[i][j] << " ";
        }
        cout << endl;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << missing[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}