#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> needed(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        cin >> c >> s;
        --c; // To convert color number to 0-based indexing

        int sizeIndex = find(sizes.begin(), sizes.end(), string(1, s)) - sizes.begin();
        bool found = false;

        // Check available sizes of the same color
        for (int j = 0; j < m; ++j) {
            if (available[c][j] > 0) {
                --available[c][j];
                found = true;
                break;
            }
        }

        // Check sizes of other colors
        if (!found) {
            for (int j = 0; j < m; ++j) {
                if (available[c][j] == 0) {
                    int newColor = -1;
                    for (int k = 0; k < n; ++k) {
                        if (available[k][j] > 0) {
                            newColor = k;
                            break;
                        }
                    }
                    if (newColor != -1) {
                        --available[newColor][j];
                        found = true;
                        break;
                    }
                }
            }
        }

        // Check larger sizes if necessary
        while (!found) {
            ++sizeIndex;
            if (sizeIndex < m) {
                for (int j = 0; j < n; ++j) {
                    if (available[j][sizeIndex] > 0) {
                        --available[j][sizeIndex];
                        found = true;
                        break;
                    }
                }
            } else {
                break;
            }
        }

        // Update remaining and needed arrays
        if (!found) {
            remaining[c][sizeIndex]++;
            needed[c][sizeIndex]++;
        }
    }

    // Output results
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << ' ';
        }
        cout << '\n';
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << needed[i][j] << ' ';
        }
        cout << '\n';
    }

    return 0;
}
