#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    // Sizes of T-shirts
    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    // Number of T-shirts available for each color and size
    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    // T-shirt requests from winners
    vector<vector<pair<int, string>>> requests(k);
    for (int i = 0; i < k; ++i) {
        int c;
        cin >> c;

        requests[i].resize(c);
        for (int j = 0; j < c; ++j) {
            cin >> requests[i][j].first >> requests[i][j].second;
            requests[i][j].first--; // Adjusting color index to 0-based
        }
    }

    // Count remaining and missing T-shirts
    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> missing(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        for (auto& req : requests[i]) {
            int color = req.first;
            string size = req.second;

            int sizeIdx = find(sizes.begin(), sizes.end(), size) - sizes.begin();

            if (available[color][sizeIdx] > 0) {
                available[color][sizeIdx]--;
                remaining[color][sizeIdx]++;
            } else {
                int altColor = -1;
                for (int j = 0; j < n; ++j) {
                    if (available[j][sizeIdx] > 0) {
                        if (altColor == -1 || available[j][sizeIdx] < available[altColor][sizeIdx]) {
                            altColor = j;
                        }
                    }
                }

                if (altColor != -1) {
                    available[altColor][sizeIdx]--;
                    remaining[altColor][sizeIdx]++;
                } else {
                    int altSizeIdx = find(sizes.begin(), sizes.end(), size) - sizes.begin();
                    for (int s = sizeIdx + 1; s < m; ++s) {
                        if (available[color][s] > 0) {
                            altSizeIdx = s;
                            break;
                        }
                    }

                    available[color][altSizeIdx]--;
                    remaining[color][altSizeIdx]++;
                }
            }
        }
    }

    // Output remaining T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << "\n";
    }

    // Output missing T-shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            missing[i][j] = max(0, requests[k - 1][i].first == i ? 0 : 1 - remaining[i][j]);
            cout << missing[i][j] << " ";
        }
        cout << "\n";
    }

    return 0;
}
