def team_composition(participants, olympiad):
    # Sort participants based on the olympiad criteria
    if olympiad == "IOI":
        participants.sort(key=lambda x: (-x[4], x[0]))
        return participants[:min(4, len(participants))]
    elif olympiad == "CEOI":
        participants.sort(key=lambda x: (-x[4], x[0]))
        return participants[:min(4, len(participants))]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == 'female']
        female_participants.sort(key=lambda x: (-x[4], x[0]))
        return female_participants[:min(4, len(female_participants))]
    elif olympiad == "EJOI":
        participants_under_16 = [p for p in participants if p[3] <= 15]
        participants_under_16.sort(key=lambda x: (-x[4], x[0]))
        return participants_under_16[:min(4, len(participants_under_16))]
    elif olympiad == "BaltOI":
        participants.sort(key=lambda x: (-x[4], x[0]))
        return participants[:min(6, len(participants))]
    elif olympiad == "BalkOI":
        participants_not_11th_grade = [p for p in participants if p[2] != 11]
        participants_not_11th_grade.sort(key=lambda x: (-x[4], x[0]))
        return participants_not_11th_grade[:min(4, len(participants_not_11th_grade))]
    elif olympiad == "JBOI":
        participants_not_11th_10th_grade = [p for p in participants if p[2] not in {10, 11}]
        participants_not_11th_10th_grade.sort(key=lambda x: (-x[4], x[0]))
        return participants_not_11th_10th_grade[:min(4, len(participants_not_11th_10th_grade))]

# Read input data
n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participant_id = int(participant_info[0])
    gender = participant_info[1]
    grade = int(participant_info[2])
    age = int(participant_info[3])
    score = int(participant_info[4])
    participants.append((participant_id, gender, grade, age, score))

# Read the number of olympiads and the olympiad names
m = int(input())
olympiads = [input() for _ in range(m)]

# Output the team composition for each olympiad
for olympiad in olympiads:
    team = team_composition(participants, olympiad)
    print(olympiad)
    for member in team:
        print(member[0])
