#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareByScore(const Participant& a, const Participant& b) {
    return a.score > b.score;
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareByScore);

    int m;
    cin >> m;

    while (m--) {
        string olympiad;
        cin >> olympiad;

        int teamSize;

        if (olympiad == "IOI" || olympiad == "CEOI") {
            teamSize = min(4, n);
        } else if (olympiad == "EGOI") {
            teamSize = count_if(participants.begin(), participants.end(), [](const Participant& p) { return p.gender == "female"; });
            teamSize = min(4, teamSize);
        } else if (olympiad == "EJOI") {
            teamSize = count_if(participants.begin(), participants.end(), [](const Participant& p) { return p.age <= 15; });
            teamSize = min(4, teamSize);
        } else if (olympiad == "BaltOI") {
            teamSize = min(6, n);
        } else if (olympiad == "BalkOI") {
            teamSize = count_if(participants.begin(), participants.end(), [](const Participant& p) { return p.grade != 11; });
            teamSize = min(4, teamSize);
        } else if (olympiad == "JBOI") {
            teamSize = count_if(participants.begin(), participants.end(), [](const Participant& p) { return p.grade != 11 && p.grade != 10; });
            teamSize = min(4, teamSize);
        }

        cout << "Composition for " << olympiad << ":" << endl;

        for (int i = 0; i < teamSize; ++i) {
            cout << participants[i].id << " ";
        }

        cout << endl;
    }

    return 0;
}

