#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id, points, grade, age;
    string gender;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].points;
    }

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        vector<Participant> team;

        if (olympiad == "IOI" || olympiad == "CEOI") {
            partial_sort(participants.begin(), participants.begin() + 4, participants.end(), [](const Participant& a, const Participant& b) {
                return a.points > b.points;
            });
            team.assign(participants.begin(), participants.begin() + 4);
        } else if (olympiad == "EGOI") {
            auto girls = accumulate(participants.begin(), participants.end(), 0, [](int count, const Participant& p) {
                return count + (p.gender == "female");
            });
            partial_sort(participants.begin(), participants.begin() + min(4, girls), participants.end(), [](const Participant& a, const Participant& b) {
                return a.points > b.points;
            });
            team.assign(participants.begin(), participants.begin() + min(4, girls));
        } else if (olympiad == "EJOI") {
            auto under15 = count_if(participants.begin(), participants.end(), [](const Participant& p) {
                return p.age <= 15;
            });
            partial_sort(participants.begin(), participants.begin() + min(4, under15), participants.end(), [](const Participant& a, const Participant& b) {
                return a.points > b.points;
            });
            team.assign(participants.begin(), participants.begin() + min(4, under15));
        } else if (olympiad == "BaltOI") {
            partial_sort(participants.begin(), participants.begin() + 6, participants.end(), [](const Participant& a, const Participant& b) {
                return a.points > b.points;
            });
            team.assign(participants.begin(), participants.begin() + 6);
        } else if (olympiad == "BalkOI") {
            auto not11thGraders = count_if(participants.begin(), participants.end(), [](const Participant& p) {
                return p.grade != 11;
            });
            partial_sort(participants.begin(), participants.begin() + min(4, not11thGraders), participants.end(), [](const Participant& a, const Participant& b) {
                return a.points > b.points;
            });
            team.assign(participants.begin(), participants.begin() + min(4, not11thGraders));
        } else if (olympiad == "JBOI") {
            auto not11thOr10thGraders = count_if(participants.begin(), participants.end(), [](const Participant& p) {
                return p.grade != 11 && p.grade != 10;
            });
            partial_sort(participants.begin(), participants.begin() + min(4, not11thOr10thGraders), participants.end(), [](const Participant& a, const Participant& b) {
                return a.points > b.points;
            });
            team.assign(participants.begin(), participants.begin() + min(4, not11thOr10thGraders));
        }

        for (const auto& member : team) {
            cout << member.id << ' ';
        }

        cout << '\n';
    }

    return 0;
}
