#include <bits/stdc++.h>
using namespace std;

struct Participant {
    int id, grade, age, score;
    string gender;
};

bool sortByScore(const Participant &a, const Participant &b) {
    return a.score > b.score;
}

bool sortByAge(const Participant &a, const Participant &b) {
    return a.age < b.age;
}

bool sortByGrade(const Participant &a, const Participant &b) {
    return a.grade < b.grade;
}

bool sortByGenderAndScore(const Participant &a, const Participant &b) {
    if (a.gender != b.gender) {
        return a.gender == "female";
    }
    return a.score > b.score;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            sort(participants.begin(), participants.end(), sortByScore);
        } else if (olympiad == "EGOI") {
            sort(participants.begin(), participants.end(), sortByGenderAndScore);
        } else if (olympiad == "EJOI") {
            sort(participants.begin(), participants.end(), sortByAge);
        } else if (olympiad == "BalkOI") {
            sort(participants.begin(), participants.end(), sortByGrade);
        } else if (olympiad == "JBOI") {
            sort(participants.begin(), participants.end(), sortByGrade);
            participants.erase(remove_if(participants.begin(), participants.end(), [](const Participant &p) { return p.grade >= 10; }), participants.end());
        }

        int teamSize;
        if (olympiad == "IOI" || olympiad == "CEOI") {
            teamSize = 4;
        } else if (olympiad == "EGOI" || olympiad == "EJOI") {
            teamSize = 4;
        } else if (olympiad == "BaltOI") {
            teamSize = 6;
        } else if (olympiad == "BalkOI" || olympiad == "JBOI") {
            teamSize = 4;
        }

        cout << olympiad << ":\n";
        for (int j = 0; j < teamSize; ++j) {
            cout << participants[j].id << " ";
        }
        cout << "\n";
    }

    return 0;
}
