#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    // Read information about participants
    vector<int> points(n);
    vector<int> ages(n);
    vector<bool> isGirl(n);
    vector<int> grades(n);

    for (int i = 0; i < n; ++i) {
        cin >> points[i] >> isGirl[i] >> ages[i] >> grades[i];
    }

    // Function to get team members based on criteria
    auto getTeamMembers = [&](const vector<int>& criteria, int teamSize) {
        vector<int> team;
        int remainingSize = teamSize;

        for (int i : criteria) {
            if (remainingSize <= 0) break;

            if (i < n) {
                team.push_back(i);
                --remainingSize;
            }
        }

        return team;
    };

    // Determine team members for each Olympiad
    vector<int> teamIOI = getTeamMembers(points, 4);
    vector<int> teamCEOI = getTeamMembers(points, 4);
    vector<int> teamEGOI = getTeamMembers(isGirl, 4);
    vector<int> teamEJOI = getTeamMembers([&]() {
        vector<int> criteria;
        for (int i = 0; i < n; ++i) {
            if (ages[i] <= 15) {
                criteria.push_back(i);
            }
        }
        return criteria;
    }(), 4);
    vector<int> teamBaltOI = getTeamMembers(points, 6);
    vector<int> teamBalkOI = getTeamMembers([&]() {
        vector<int> criteria;
        for (int i = 0; i < n; ++i) {
            if (grades[i] != 11) {
                criteria.push_back(i);
            }
        }
        return criteria;
    }(), 4);
    vector<int> teamJBOI = getTeamMembers([&]() {
        vector<int> criteria;
        for (int i = 0; i < n; ++i) {
            if (grades[i] != 11 && grades[i] != 10) {
                criteria.push_back(i);
            }
        }
        return criteria;
    }(), 4);

    // Output team members
    cout << "IOI Team: ";
    for (int member : teamIOI) cout << member << " ";
    cout << endl;

    cout << "CEOI Team: ";
    for (int member : teamCEOI) cout << member << " ";
    cout << endl;

    cout << "EGOI Team: ";
    for (int member : teamEGOI) cout << member << " ";
    cout << endl;

    cout << "EJOI Team: ";
    for (int member : teamEJOI) cout << member << " ";
    cout << endl;

    cout << "BaltOI Team: ";
    for (int member : teamBaltOI) cout << member << " ";
    cout << endl;

    cout << "BalkOI Team: ";
    for (int member : teamBalkOI) cout << member << " ";
    cout << endl;

    cout << "JBOI Team: ";
    for (int member : teamJBOI) cout << member << " ";
    cout << endl;

    return 0;
}
