def max_uncrossed_subsegment_length(n, m, a):
    a.sort()
    prefix_sum = [0] * (n + 1)

    for i in range(1, n + 1):
        prefix_sum[i] = prefix_sum[i - 1] + a[i - 1]

    def get_length(x):
        left, right = 0, n
        while left < right:
            mid = (left + right) // 2
            if a[mid] <= x:
                left = mid + 1
            else:
                right = mid

        return left

    result = 0
    for _ in range(m):
        x = prefix_sum[-1]
        length = get_length(x)
        result = max(result, length)
        x = prefix_sum[length - 1] + (x - prefix_sum[length])
        prefix_sum.append(x)

    return result

# Read input values
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output the result
result = max_uncrossed_subsegment_length(n, m, a)
print(result)
