#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Participant
{
    long long id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2)
{
    return p1.score > p2.score || (p1.score == p2.score && p1.id < p2.id);
}

bool compareById(const Participant& p1, const Participant& p2) {
    return p1.id < p2.id;
}

int main()
{
    int n;
    cin >> n;
    vector<Participant> a(n + 1);
    int i;
    for (i = 0; i < n; i++)
        cin >> a[i].id >> a[i].gender >> a[i].grade >> a[i].age >> a[i].score;
    sort(a.begin(), a.end(), compareParticipants);
    int m;
    cin >> m;
    int j;
    for (i = 1; i <= m; i++)
    {
        string ol;
        cin >> ol;
        if (ol == "IOI" || ol == "CEOI")
        {
            cout << ol << endl;
            vector<Participant> ioi(5);
            ioi[0] = a[0];
            ioi[1] = a[1];
            ioi[2] = a[2];
            ioi[3] = a[3];
            sort(ioi.begin(), ioi.end(), compareById);
            for (j = 1; j <= 4; j++)
                if (ioi[j].id != 0) cout << ioi[j].id << endl;
            cout << endl;
        }

        if (ol == "EGOI")
        {
            cout << ol << endl;
            vector<Participant> egoi(5);
            for (j = 0; j < n; j++)
                if (a[j].gender == "female")
                    egoi.push_back(a[j]);
            sort(egoi.begin(), egoi.end(), compareById);
            for (j = 0; j <= egoi.size(); j++)
                if (egoi[j].id != 0) cout << egoi[j].id << endl;
            cout << endl;
        }
        if (ol == "EJOI")
        {
            cout << ol << endl;
            vector<Participant> ejoi(5);
            for (j = 0; j < n; j++)
                if (a[j].age <= 15)
                    ejoi.push_back(a[j]);
            sort(ejoi.begin(), ejoi.end(), compareById);
            for (j = 0; j <= ejoi.size(); j++)
                if (ejoi[j].id != 0) cout << ejoi[j].id << endl;
            cout << endl;
        }
        if (ol == "BaltOI")
        {
            cout << ol << endl;
            vector<Participant> baltoi(7);
            baltoi[0] = a[0];
            baltoi[1] = a[1];
            baltoi[2] = a[2];
            baltoi[3] = a[3];
            baltoi[4] = a[4];
            baltoi[5] = a[5];
            sort(baltoi.begin(), baltoi.end(), compareById);
            for (j = 1; j <= 6; j++)
                if (baltoi[j].id != 0) cout << baltoi[j].id << endl;
            cout << endl;
        }
        if (ol == "BalkOI")
        {
            cout << ol << endl;
            vector<Participant> balkoi(5);
            for (j = 0; j < n; j++)
                if (a[j].grade != 11)
                    balkoi.push_back(a[j]);
            sort(balkoi.begin(), balkoi.end(), compareById);
            for (j = 0; j <= balkoi.size(); j++)
                if (balkoi[j].id != 0) cout << balkoi[j].id << endl;
            cout << endl;
        }
        if (ol == "JBOI")
        {
            cout << ol << endl;
            vector<Participant> jboi(5);
            for (j = 0; j < n; j++)
                if (a[j].grade <10)
                    jboi.push_back(a[j]);
            sort(jboi.begin(), jboi.end(), compareById);
            for (j = 0; j <= jboi.size(); j++)
                if (jboi[j].id != 0) cout << jboi[j].id << endl;
            cout << endl;
        }
    }
}