#include <iostream>
#include <vector>

int findItemToMove(std::vector<int>& boxWeights) {
    int minWeightBox = 1;
    int minTotalWeight = 0;

    for (int weight : boxWeights) {
        minTotalWeight += weight;
    }

    for (int i = 2; i <= 3; ++i) {
        int totalWeight = 0;

        for (int weight : boxWeights) {
            totalWeight += weight;
        }

        if (totalWeight < minTotalWeight) {
            minWeightBox = i;
            minTotalWeight = totalWeight;
        }
    }

    return minWeightBox;
}

int findMinWeightBox(std::vector<int>& boxes, std::vector<int>& weights) {
    std::vector<int> boxWeights;

    for (size_t i = 0; i < boxes.size(); ++i) {
        if (boxes[i] == 1) {
            boxWeights.push_back(weights[i]);
        }
    }

    return findItemToMove(boxWeights);
}

int main() {
    std::vector<int> weights(5);
    std::vector<int> boxes(5);

    // Read input data
    for (int i = 1; i <= 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 1; i <= 4; ++i) {
        std::cin >> boxes[i];
    }

    // Find the item to move
    int itemToMove = findMinWeightBox(boxes, weights);

    // Output the result
    if (itemToMove != -1) {
        std::cout << itemToMove << std::endl;
    } else {
        std::cout << -1 << std::endl;
    }

    return 0;
}
