 #include <iostream>
#include <vector>

int findItemToMove(const std::vector<int>& weights, const std::vector<int>& boxes) {
    int minWeightBox = 1;
    int minTotalWeight = 0;

    for (int i = 0; i < 4; ++i) {
        minTotalWeight += (boxes[i] == 1) ? weights[i] : 0;
    }

    for (int i = 2; i <= 3; ++i) {
        int totalWeight = 0;

        for (int j = 0; j < 4; ++j) {
            totalWeight += (boxes[j] == i) ? weights[j] : 0;
        }

        if (totalWeight < minTotalWeight) {
            minWeightBox = i;
            minTotalWeight = totalWeight;
        }
    }

    return minWeightBox;
}

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    // Read input data
    for (int i = 0; i < 4; ++i) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; ++i) {
        std::cin >> boxes[i];
    }

    // Find the item to move
    int itemToMove = findItemToMove(weights, boxes);

    // Output the result
    std::cout << itemToMove << std::endl;

    return 0;
}
