#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::unordered_map<std::string, std::vector<int>> olympiadTeams;

    for (int i = 0; i < m; ++i) {
        std::string olympiadName;
        std::cin >> olympiadName;

        // Сортуємо учасників за балами у зворотньому порядку
        std::sort(participants.begin(), participants.end(), [](const Participant& a, const Participant& b) {
            return a.score > b.score;
        });

        // Визначаємо команду для кожної олімпіади
        if (olympiadName == "IOI" || olympiadName == "CEOI" || olympiadName == "EGOI" || olympiadName == "EJOI") {
            int teamSize = (olympiadName == "EGOI") ? 2 : 4;
            std::vector<int> teamIds;

            for (const auto& participant : participants) {
                if (teamIds.size() == teamSize) {
                    break;
                }

                if ((olympiadName == "EGOI" && participant.gender == "female") ||
                    (olympiadName == "EJOI" && participant.age <= 15) ||
                    (olympiadName != "EGOI" && olympiadName != "EJOI")) {
                    teamIds.push_back(participant.id);
                }
            }

            olympiadTeams[olympiadName] = teamIds;
        } else if (olympiadName == "BaltOI") {
            int teamSize = 6;
            std::vector<int> teamIds;

            for (const auto& participant : participants) {
                if (teamIds.size() == teamSize) {
                    break;
                }

                teamIds.push_back(participant.id);
            }

            olympiadTeams[olympiadName] = teamIds;
        } else if (olympiadName == "BalkOI" || olympiadName == "JBOI") {
            int teamSize = (olympiadName == "BalkOI") ? 4 : 4;
            std::vector<int> teamIds;

            for (const auto& participant : participants) {
                if (teamIds.size() == teamSize) {
                    break;
                }

                if ((olympiadName == "BalkOI" && participant.grade != 11) ||
                    (olympiadName == "JBOI" && participant.grade < 10)) {
                    teamIds.push_back(participant.id);
                }
            }

            olympiadTeams[olympiadName] = teamIds;
        }
    }

    // Виводимо результат
    for (int i = 0; i < m; ++i) {
        std::string olympiadName;
        std::cin >> olympiadName;

        std::cout << olympiadName << std::endl;

        for (int id : olympiadTeams[olympiadName]) {
            std::cout << id << " ";
        }

        std::cout << std::endl;
    }

    return 0;
}
