import java.util.Scanner;

public class MissMGifts {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Зчитування кількості різних кольорів та розмірів футболок
        int n = scanner.nextInt();
        int m = scanner.nextInt();

        // Зчитування розмірів футболок, які доставили Міс М
        String[] sizes = new String[m];
        for (int i = 0; i < m; i++) {
            sizes[i] = scanner.next();
        }

        // Зчитування кількості футболок різного кольору та розміру
        int[][] shirts = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                shirts[i][j] = scanner.nextInt();
            }
        }

        // Зчитування кількості переможців та їх побажань
        int k = scanner.nextInt();
        for (int i = 0; i < k; i++) {
            int colorIndex = scanner.nextInt() - 1;
            String size = scanner.next();

            // Обробка запиту переможця
            processWinnerRequest(shirts, colorIndex, size);

            // Виведення результатів
            printResults(shirts);
        }

        // Закриваємо Scanner
        scanner.close();
    }

    private static void processWinnerRequest(int[][] shirts, int colorIndex, String size) {
        // Пошук футболки потрібного кольору та розміру
        if (shirts[colorIndex][getIndexForSize(size)] > 0) {
            // Якщо футболка потрібного розміру та кольору залишилась, беремо її
            shirts[colorIndex][getIndexForSize(size)]--;
        } else {
            // Якщо немає футболок потрібного розміру та кольору, шукаємо інші варіанти
            boolean found = false;

            // Шукаємо футболку того ж розміру, але іншого кольору
            for (int i = 0; i < shirts.length; i++) {
                if (shirts[i][getIndexForSize(size)] > 0) {
                    shirts[i][getIndexForSize(size)]--;
                    found = true;
                    break;
                }
            }

            // Якщо не знайшли, шукаємо футболку більшого розміру
            if (!found) {
                for (int i = getIndexForSize(size) + 1; i < shirts[0].length; i++) {
                    for (int j = 0; j < shirts.length; j++) {
                        if (shirts[j][i] > 0) {
                            shirts[j][i]--;
                            found = true;
                            break;
                        }
                    }
                    if (found) break;
                }
            }

            // Якщо не знайшли, повторюємо шукати серед футболок наступного більшого розміру
            while (!found) {
                for (int i = 0; i < shirts.length; i++) {
                    if (shirts[i][getIndexForSize(size) + 1] > 0) {
                        shirts[i][getIndexForSize(size) + 1]--;
                        found = true;
                        break;
                    }
                }
            }
        }
    }

    private static int getIndexForSize(String size) {
        // Метод для визначення індексу розміру у масиві
        switch (size) {
            case "XS":
                return 0;
            case "S":
                return 1;
            case "M":
                return 2;
            case "L":
                return 3;
            case "XL":
                return 4;
            case "2XL":
                return 5;
            default:
                return -1;
        }
    }

    private static void printResults(int[][] shirts) {for (int i = 0; i < shirts.length; i++) {
            for (int j = 0; j < shirts[0].length; j++) {
                System.out.print(shirts[i][j] + " ");
            }
            System.out.println();
        }
    }
}
