import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Зчитуємо кількість кольорів та розмірів футболок
        int n = scanner.nextInt();
        int m = scanner.nextInt();

        // Зчитуємо розміри футболок, які є на складі
        String[] sizes = new String[m];
        for (int i = 0; i < m; i++) {
            sizes[i] = scanner.next();
        }

        // Зчитуємо кількість футболок кожного розміру для кожного кольору
        int[][] available = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                available[i][j] = scanner.nextInt();
            }
        }

        // Зчитуємо кількість переможців
        int k = scanner.nextInt();

        // Ініціалізуємо двовимірний масив для зберігання кількості футболок, які треба замовити
        int[][] toOrder = new int[n][m];

        // Обробляємо запити переможців
        for (int i = 0; i < k; i++) {
            // Зчитуємо номер кольору та розмір футболки, яку запросив переможець
            int color = scanner.nextInt() - 1; // зменшуємо на 1, оскільки індексація з 0
            String size = scanner.next();

            // Перевіряємо наявність футболки потрібного розміру та кольору
            boolean found = false;
            for (int j = 0; j < m; j++) {
                if (sizes[j].equals(size) && available[color][j] > 0) {
                    // Якщо є футболка потрібного розміру та кольору
                    available[color][j]--; // зменшуємо наявність футболки
                    found = true;
                    break;
                }
            }

            // Якщо немає футболки потрібного розміру та кольору
            if (!found) {
                // Шукаємо футболку потрібного розміру, але іншого кольору
                boolean foundDifferentColor = false;
                for (int j = 0; j < m; j++) {
                    if (sizes[j].equals(size)) {
                        // Якщо знайшли футболку потрібного розміру, але іншого кольору
                        // Беремо футболку з мінімальним номером кольору
                        toOrder[color][j]++;
                        foundDifferentColor = true;
                        break;
                    }
                }

                // Якщо немає футболки потрібного розміру, але іншого кольору
                if (!foundDifferentColor) {
                    // Шукаємо футболку наступного більшого розміру
                    for (int j = 0; j < m; j++) {
                        if (sizes[j].compareTo(size) > 0) {
                            // Беремо футболку з мінімальним номером кольору
                            toOrder[color][j]++;
                            break;
                        }
                    }
                }
            }
        }

        // Виводимо результати
        printTable(available);
        printTable(toOrder);
    }

    // Метод для виведення таблиці
    private static void printTable(int[][] table) {
        for (int i = 0; i < table.length; i++) {
            for (int j = 0; j < table[0].length; j++) {
                System.out.print(table[i][j] + " ");
            }
            System.out.println();
        }
    }
}

