def find_item_to_move(weights, boxes):
    # Calculate the current maximum weight
    current_max_weight = max(
        weights[i] for i in range(4) if boxes[i] == 1
    )

    # Initialize the best move with None
    best_move = None

    # Try moving each item to the other box
    for i in range(4):
        for j in range(2):
            if boxes[i] != j:
                # Move item i to box j
                new_boxes = boxes[:]
                new_boxes[i] = j

                # Calculate the new maximum weight
                new_max_weight = max(
                    weights[k] for k in range(4) if new_boxes[k] == 1
                )

                # If the new maximum weight is smaller than the current maximum weight, update the best move
                if new_max_weight < current_max_weight:
                    best_move = (i, j)
                    current_max_weight = new_max_weight

    # If there is no better move, return -1
    if best_move is None:
        return -1

    # Return the item number to move
    return best_move[0] + 1

# Get the input
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Find the item to move
item_to_move = find_item_to_move(weights, boxes)

# Print the output
print(item_to_move)