def find_item_to_move(weights, boxes):
    # Initialize the current maximum weight and the best move
    current_max_weight = float('inf')
    best_move = None

    # Try moving each item to the other box
    for item in range(4):
        for new_box in range(2):
            if boxes[item] != new_box:
                # Move item to the new box
                new_boxes = boxes[:]
                new_boxes[item] = new_box

                # Calculate the new maximum weight
                new_max_weight = max(
                    weights[k] for k in range(4) if new_boxes[k] == 1
                )

                # Update the best move if necessary
                if new_max_weight < current_max_weight:
                    current_max_weight = new_max_weight
                    best_move = (item, new_box)

    # Check if there is a best move
    if best_move is None:
        return -1

    # Return the item number to move
    return best_move[0] + 1

# Get the input
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Find the item to move
item_to_move = find_item_to_move(weights, boxes)

# Print the output
print(item_to_move)
