def full_match(data: dict, request: list) -> bool:
    """Check if there is a full match to request in shirts"""
    color = request[0]-1
    size = data["sizes"].index(request[1])

    if data["shirts"][color][size] <= 0:
        return False
    else:
        data["shirts"][color][size] -= 1
        return True


def size_match(data: dict, request: list) -> bool:
    """Check if there is a size match to request in shirts"""
    size = data["sizes"].index(request[1])

    for color in data["shirts"]:
        if color[size] > 0:
            color[size] -= 1
            return True
    
    return False


def get_inputs() -> dict:
    """Get input data, return dict"""
    color_count, size_count = list(map(int, input().split()))
    sizes = input().split()
    shirts = []
    for _ in range(color_count):
        shirt = list(map(int, input().split()))
        shirts.append(shirt)

    winner_count = int(input())
    requests = []
    for _ in range(winner_count):
        request = input().split()
        requests.append([int(request[0]), request[1]])

    data = {"sizes": sizes, "shirts": shirts, "requests": requests}
    return data


def steps12(data: dict, request: list) -> bool:
    """Go through steps 1 and 2 of algorithm"""
    if not full_match(data, request):
        if not size_match(data, request):
            return False
    return True


def steps13(data: dict, request: list) -> bool:
    """Go through steps 1, 2 and 3 of algorithm"""
    if not steps12(data, request):
        size = data["sizes"].index(request[1])
        if size == len(data["sizes"])-1:
            not_found.append(request)
            return False
        else:
            new_request = request.copy()
            new_request[1] = data["sizes"][size+1]
            if not steps13(data, new_request):
                return False
            return True


def format_order(data: dict, not_found: list) -> list:
    """Format not found list"""

    results = [[0]*len(data["sizes"]) for _ in range(len(data["shirts"]))]
    for request in not_found:
        color = request[0]-1
        size = data["sizes"].index(request[1])
        results[color][size] += 1

    return results


not_found = []
data = get_inputs()
for request in data["requests"]:
    steps13(data, request)

print("\n".join([" ".join(list(map(str, x))) for x in data["shirts"]]))
print("\n".join([" ".join(list(map(str, x))) for x in format_order(data, not_found)]))