def main():
    n, m = map(int, input().split())  # кількість різних кольорів та розмірів
    sizes = input().split()  # розміри футболок
    stock = [list(map(int, input().split())) for _ in range(n)]  # наявність футболок
    k = int(input())  # кількість переможців
    requests = [input().split() for _ in range(k)]  # запити переможців

    excess_stock = [[0] * m for _ in range(n)]  # зайві футболки
    needed_stock = [[0] * m for _ in range(n)]  # футболки для замовлення

    for c, s in requests:
        size_idx = sizes.index(s)  # індекс розміру
        color_idx = int(c) - 1  # індекс кольору

        if stock[color_idx][size_idx] > 0:  # перевірка доступності потрібної футболки
            stock[color_idx][size_idx] -= 1  # видача футболки
        else:
            found = False
            for i in range(size_idx + 1, m):  # шукати наступний більший розмір
                if stock[color_idx][i] > 0:  # перевірка доступності футболки
                    stock[color_idx][i] -= 1  # видача футболки
                    needed_stock[color_idx][i] += 1  # запис потреби у футболці цього розміру
                    found = True
                    break

            if not found:  # якщо футболки такого розміру немає, шукати інші розміри
                for i in range(color_idx + 1, n):
                    for j in range(size_idx):  # шукати розмір менший за поточний
                        if stock[i][j] > 0:  # перевірка доступності футболки
                            stock[i][j] -= 1  # видача футболки
                            needed_stock[i][j] += 1  # запис потреби у футболці цього розміру
                            found = True
                            break
                    if found:
                        break

            if not found:  # якщо футболки не знайдено
                excess_stock[color_idx][size_idx] += 1  # запис зайвої футболки

    for row in excess_stock:
        print(' '.join(map(str, row)))

    for row in needed_stock:
        print(' '.join(map(str, row)))

if __name__ == "__main__":
    main()