def longest_sequence(wheel):
    max_length = 0
    max_start = -1
    max_end = -1
    start = -1
    end = -1

    for i in range(len(wheel)):
        if wheel[i] == 0:
            if start == -1:
                start = i
            end = i
        else:
            if end - start + 1 > max_length:
                max_length = end - start + 1
                max_start = start
                max_end = end
            start = -1
            end = -1

    if start != -1 and end == -1:
        end = len(wheel) - 1
        if wheel[0] == 0:
            start = 0
            while wheel[start] == 0:
                start += 1
            start -= 1
        if end - start + 1 > max_length:
            max_length = end - start + 1
            max_start = start
            max_end = end

    return max_length, max_start, max_end

def choose_color(wheel, start, end):
    mid = (start + end) // 2
    wheel[mid] = 1
    return mid

n, m = map(int, input().split())
a = list(map(int, input().split()))

wheels = []

for i in range(n):
    wheel = [0] * (a[i] + 1)
    wheel[0] = 1
    wheels.append(wheel)

colors = []

for i in range(m):
    max_length = 0
    max_index = -1
    max_start = -1
    max_end = -1

    for j in range(n):
        length, start, end = longest_sequence(wheels[j])
        if length > max_length:
            max_length = length
            max_index = j
            max_start = start
            max_end = end

    color = choose_color(wheels[max_index], max_start, max_end)
    colors.append((color, max_index))

print(max_length)