def process_gifts(colors, sizes, inventory, orders):
    remaining_inventory = [[inventory[i][j] for j in range(len(sizes))] for i in range(len(colors))]
    additional_orders = [[0] * len(sizes) for _ in range(len(colors))]

    for order in orders:
        color, size = order[1], order[2]
        size_index = sizes.index(size)

        # Check if there's a matching size and color
        if remaining_inventory[color][size_index] > 0:
            remaining_inventory[color][size_index] -= 1
        else:
            # Find a different color with the same size
            alt_color = None
            for alt_color_index in range(len(colors)):
                if remaining_inventory[alt_color_index][size_index] > 0:
                    alt_color = alt_color_index
                    break

            if alt_color is not None:
                remaining_inventory[alt_color][size_index] -= 1
            else:
                # Find a larger size with the same color
                alt_size = None
                for alt_size_index in range(size_index + 1, len(sizes)):
                    if remaining_inventory[color][alt_size_index] > 0:
                        alt_size = alt_size_index
                        break

                if alt_size is not None:
                    remaining_inventory[color][alt_size] -= 1
                else:
                    # Find a larger size with any color
                    for alt_size_index in range(size_index + 1, len(sizes)):
                        for alt_color_index in range(len(colors)):
                            if remaining_inventory[alt_color_index][alt_size_index] > 0:
                                remaining_inventory[alt_color_index][alt_size_index] -= 1
                                break

        additional_orders[color][size_index] += 1

    return remaining_inventory, additional_orders


# Reading input
n, m = map(int, input().split())
sizes = input().split()
inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
orders = [tuple(input().split()) for _ in range(k)]

# Processing gifts
remaining_inventory, additional_orders = process_gifts(range(n), sizes, inventory, orders)

# Printing output
for i in range(n):
    print(" ".join(map(str, remaining_inventory[i])))
for i in range(n):
    print(" ".join(map(str, additional_orders[i])))
