from collections import defaultdict

def form_teams(participants, olympiads):
    teams = defaultdict(list)

    for participant in participants:
        teams[participant[2]].append(participant)

    result = []
    for olympiad in olympiads:
        team = sorted(teams[olympiad], key=lambda x: x[4], reverse=True)[:min(len(teams[olympiad]), get_team_size(olympiad))]
        result.extend((olympiad, participant[0]) for participant in sorted(team, key=lambda x: x[0]))

    return result

def get_team_size(olympiad):
    if olympiad == 'IOI' or olympiad == 'CEOI' or olympiad == 'BaltOI':
        return 4
    elif olympiad == 'EGOI':
        return 4 if len(teams['female']) >= 4 else len(teams['female'])
    elif olympiad == 'EJOI':
        return 4 if len(teams['age15']) >= 4 else len(teams['age15'])
    elif olympiad == 'BalkOI':
        return 4 if len(teams['not_grade11']) >= 4 else len(teams['not_grade11'])
    elif olympiad == 'JBOI':
        return 4 if len(teams['not_grade11_10']) >= 4 else len(teams['not_grade11_10'])

n = int(input())
participants = []

for _ in range(n):
    participant = list(map(str, input().split()))
    participants.append(participant)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

result = form_teams(participants, olympiads)

for res in result:
    print(*res)
