#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;

struct Participant
{
    int id, score, age, grade;
    bool gender;

    Participant(int _id, bool _gender, int _grade, int _age, int _score)
    {
        id = _id; gender = _gender; grade = _grade; age = _age; score = _score;
    }
};

bool can_go_EGOI(Participant p)
{
    return !p.gender;
}
bool can_go_IOI(Participant p)
{
    return true;
}
bool can_go_CEOI(Participant p)
{
    return true;
}
bool can_go_EJOI(Participant p)
{
    return p.age <= 15;
}
bool can_go_BaltOI(Participant p)
{
    return true;
}
bool can_go_BalkOI(Participant p)
{
    return p.grade < 11;
}
bool can_go_JBOI(Participant p)
{
    return p.grade < 10;
}

template <class FunctionT>
void DoSomething(Participant p, FunctionT func)
{
    if (func(p))
    {
        cout << "YEAH";
    }
    else cout << "NAH";
}

vector<Participant> participants;
vector<pair<int, int>> sort_order;

template <class FunctionT>
void SelectParticipants(int top, FunctionT can_go)
{
    vector<int> res;
    for (int i = 0; i < sort_order.size(); i++)
    {
        int ind = sort_order[i].second;
        if (can_go(participants[ind]))
        {
            res.push_back(participants[ind].id);
            top--;
            if (top == 0) break;
        }
    }
    sort(res.begin(), res.end());
    for (int i = 0; i < res.size(); i++)
    {
        cout << res[i] << "\n";
    }
}


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n; cin >> n;
    for (int i = 0; i < n; i++)
    {
        int _id; string _gender; int _grade; int _age; int _score;
        cin >> _id >> _gender >> _grade >> _age >> _score;
        participants.push_back({ _id, _gender == "male", _grade, _age, _score });
        sort_order.push_back({ _score, i });
    }
    sort(sort_order.begin(), sort_order.end(), greater<pint>());
    int oc; cin >> oc;
    for (int i = 0; i < oc; i++)
    {
        string olympiad; cin >> olympiad;
        cout << olympiad << "\n";
        if (olympiad == "IOI") SelectParticipants(4, can_go_IOI);
        else if (olympiad == "CEOI") SelectParticipants(4, can_go_CEOI);
        else if (olympiad == "EGOI") SelectParticipants(4, can_go_EGOI);
        else if (olympiad == "EJOI") SelectParticipants(4, can_go_EJOI);
        else if (olympiad == "BaltOI") SelectParticipants(6, can_go_BaltOI);
        else if (olympiad == "BalkOI") SelectParticipants(4, can_go_BalkOI);    
        else if (olympiad == "JBOI") SelectParticipants(4, can_go_JBOI);
        cout << "\n";
    }
}