#include <iostream>
#include <vector>
#include <map>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m;

    map<string, int> sizeIndex;
    for (int i = 0; i < m; ++i) {
        string size;
        cin >> size;
        sizeIndex[size] = i;
    }

    vector<vector<int>> stock(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> stock[i][j];
        }
    }

    cin >> k;
    vector<vector<int>> order(n, vector<int>(m, 0));
    while (k--) {
        int color;
        string size;
        cin >> color >> size;
        --color; 
        int sizeIdx = sizeIndex[size];
        bool fulfilled = false;

        for (int s = sizeIdx; s < m && !fulfilled; ++s) {
            for (int c = 0; c < n && !fulfilled; ++c) {
                if (stock[c][s] > 0) {
                    stock[c][s]--;
                    fulfilled = true;
                }
            }
        }

        if (!fulfilled) {
            order[color][sizeIdx]++;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << stock[i][j] << " ";
        }
        cout << endl;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
