#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

struct Participant {
    int id, grade, age, score;
    string gender;

    Participant(int id, string gender, int grade, int age, int score)
        : id(id), gender(gender), grade(grade), age(age), score(score) {}
};

vector<Participant> filterParticipants(vector<Participant>& participants, string olympiad) {
    vector<Participant> filtered;

    for (const auto& p : participants) {
        if ((olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") ||
            (olympiad == "EGOI" && p.gender == "female") ||
            (olympiad == "EJOI" && p.age < 15) ||
            (olympiad == "BalkOI" && p.grade != 11) ||
            (olympiad == "JBOI" && p.grade != 11 && p.grade != 10)) {
            filtered.push_back(p);
        }
    }

    return filtered;
}

int main() {
    int n;
    cin >> n;
    vector<Participant> participants;
    for (int i = 0; i < n; ++i) {
        int id, grade, age, score;
        string gender;
        cin >> id >> gender >> grade >> age >> score;
        participants.push_back(Participant(id, gender, grade, age, score));
    }

    int m;
    cin >> m;
    map<string, int> teamSize = {{"IOI", 4}, {"CEOI", 4}, {"EGOI", 4}, {"EJOI", 4},
                                 {"BaltOI", 6}, {"BalkOI", 4}, {"JBOI", 4}};

    while (m--) {
        string olympiad;
        cin >> olympiad;
        auto filtered = filterParticipants(participants, olympiad);

        sort(filtered.begin(), filtered.end(), [](const Participant& a, const Participant& b) {
            return a.score > b.score;
        });

        int size = min((int)filtered.size(), teamSize[olympiad]);
        sort(filtered.begin(), filtered.begin() + size, [](const Participant& a, const Participant& b) {
            return a.id < b.id;
        });

        cout << olympiad << endl;
        for (int i = 0; i < size; ++i) {
            cout << filtered[i].id << endl;
        }
    }

    return 0;
}
