n, m = map(int, input().split())
world = [['.' for _ in range(m)] for _ in range(n)]
rays = [
    {'head_pos': [0, 0], 'direction_vec': [1, 1]},
    {'head_pos': [0, m-1], 'direction_vec': [1, -1]}
]

def render(matrix):
    for row in matrix:
        print(''.join(row))

def update(world, rays):
    new_rays = []
    for ray in rays:
        head_pos = ray['head_pos']
        direction_vec = ray['direction_vec']

        # Set the current position to lit
        world[head_pos[0]][head_pos[1]] = 'x'

        # Calculate the next position
        next_pos = [head_pos[0] + direction_vec[0], head_pos[1] + direction_vec[1]]

        # Reflect on vertical edges
        if next_pos[1] < 0 or next_pos[1] >= m:
            direction_vec[1] *= -1

        # Reflect on horizontal edges or delete rays
        if next_pos[0] >= n:
            continue
        else:
            head_pos[0] += direction_vec[0]
            head_pos[1] += direction_vec[1]
            new_rays.append(ray)  # Only keep rays that haven't passed the grid

    return world, new_rays

while len(rays) > 0:
    world, rays = update(world, rays)
render(world)