### Input

# Read the initial number of colors and sizes
n, m = map(int, input().split())
sizes_str = input().split()

# Read the initial stock of shirts
shirts = [list(map(int, input().split())) for _ in range(n)]

# Read the number of winners and their preferred shirt specs
k = int(input())
requests = [input().split() for _ in range(k)]


### Process the shirt requests

leftovers = [[shirts[i][j] for j in range(m)] for i in range(n)]
to_order = [[0 for _ in range(m)] for _ in range(n)]

for req in requests:
    color = int(req[0]) - 1 # Convert to zero-based index
    size = sizes_str.index(req[1]) # No conversion to index necessary
    assigned = False

    # Check available stock for the exact color and size
    if leftovers[color][size] > 0:
        leftovers[color][size] -= 1
        assigned = True
    else:
        # Try other colors with the same size
        for c in range(n):
            if leftovers[c][size] > 0:
                leftovers[c][size] -= 1
                assigned = True
                break

    # If not assigned, look for larger sizes
    if not assigned:
        for next_size in range(size + 1, m):
            if leftovers[color][next_size] > 0:
                leftovers[color][next_size] -= 1
                assigned = True
                break

        # If still not assigned, record the need to order
        if not assigned:
            to_order[color][size] += 1


### Output

for row in leftovers:
    print(' '.join(map(str, row)))
for row in to_order:
    print(' '.join(map(str, row)))