def process_gifts(n, m, sizes, stock, requests):
    remaining_stock = [[stock[i][j] for j in range(m)] for i in range(n)]
    required_stock = [[0] * m for _ in range(n)]

    for participant in requests:
        color, size = participant
        size_index = sizes.index(size)

        if remaining_stock[int(color) - 1][size_index] > 0:
            remaining_stock[int(color) - 1][size_index] -= 1
        else:
            available_colors = [i for i in range(n) if remaining_stock[i][size_index] > 0]

            if available_colors:
                min_color = min(available_colors)
                remaining_stock[min_color][size_index] -= 1
            else:
                for next_size in range(size_index + 1, m):
                    available_colors = [i for i in range(n) if remaining_stock[i][next_size] > 0]
                    if available_colors:
                        min_color = min(available_colors)
                        remaining_stock[min_color][next_size] -= 1
                        break

        required_stock[int(color) - 1][size_index] += 1

    return remaining_stock, required_stock


n, m = map(int, input().split())
sizes = input().split()

stock = []
for _ in range(n):
    stock.append(list(map(int, input().split())))

k = int(input())
requests = [tuple(map(str, input().split())) for _ in range(k)]

remaining_stock, required_stock = process_gifts(n, m, sizes, stock, requests)

for row in remaining_stock:
    print(" ".join(map(str, row)))

for row in required_stock:
    print(" ".join(map(str, row)))
