# Function to determine team composition for each olympiad
def determine_team(participants, olympiad):
    team = []

    if olympiad == 'IOI' or olympiad == 'CEOI':
        participants.sort(key=lambda x: x[4], reverse=True)
        team = participants[:4]
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p[1] == 'female']
        female_participants.sort(key=lambda x: x[4], reverse=True)
        team = female_participants[:4]
    elif olympiad == 'EJOI':
        under_15_participants = [p for p in participants if p[3] <= 15]
        under_15_participants.sort(key=lambda x: x[4], reverse=True)
        team = under_15_participants[:4]
    elif olympiad == 'BaltOI':
        participants.sort(key=lambda x: x[4], reverse=True)
        team = participants[:6]
    elif olympiad == 'BalkOI':
        non_11th_grade_participants = [p for p in participants if p[2] != 11]
        non_11th_grade_participants.sort(key=lambda x: x[4], reverse=True)
        team = non_11th_grade_participants[:4]
    elif olympiad == 'JBOI':
        non_11th_10th_grade_participants = [p for p in participants if p[2] not in [10, 11]]
        non_11th_10th_grade_participants.sort(key=lambda x: x[4], reverse=True)
        team = non_11th_10th_grade_participants[:4]

    return team


# Input processing
n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participant_id, gender, grade, age, score = int(participant_info[0]), participant_info[1], int(participant_info[2]), int(participant_info[3]), int(participant_info[4])
    participants.append((participant_id, gender, grade, age, score))

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Output team composition for each specified olympiad
for olympiad in olympiads:
    team = determine_team(participants, olympiad)
    print(olympiad)
    for member in team:
        print(member[0])
