from collections import defaultdict

# Функція для визначення складу команди для кожної олімпіади
def form_teams(participants, olympiads):
    # Словник для збереження учасників за кожною олімпіадою
    teams = defaultdict(list)

    for olympiad in olympiads:
        if olympiad == 'IOI':
            # Сортування учасників за балами і вибір найкращих 4
            best_participants = sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
            teams['IOI'] = [participant['id'] for participant in best_participants]
        elif olympiad == 'CEOI':
            # Аналогічно для інших олімпіад
            # ...
            # Код для визначення складу команд для CEOI
            pass
        # Інші умови для решти олімпіад

        # Додати інші умови для решти олімпіад
        # ...

    return teams

# Зчитування вхідних даних
n = int(input())  # Кількість учасників
participants = []  # Список учасників

for _ in range(n):
    participant_info = input().split()
    participant = {
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    }
    participants.append(participant)

m = int(input())  # Кількість олімпіад
olympiads = []  # Список олімпіад

for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)

# Формування складу команд для кожної олімпіади
teams = form_teams(participants, olympiads)

# Виведення результатів
for olympiad in olympiads:
    team_members = teams[olympiad]
    print(olympiad)
    for member in team_members:
        print(member)
