#include <iostream>
#include <vector>
#include <tuple>

using namespace std;

void process_gifts(int n, int m, vector<string>& sizes, vector<vector<int>>& quantities, int k, vector<tuple<int, string>>& winners) {
    vector<vector<int>> remaining_shirts(n, vector<int>(m, 0));
    vector<vector<int>> needed_shirts(n, vector<int>(m, 0));
    vector<vector<int>> excess_shirts(n, vector<int>(m, 0));
    vector<vector<int>> unfulfilled_requests(n, vector<int>(m, 0));

    // Copy quantities to remaining_shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            remaining_shirts[i][j] = quantities[i][j];
        }
    }

    for (int i = 0; i < k; ++i) {
        int color = get<0>(winners[i]);
        string size = get<1>(winners[i]);
        int size_index = -1;

        // Find the index of the size
        for (int j = 0; j < m; ++j) {
            if (sizes[j] == size) {
                size_index = j;
                break;
            }
        }

        // Check if there is a shirt of the specified color and size
        if (remaining_shirts[color - 1][size_index] > 0) {
            remaining_shirts[color - 1][size_index] -= 1;
        } else {
            // Find a shirt of the same size but different color
            bool found_alternative = false;
            for (int j = 0; j < n; ++j) {
                if (remaining_shirts[j][size_index] > 0) {
                    remaining_shirts[j][size_index] -= 1;
                    excess_shirts[j][size_index] += 1;
                    found_alternative = true;
                    break;
                }
            }

            // If no alternative is found, find the smallest available size
            if (!found_alternative) {
                for (int j = size_index + 1; j < m; ++j) {
                    for (int k = 0; k < n; ++k) {
                        if (remaining_shirts[k][j] > 0) {
                            remaining_shirts[k][j] -= 1;
                            excess_shirts[k][j] += 1;
                            break;
                        }
                    }
                }
            }
        }

        // Update the needed shirts count
        needed_shirts[color - 1][size_index] += 1;
    }

    // Display the excess and unfulfilled shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << excess_shirts[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << unfulfilled_requests[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    int n, m, k;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> quantities(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> quantities[i][j];
        }
    }

    cin >> k;

    vector<tuple<int, string>> winners(k);
    for (int i = 0; i < k; ++i) {
        cin >> get<0>(winners[i]) >> get<1>(winners[i]);
    }

    process_gifts(n, m, sizes, quantities, k, winners);

    return 0;
}
