#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct TShirt {
    char color;
    char size;
};

bool compareSizes(char a, char b) {
    string sizes = "XS S M L XL 2XL";
    return sizes.find(a) < sizes.find(b);
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<char> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<TShirt> orders(k);
    for (int i = 0; i < k; ++i) {
        int c;
        cin >> c;
        orders[i].color = c - 1;
        cin >> orders[i].size;
    }

    vector<vector<int>> remaining = available;

    for (auto& order : orders) {
        char color = order.color;
        char size = order.size;

        if (remaining[color][size] > 0) {
            remaining[color][size]--;
        } else {
            vector<char> availableSizes;
            for (int i = 0; i < m; ++i) {
                if (remaining[color][i] > 0) {
                    availableSizes.push_back(sizes[i]);
                }
            }

            sort(availableSizes.begin(), availableSizes.end(), compareSizes);

            bool found = false;
            for (char availableSize : availableSizes) {
                for (int i = size - '0' + 1; i < m; ++i) {
                    if (remaining[color][i] > 0 && sizes[i] == availableSize) {
                        remaining[color][i]--;
                        found = true;
                        break;
                    }
                }
                if (found) break;
            }
        }
    }

    // Output remaining shirts
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    // Output shirts to order
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << (available[i][j] - remaining[i][j]) << " ";
        }
        cout << endl;
    }

    return 0;
}
