def process_gifts(n, m, sizes, available, winners):
    remaining_gifts = [[available[i][j] for j in range(m)] for i in range(n)]
    required_gifts = [[0 for j in range(m)] for i in range(n)]

    for i in range(len(winners)):
        color, size = winners[i][1], winners[i][2]
        size_index = sizes.index(size)

        if remaining_gifts[color][size_index] > 0:
            remaining_gifts[color][size_index] -= 1
        else:
            for j in range(size_index + 1, m):
                if remaining_gifts[color][j] > 0:
                    remaining_gifts[color][j] -= 1
                    required_gifts[color][j] += 1
                    break

    return remaining_gifts, required_gifts

def main():
    n, m = map(int, input().split())
    sizes = input().split()
    available = [list(map(int, input().split())) for _ in range(n)]

    k = int(input())
    winners = [list(map(str, input().split())) for _ in range(k)]

    remaining_gifts, required_gifts = process_gifts(n, m, sizes, available, winners)

    for row in remaining_gifts:
        print(" ".join(map(str, row)))

    for row in required_gifts:
        print(" ".join(map(str, row)))

if __name__ == "__main__":
    main()
