#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

using namespace std;

void processGifts(int n, int m, const vector<string>& sizes, vector<vector<int>>& available, const vector<pair<int, string>>& winners) {
    vector<vector<int>> remainingGifts(n, vector<int>(m, 0));
    vector<vector<int>> requiredGifts(n, vector<int>(m, 0));

    for (const auto& winner : winners) 
    {
        size_t color = winner.first - 1;
        string size = winner.second;
        auto it = find(sizes.begin(), sizes.end(), size);

        if (it != sizes.end()) 
        {
            size_t sizeIndex = distance(sizes.begin(), it);

            if (available[color][sizeIndex] > 0) 
            {
                available[color][sizeIndex]--;
            } else {
                for (size_t j = sizeIndex + 1; j < m; ++j) 
                {
                    if (available[color][j] > 0) 
                    {
                        available[color][j]--;
                        requiredGifts[color][j]++;
                        break;
                    }
                }
            }
        }
    }

    for (const auto& row : available) 
    {
        for (int count : row) 
        {
            cout << count << " ";
        }
        cout << endl;
    }

    for (const auto& row : requiredGifts) 
    {
        for (int count : row) 
        {
            cout << count << " ";
        }
        cout << endl;
    }
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) 
    {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) 
    {
        for (int j = 0; j < m; ++j) 
        {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<pair<int, string>> winners(k);
    for (int i = 0; i < k; ++i) 
    {
        cin >> winners[i].first >> winners[i].second;
    }

    processGifts(n, m, sizes, available, winners);

    return 0;
}
