from heapq import nlargest

# Function to determine team composition for each olympiad
def determine_team(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return nlargest(4, participants, key=lambda x: x[4])
    elif olympiad == "EGOI":
        return nlargest(4, filter(lambda x: x[1] == "female", participants), key=lambda x: x[4])
    elif olympiad == "EJOI":
        return nlargest(4, filter(lambda x: x[3] < 15, participants), key=lambda x: x[4])
    elif olympiad == "BaltOI":
        return nlargest(6, participants, key=lambda x: x[4])
    elif olympiad == "BalkOI":
        return nlargest(4, filter(lambda x: x[2] != 11, participants), key=lambda x: x[4])
    elif olympiad == "JBOI":
        return nlargest(4, filter(lambda x: x[2] not in [11, 10], participants), key=lambda x: x[4])

# Input
n = int(input())
participants = [tuple(map(str, input().split())) for _ in range(n)]
participants = sorted(participants, key=lambda x: int(x[0]))

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Process and output
for olympiad in olympiads:
    team = determine_team(olympiad, participants)
    print(olympiad)
    for participant in sorted(team, key=lambda x: int(x[0])):
        print(participant[0])