import heapq

def max_unmarked_sequence_length(n, m, a):
    # Initialize the priority queue with initial lengths of color sequences
    max_lengths = [-(-(a[i] - 1) // 2) for i in range(n)]
    heapq.heapify(max_lengths)

    total_unmarked = sum(max_lengths)

    # Perform Miss M's process to find the maximum length of unmarked sequence
    while m > 0:
        max_length = -heapq.heappop(max_lengths)
        half_length = (max_length - 1) // 2

        # Update the priority queue with new lengths after marking a color
        heapq.heappush(max_lengths, -half_length)
        heapq.heappush(max_lengths, -(max_length - half_length - 1))

        total_unmarked -= max_length
        m -= 1

    return total_unmarked

# Input
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output
result = max_unmarked_sequence_length(n, m, a)
print(result)