from collections import defaultdict

def select_team(participants, criteria, num_of_members):
    participants.sort(key=lambda x: x[3], reverse=True)
    selected = participants[:num_of_members]
    
    if criteria == 'EGOI':
        selected = [p for p in selected if p[1] == 'female']
    
    return sorted([p[0] for p in selected])

def main():
    n = int(input())
    participants = []

    for _ in range(n):
        participant_info = input().split()
        participants.append((int(participant_info[0]), participant_info[1], int(participant_info[3]), int(participant_info[4])))

    m = int(input())
    for _ in range(m):
        olympiad = input().strip()
        criteria, num_of_members = olympiad_criteria[olympiad]
        team_members = select_team(participants, criteria, num_of_members)

        print(olympiad)
        for member in team_members:
            print(member)

olympiad_criteria = {
    'IOI': ('', 4),
    'CEOI': ('', 4),
    'EGOI': ('female', 4),
    'EJOI': ('age<16', 4),
    'BaltOI': ('', 6),
    'BalkOI': ('grade!=11', 4),
    'JBOI': ('grade!=11 and grade!=10', 4),
}

if __name__ == "__main__":
    main()