def select_team(participants, criteria):
    # Створюємо список для кожної олімпіади, де будемо зберігати id учасників
    teams = {olympiad: [] for olympiad in criteria}

    # Визначаємо команди для кожної олімпіади
    for olympiad in criteria:
        if olympiad == 'IOI' or olympiad == 'CEOI':
            teams[olympiad] = sorted(participants, key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == 'EGOI':
            female_participants = [p for p in participants if p['gender'] == 'female']
            teams[olympiad] = sorted(female_participants, key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == 'EJOI':
            young_participants = [p for p in participants if p['age'] <= 15]
            teams[olympiad] = sorted(young_participants, key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == 'BaltOI':
            teams[olympiad] = sorted(participants, key=lambda x: x['score'], reverse=True)[:6]
        elif olympiad == 'BalkOI':
            not_11th_graders = [p for p in participants if p['grade'] != 11]
            teams[olympiad] = sorted(not_11th_graders, key=lambda x: x['score'], reverse=True)[:4]
        elif olympiad == 'JBOI':
            not_10th_11th_graders = [p for p in participants if p['grade'] not in {10, 11}]
            teams[olympiad] = sorted(not_10th_11th_graders, key=lambda x: x['score'], reverse=True)[:4]

    return teams


# Вхідні дані для тестування (введення замінено на фіксовані значення)
n = 6
participants_data = [
    (1, 'male', 11, 17, 300),
    (2, 'female', 11, 16, 350),
    (3, 'male', 10, 15, 320),
    (4, 'female', 10, 14, 280),
    (5, 'male', 9, 13, 310),
    (6, 'female', 9, 12, 330)
]

participants = [{'id': id, 'gender': gender, 'grade': grade, 'age': age, 'score': score} for id, gender, grade, age, score in participants_data]

m = 3
criteria = ['IOI', 'EGOI', 'JBOI']

# Визначення складу команд для кожної олімпіади
teams = select_team(participants, criteria)

# Виведення результатів
for olympiad in criteria:
    team_members = sorted([participant['id'] for participant in teams[olympiad]])
    print(olympiad)
    print(" ".join(map(str, team_members)))