#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_OLYMPIADS 6

int determine_team_size(char *olympiad, int num_participants);

void determine_team_participants(char **olympiads, int *participants, int n, int m) {
    // Use arrays to store results
    int results[MAX_OLYMPIADS][1000][2];

    for (int i = 0; i < n; ++i) {
        int id, grade, age, score;
        char gender[10];
        id = participants[i * 5];
        strcpy(gender, (char *)(participants + i * 5 + 1));
        grade = participants[i * 5 + 2];
        age = participants[i * 5 + 3];
        score = participants[i * 5 + 4];

        for (int j = 0; j < m; ++j) {
            char *olympiad = olympiads[j];

            if (strcmp(olympiad, "IOI") == 0) {
                results[0][i][0] = score;
                results[0][i][1] = id;
            } else if (strcmp(olympiad, "CEOI") == 0) {
                results[1][i][0] = score;
                results[1][i][1] = id;
            } else if (strcmp(olympiad, "EGOI") == 0 && strcmp(gender, "female") == 0) {
                results[2][i][0] = score;
                results[2][i][1] = id;
            } else if (strcmp(olympiad, "EJOI") == 0 && age <= 15) {
                results[3][i][0] = score;
                results[3][i][1] = id;
            } else if (strcmp(olympiad, "BaltOI") == 0) {
                results[4][i][0] = score;
                results[4][i][1] = id;
            } else if (strcmp(olympiad, "BalkOI") == 0 && grade != 11) {
                results[5][i][0] = score;
                results[5][i][1] = id;
            } else if (strcmp(olympiad, "JBOI") == 0 && grade < 11) {
                results[6][i][0] = score;
                results[6][i][1] = id;
            }
        }
    }

    // Use arrays to store teams
    int teams[MAX_OLYMPIADS][4];
    for (int i = 0; i < m; ++i) {
        char *olympiad = olympiads[i];
        int team_size = determine_team_size(olympiad, n);

        // Sorting the results array
        for (int k = 0; k < n - 1; ++k) {
            for (int l = 0; l < n - k - 1; ++l) {
                if (results[i][l][0] < results[i][l + 1][0]) {
                    int temp_score = results[i][l][0];
                    int temp_id = results[i][l][1];

                    results[i][l][0] = results[i][l + 1][0];
                    results[i][l][1] = results[i][l + 1][1];

                    results[i][l + 1][0] = temp_score;
                    results[i][l + 1][1] = temp_id;
                }
            }
        }

        // Assigning team members
        for (int j = 0; j < team_size; ++j) {
            teams[i][j] = results[i][j][1];
        }
    }

    // Printing results
    for (int i = 0; i < m; ++i) {
        printf("%s\n", olympiads[i]);
        for (int j = 0; j < determine_team_size(olympiads[i], n); ++j) {
            printf("%d\n", teams[i][j]);
        }
    }
}

int determine_team_size(char *olympiad, int num_participants) {
    if (strcmp(olympiad, "IOI") == 0 || strcmp(olympiad, "CEOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "EGOI") == 0 || strcmp(olympiad, "EJOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else if (strcmp(olympiad, "BaltOI") == 0) {
        return num_participants < 6 ? num_participants : 6;
    } else if (strcmp(olympiad, "BalkOI") == 0) {
        return num_participants < 4 ? num_participants : 4;
    } else {
        return 0;
    }
}

int main() {
    int n, m;
    scanf("%d", &n);

    // Allocate memory for participants
    int *participants = (int *)malloc(n * 5 * sizeof(int));
    for (int i = 0; i < n * 5; ++i) {
        scanf("%d", participants + i);
    }

    scanf("%d", &m);

    // Allocate memory for olympiads
    char **olympiads = (char **)malloc(m * sizeof(char *));
    for (int i = 0; i < m; ++i) {
        olympiads[i] = (char *)malloc(10 * sizeof(char));
        scanf("%s", olympiads[i]);
    }

    // Call the function to determine teams and print results
    determine_team_participants(olympiads, participants, n, m);

    // Free allocated memory
    free(participants);

    for (int i = 0; i < m; ++i) {
        free(olympiads[i]);
    }
    free(olympiads);

    return 0;
}