#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score || (a.score == b.score && a.id < b.id);
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    map<string, int> olympiadMap;
    vector<vector<int>> selectedParticipants(m);

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;
        olympiadMap[olympiad] = i;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            int teamSize = (olympiad == "BaltOI") ? 6 : 4;
            for (int j = 0; j < min(n, teamSize); ++j) {
                selectedParticipants[i].push_back(participants[j].id);
            }
        } else if (olympiad == "EGOI") {
            int teamSize = 4;
            int girlsCount = 0;
            for (const auto &participant : participants) {
                if (participant.gender == "female" && girlsCount < teamSize) {
                    selectedParticipants[i].push_back(participant.id);
                    girlsCount++;
                }
            }
        } else if (olympiad == "EJOI") {
            int teamSize = 4;
            int juniorsCount = 0;
            for (const auto &participant : participants) {
                if (participant.grade <= 10 && juniorsCount < teamSize) {
                    selectedParticipants[i].push_back(participant.id);
                    juniorsCount++;
                }
            }
        } else if (olympiad == "BalkOI") {
            int teamSize = 4;
            int nonSeniorsCount = 0;
            for (const auto &participant : participants) {
                if (participant.grade != 11 && nonSeniorsCount < teamSize) {
                    selectedParticipants[i].push_back(participant.id);
                    nonSeniorsCount++;
                }
            }
        } else if (olympiad == "JBOI") {
            int teamSize = 4;
            int non11thAnd10thGradersCount = 0;
            for (const auto &participant : participants) {
                if (participant.grade != 11 && participant.grade != 10 && non11thAnd10thGradersCount < teamSize) {
                    selectedParticipants[i].push_back(participant.id);
                    non11thAnd10thGradersCount++;
                }
            }
        }
    }

    for (int i = 0; i < m; ++i) {
        cout << selectedParticipants[olympiadMap["IOI"]].size() << endl;
        for (int participantId : selectedParticipants[olympiadMap["IOI"]]) {
            cout << participantId << " ";
        }
        cout << endl;
    }

    return 0;
}
