program MissMChampionship;

const
  MAX_N = 100;
  MAX_M = 6;
  MAX_K = 100000;

var
  n, m, k, i, j, sizeIndex, colorIndex: integer;
  sizes: array[0..MAX_M-1] of string;
  teamRequests: array[1..MAX_N, 0..MAX_M-1] of integer;
  remainingColors, orderedColors: array[1..MAX_N, 0..MAX_M-1] of integer;

procedure InitializeArrays();
begin
  for i := 1 to n do
    for j := 0 to m - 1 do
    begin
      teamRequests[i][j] := 0;
      remainingColors[i][j] := 0;
      orderedColors[i][j] := 0;
    end;
end;

procedure ProcessRequests();
var
  color, size: string;
begin
  for i := 1 to k do
  begin
    readln(color, size);

    sizeIndex := -1;
    for j := 0 to m - 1 do
      if sizes[j] = size then
        sizeIndex := j;

    teamRequests[colorIndex][sizeIndex] := teamRequests[colorIndex][sizeIndex] + 1;
    remainingColors[colorIndex][sizeIndex] := remainingColors[colorIndex][sizeIndex] + 1;
  end;
end;

procedure DistributeTShirts();
begin
  for i := 1 to n do
    for j := 0 to m - 1 do
    begin
      if teamRequests[i][j] > 0 then
      begin
        if remainingColors[i][j] > 0 then
        begin
          remainingColors[i][j] := remainingColors[i][j] - 1;
          orderedColors[i][j] := orderedColors[i][j] + 1;
        end
        else
        begin
          colorIndex := 1;
          while (remainingColors[colorIndex][j] = 0) and (colorIndex <= n) do
            colorIndex := colorIndex + 1;

          if colorIndex <= n then
          begin
            remainingColors[colorIndex][j] := remainingColors[colorIndex][j] - 1;
            orderedColors[colorIndex][j] := orderedColors[colorIndex][j] + 1;
          end
          else
          begin
            sizeIndex := j + 1;
            while (sizeIndex < m) and (remainingColors[i][sizeIndex] = 0) do
              sizeIndex := sizeIndex + 1;

            if sizeIndex < m then
            begin
              remainingColors[i][sizeIndex] := remainingColors[i][sizeIndex] - 1;
              orderedColors[i][sizeIndex] := orderedColors[i][sizeIndex] + 1;
            end
            else
            begin
              sizeIndex := j + 1;
              while (sizeIndex < m) and (remainingColors[1][sizeIndex] = 0) do
                sizeIndex := sizeIndex + 1;

              if sizeIndex < m then
              begin
                remainingColors[1][sizeIndex] := remainingColors[1][sizeIndex] - 1;
                orderedColors[1][sizeIndex] := orderedColors[1][sizeIndex] + 1;
              end
              else
                orderedColors[i][j] := -1; // Mark as absent
            end;
          end;
        end;
      end;
    end;
end;

procedure DisplayResults();
begin
  // Display remaining T-shirts
  writeln('Remaining T-shirts:');
  for i := 1 to n do
  begin
    for j := 0 to m - 1 do
      write(remainingColors[i][j], ' ');
    writeln;
  end;
  for i := 1 to n do
  begin
    for j := 0 to m - 1 do
      write(orderedColors[i][j], ' ');
    writeln;
  end;
end;

begin
  readln(n, m);

  for i := 0 to m - 1 do
    read(sizes[i]);

  InitializeArrays();
  ProcessRequests();
  DistributeTShirts();
  DisplayResults();
end.
