from collections import defaultdict

def main():
    # Read input
    n, m = map(int, input().split())
    sizes = input().split()
    quantities = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    winners = [input().split() for _ in range(k)]

    remaining_gifts = defaultdict(lambda: defaultdict(int))
    missing_gifts = defaultdict(lambda: defaultdict(int))

    # Process gifts
    for j in range(m):
        for i in range(n):
            remaining_gifts[sizes[j]][i] = quantities[i][j]

    for i in range(len(winners)):
        color, size = winners[i][1], winners[i][0]
        if remaining_gifts[color][size] > 0:
            remaining_gifts[color][size] -= 1
        elif remaining_gifts[color][size] == 0:
            found_alternative = False
            for alt_size in range(size + 1, m):
                if remaining_gifts[color][alt_size] > 0:
                    remaining_gifts[color][alt_size] -= 1
                    found_alternative = True
                    break

            if not found_alternative:
                for alt_size in range(size + 1, m):
                    for alt_color in range(color + 1, n):
                        if remaining_gifts[alt_color][alt_size] > 0:
                            remaining_gifts[alt_color][alt_size] -= 1
                            found_alternative = True
                            break
                    if found_alternative:
                        break

            if not found_alternative:
                missing_gifts[color][size] += 1

    # Print remaining gifts
    for i in range(n):
        print(" ".join(map(str, [remaining_gifts[color][i] for color in sizes])))

    # Print missing gifts
    for i in range(n):
        print(" ".join(map(str, [missing_gifts[color][i] for color in sizes])))

if __name__ == "__main__":
    main()
