# Read input values
n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participants.append({
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    })

m = int(input())
olympiads = [input() for _ in range(m)]

# Define functions to filter participants based on olympiad criteria
def ioi_criteria(participant):
    return True

def ceoi_criteria(participant):
    return True

def egoi_criteria(participant):
    return participant['gender'] == 'female'

def ejoi_criteria(participant):
    return participant['age'] <= 15

def baltoi_criteria(participant):
    return True

def balkoi_criteria(participant):
    return participant['grade'] != 11

def jboi_criteria(participant):
    return participant['grade'] not in [10, 11]

# Create a dictionary mapping olympiad names to their corresponding criteria functions
olympiad_criteria = {
    'IOI': ioi_criteria,
    'CEOI': ceoi_criteria,
    'EGOI': egoi_criteria,
    'EJOI': ejoi_criteria,
    'BaltOI': baltoi_criteria,
    'BalkOI': balkoi_criteria,
    'JBOI': jboi_criteria,
}

# Process each olympiad and print the team members
for olympiad in olympiads:
    criteria_function = olympiad_criteria[olympiad]
    team_members = [participant['id'] for participant in sorted(participants, key=lambda x: (-x['score'], x['id'])) if criteria_function(participant)]
    print(olympiad)
    for member in team_members:
        print(member)
