def process_olympiad_teams(participants, olympiad_name):
    sorted_participants = sorted(participants, key=lambda x: (-x['score'], x['id']))

    if olympiad_name == 'IOI' or olympiad_name == 'CEOI':
        return sorted_participants[:4]
    elif olympiad_name == 'EGOI':
        return [participant for participant in sorted_participants if participant['gender'] == 'female'][:4]
    elif olympiad_name == 'EJOI':
        return [participant for participant in sorted_participants if participant['age'] <= 15][:4]
    elif olympiad_name == 'BaltOI':
        return sorted_participants[:6]
    elif olympiad_name == 'BalkOI':
        return [participant for participant in sorted_participants if participant['grade'] != 11][:4]
    elif olympiad_name == 'JBOI':
        return [participant for participant in sorted_participants if participant['grade'] not in [10, 11]][:4]
    else:
        return []

def main():
    n = int(input())
    participants = []

    for _ in range(n):
        participant_info = input().split()
        participants.append({
            'id': int(participant_info[0]),
            'gender': participant_info[1],
            'grade': int(participant_info[2]),
            'age': int(participant_info[3]),
            'score': int(participant_info[4])
        })

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    for olympiad_name in olympiads:
        team_members = process_olympiad_teams(participants, olympiad_name)
        print(olympiad_name)
        for member in team_members:
            print(member['id'])

if __name__ == "__main__":
    main()

