# Function to filter participants based on olympiad criteria
def filter_participants(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI" or olympiad == "BaltOI":
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(len(participants), 6)]
    elif olympiad == "EGOI":
        return sorted([p for p in participants if p[1] == "female"], key=lambda x: -x[4])[:min(len(participants), 4)]
    elif olympiad == "EJOI":
        return sorted([p for p in participants if p[3] <= 15], key=lambda x: -x[4])[:min(len(participants), 4)]
    elif olympiad == "BalkOI":
        return sorted([p for p in participants if p[2] != 11], key=lambda x: -x[4])[:min(len(participants), 4)]
    elif olympiad == "JBOI":
        return sorted([p for p in participants if p[2] not in (10, 11)], key=lambda x: -x[4])[:min(len(participants), 4)]

# Reading input
n = int(input())
participants = []
for _ in range(n):
    info = input().split()
    participant_id = int(info[0])
    gender = info[1]
    grade = int(info[2])
    age = int(info[3])
    score = int(info[4])
    participants.append((participant_id, gender, grade, age, score))

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Processing olympiad teams
for olympiad in olympiads:
    selected_participants = filter_participants(olympiad, participants)
    print(olympiad)
    for participant in selected_participants:
        print(participant[0])
