using System;
using System.Collections.Generic;
using System.Linq;

class Participant
{
    public long Id { get; set; }
    public string Gender { get; set; }
    public int Grade { get; set; }
    public int Age { get; set; }
    public int Score { get; set; }
}

class Program
{
    static void Main()
    {
        int n = int.Parse(Console.ReadLine()); // Number of participants
        var participants = new List<Participant>();

        // Reading participants' information
        for (int i = 0; i < n; i++)
        {
            string[] input = Console.ReadLine().Split();
            var participant = new Participant
            {
                Id = long.Parse(input[0]),
                Gender = input[1],
                Grade = int.Parse(input[2]),
                Age = int.Parse(input[3]),
                Score = int.Parse(input[4])
            };
            participants.Add(participant);
        }

        int m = int.Parse(Console.ReadLine()); // Number of olympiads
        var olympiads = new List<string>();

        // Reading olympiad names
        for (int i = 0; i < m; i++)
        {
            string olympiad = Console.ReadLine();
            olympiads.Add(olympiad);
        }

        foreach (var olympiad in olympiads)
        {
            List<Participant> team = new List<Participant>();
            switch (olympiad)
            {
                case "IOI":
                case "CEOI":
                case "BaltOI":
                    team = participants
                        .OrderByDescending(p => p.Score)
                        .Take(olympiad == "BaltOI" ? 6 : 4)
                        .ToList();
                    break;

                case "EGOI":
                    team = participants
                        .Where(p => p.Gender == "female")
                        .OrderByDescending(p => p.Score)
                        .Take(4)
                        .ToList();
                    break;

                case "EJOI":
                    team = participants
                        .Where(p => p.Age <= 15)
                        .OrderByDescending(p => p.Score)
                        .Take(4)
                        .ToList();
                    break;

                case "BalkOI":
                    team = participants
                        .Where(p => p.Grade != 11)
                        .OrderByDescending(p => p.Score)
                        .Take(4)
                        .ToList();
                    break;

                case "JBOI":
                    team = participants
                        .Where(p => p.Grade != 11 && p.Grade != 10)
                        .OrderByDescending(p => p.Score)
                        .Take(4)
                        .ToList();
                    break;
            }

            Console.WriteLine(olympiad);
            foreach (var participant in team)
            {
                Console.WriteLine(participant.Id);
            }
        }
    }
}
