using System;

class Program
{
    static void Main(string[] args)
    {
        string[] input = Console.ReadLine().Split();
        int n = int.Parse(input[0]); // Number of color wheels
        long m = long.Parse(input[1]); // Number of additional colors Miss M wants to take

        string[] wheelsInput = Console.ReadLine().Split();
        long[] wheels = new long[n];
        long maxWheel = 0;

        for (int i = 0; i < n; i++)
        {
            wheels[i] = long.Parse(wheelsInput[i]);
            maxWheel = Math.Max(maxWheel, wheels[i]);
        }

        long left = 1;
        long right = maxWheel;

        // Binary search to find the maximum length of unmarked sequence
        while (left < right)
        {
            long mid = (left + right + 1) / 2;
            long total = 0;

            for (int i = 0; i < n; i++)
            {
                total += Math.Max(0, wheels[i] - mid + 1);
            }

            if (total >= m)
            {
                left = mid;
            }
            else
            {
                right = mid - 1;
            }
        }

        Console.WriteLine(left);
    }
}
