def tshirt_distribution(n, m, sizes, inventory, k, winners):
    # Map sizes to indices
    size_to_index = {size: index for index, size in enumerate(sizes)}
    
    # Initialize the remaining and needed T-shirts tables
    remaining = [inventory[i][:] for i in range(n)]
    needed = [[0]*m for _ in range(n)]
    
    # Process each winner's request
    for color, size in winners:
        color -= 1  # Convert to 0-based index
        size_index = size_to_index[size]
        
        # Try to find a T-shirt of the required size and color
        if remaining[color][size_index] > 0:
            remaining[color][size_index] -= 1
        else:
            # Try to find a T-shirt of the same size but different color
            for i in range(n):
                if remaining[i][size_index] > 0:
                    remaining[i][size_index] -= 1
                    break
            else:
                # Try to find a T-shirt of a larger size
                for j in range(size_index+1, m):
                    if remaining[color][j] > 0:
                        remaining[color][j] -= 1
                        break
                    for i in range(n):
                        if remaining[i][j] > 0:
                            remaining[i][j] -= 1
                            break
                else:
                    # No suitable T-shirt was found
                    needed[color][size_index] += 1
    
    return remaining, needed


n = 2
m = 3
sizes = ['S', 'M', 'XL']
inventory = [[1, 3, 0], [3, 0, 3]]
k = 9
winners = [(1, 'S'), (2, 'XL'), (1, 'M'), (2, 'XL'), (1, 'M'), (2, 'M'), (1, 'M'), (2, 'S'), (1, 'XL')]

remaining, needed = tshirt_distribution(n, m, sizes, inventory, k, winners)

for row in remaining:
    print(*row)

for row in needed:
    print(*row)