import random

def max_length(colors):
    max_len = 0
    cur_len = 0
    for color in colors:
        if color == 1:
            cur_len = 0
        else:
            cur_len += 1
        max_len = max(max_len, cur_len)

    return max_len


def choose_color(colors):
    max_len = max_length(colors)
    if max_len == 0:
        return None

    mid = max_len // 2
    for i in range(len(colors)):
        if colors[i] == 0:
            mid -= 1

        if mid == 0:
            colors[i] = 1
            return i

        if colors[i] == 1:
            mid = max_len // 2


def solve(n, m, a):
    colors = []
    for ai in a:
        wheel = [0] * (ai + 1)
        wheel[random.randint(0, ai)] = 1
        colors.append(wheel)
    
    answer = 0
    for i in range(m):
        max_len = 0
        for wheel in colors:
            max_len = max(max_len, max_length(wheel))
        if i == m - 1:
            answer = max_len
        for wheel in colors:
            choose_color(wheel)
    return answer


n, m = map(int, input().split())
a = list(map(int, input().split()))
print(solve(n, m, a))
