#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Participant {
  int id;
  string gender;
  int grade;
  int age;
  int score;
};

bool compare_by_score(const Participant& a, const Participant& b) {
  return a.score > b.score;
}

bool is_valid_for_ioi(const Participant& participant) {
  return participant.grade <= 11;
}

bool is_valid_for_ceoi(const Participant& participant) {
  return is_valid_for_ioi(participant);
}

bool is_valid_for_egoi(const Participant& participant) {
  return participant.gender == "female" && is_valid_for_ioi(participant);
}

bool is_valid_for_ejoi(const Participant& participant) {
  return participant.age <= 15 && is_valid_for_ioi(participant);
}

bool is_valid_for_baltoi(const Participant& participant) {
  return is_valid_for_ioi(participant);
}

bool is_valid_for_balkoi(const Participant& participant) {
  return participant.grade != 11 && is_valid_for_ioi(participant);
}

bool is_valid_for_jboi(const Participant& participant) {
  return participant.grade < 11 && is_valid_for_ioi(participant);
}

int main() {
  int n;
  cin >> n;
  vector<Participant> participants(n);
  for (int i = 0; i < n; i++) {
    cin >> participants[i].id >> participants[i].gender >> participants[i].grade >>
        participants[i].age >> participants[i].score;
  }

  int m;
  cin >> m;
  vector<string> olympiads(m);
  for (int i = 0; i < m; i++) {
    cin >> olympiads[i];
  }

  for (int i = 0; i < m; i++) {
    vector<int> team;
    switch (olympiads[i]) {
      case "IOI":
        for (int j = 0; j < 4 && j < n; j++) {
          team.push_back(participants[j].id);
        }
        break;
      case "CEOI":
        for (int j = 0; j < 4 && j < n; j++) {
          team.push_back(participants[j].id);
        }
        break;
      case "EGOI":
        for (int j = 0; j < 4 && j < n; j++) {
          if (participants[j].gender == "female") {
            team.push_back(participants[j].id);
          }
        }
        break;
      case "EJOI":
        for (int j = 0; j < 4 && j < n; j++) {
          if (participants[j].age <= 15) {
            team.push_back(participants[j].id);
          }
        }
        break;
      case "BaltOI":
        for (int j = 0; j < 6 && j < n; j++) {
          team.push_back(participants[j].id);
        }
        break;
      case "BalkOI":
        for (int j = 0; j < 4 && j < n; j++) {
          if (participants[j].grade != 11) {
            team.push_back(participants[j].id);
          }
        }
        break;
      case "JBOI":
        for (int j = 0; j < 4 && j < n; j++) {
          if (participants[j].grade < 11) {
            team.push_back(participants[j].id);
          }
        }
        break;
    }
    sort(team.begin(), team.end());
    cout << olympiads[i] << " ";
  
