def process_gifts(n, m, sizes, available, winners):
    # Ініціалізуємо таблиці для виявлення зайвих та відсутніх футболок
    excess = [[0] * m for _ in range(n)]
    missing = [[0] * m for _ in range(n)]

    for winner in winners:
        color, size = int(winner[0]), winner[1]
        size_index = sizes.index(size)

        # Шукаємо футболку потрібного розміру та кольору
        if available[color - 1][size_index] > 0:
            available[color - 1][size_index] -= 1
        else:
            # Шукаємо футболку того ж розміру, але іншого кольору
            alt_color = find_alternative_color(available, color - 1, size_index)
            if alt_color is not None:
                available[alt_color][size_index] -= 1
                excess[alt_color][size_index] += 1
            else:
                # Шукаємо футболку наступного більшого розміру
                alt_size = find_alternative_size(available, color - 1, size_index)
                if alt_size is not None:
                    available[color - 1][alt_size] -= 1
                    excess[color - 1][alt_size] += 1
                else:
                    # Записуємо футболку як відсутню
                    missing[color - 1][size_index] += 1

    return excess, missing

def find_alternative_color(available, color, size_index):
    for alt_color in range(len(available)):
        if available[alt_color][size_index] > 0 and alt_color != color:
            return alt_color
    return None

def find_alternative_size(available, color, size_index):
    for alt_size in range(size_index + 1, len(available[0])):
        for alt_color in range(len(available)):
            if available[alt_color][alt_size] > 0 and alt_color == color:
                return alt_size
    return None


# Зчитуємо вхідні дані
n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]

# Обробляємо подарунки
excess, missing = process_gifts(n, m, sizes, available, winners)

# Виводимо результати
for row in excess:
    print(*row)
for row in missing:
    print(*row)

