def find_min_max_weight(weights, boxes):
    low, high = max(weights), sum(weights)

    while low < high:
        mid = (low + high) // 2
        current_box_weight, num_boxes = 0, 1

        for i in range(len(weights)):
            if current_box_weight + weights[i] > mid:
                current_box_weight = 0
                num_boxes += 1

            current_box_weight += weights[i]

        if num_boxes <= 2:
            high = mid
        else:
            low = mid + 1

    return low

def find_item_to_move(weights, boxes):
    max_weight = find_min_max_weight(weights, boxes)

    current_box_weight, current_box = 0, 1

    for i in range(len(weights) - 1, -1, -1):
        if current_box_weight + weights[i] > max_weight:
            current_box_weight = 0
            current_box += 1

        current_box_weight += weights[i]

        if current_box > 2:
            return i + 1

    return -1


weights = list(map(int, input("Enter the weights separated by space: ").split()))
boxes = list(map(int, input("Enter the corresponding boxes separated by space: ").split()))

item_to_move = find_item_to_move(weights, boxes)
print("Item to be moved:", item_to_move)

