# Function to calculate the maximum weight of a box after moving an item
def max_weight_after_move(weights, boxes, item_index, to_box):
    box_weights = [0, 0]
    for i in range(4):
        if i != item_index:
            box_weights[boxes[i] - 1] += weights[i]

    box_weights[to_box - 1] += weights[item_index]

    return max(box_weights)

# Input
weights = list(map(int, input().split()))
boxes = list(map(int, input().split()))

# Initialize with the maximum weight of a box without moving any item
max_weight_before = max(sum(weights[:2]), sum(weights[2:]))

# Check each item and find the one that minimizes the maximum weight after moving
move_candidate = -1
for i in range(4):
    for to_box in range(1, 3):
        if boxes[i] != to_box:
            max_weight_after = max_weight_after_move(weights, boxes, i, to_box)
            if max_weight_after < max_weight_before:
                max_weight_before = max_weight_after
                move_candidate = i + 1

# Output the result
print(move_candidate)