import sys

def main():
    n, m = map(int, sys.stdin.readline().split())
    sizes = [s for s in sys.stdin.readline().split()]
    T = [[int(x) for x in sys.stdin.readline().split()] for _ in range(n)]
    k = int(sys.stdin.readline())
    requests = [sys.stdin.readline().split() for _ in range(k)]

    # initialize the remaining and needed matrices
    remaining = [[0] * m for _ in range(n)]
    needed = [[0] * m for _ in range(n)]

    # process the requests
    for color, size in requests:
        color_index = int(color) - 1
        size_index = sizes.index(size)

        # check if there is a T-shirt of the requested size and color
        if T[color_index][size_index] > 0:
            T[color_index][size_index] -= 1
        else:
            # look for a T-shirt of the same size but a different color
            for i in range(n):
                if i != color_index and T[i][size_index] > 0:
                    T[i][size_index] -= 1
                    remaining[color_index][size_index] += 1
                    needed[i][size_index] += 1
                    break

            # if no T-shirt of the same size is found, look for a T-shirt of the next larger size
            if remaining[color_index][size_index] == 0:
                for j in range(size_index + 1, m):
                    if T[color_index][j] > 0:
                        T[color_index][j] -= 1
                        remaining[color_index][size_index] += 1
                        needed[color_index][j] += 1
                        break

            # if no T-shirt is found, record it as absent
            if remaining[color_index][size_index] == 0:
                needed[color_index][size_index] += 1

    # print the remaining and needed matrices
    for row in remaining:
        print(' '.join(map(str, row)))

    for row in needed:
        print(' '.join(map(str, row)))

if __name__ == '__main__':
    main()