from collections import defaultdict

# Function to determine the team for each olympiad
def determine_team(participants, olympiad):
    if olympiad == 'IOI' or olympiad == 'CEOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(4, len(participants))]
    elif olympiad == 'EGOI':
        female_participants = [p for p in participants if p[1] == 'female']
        return sorted(female_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(female_participants))]
    elif olympiad == 'EJOI':
        under_15_participants = [p for p in participants if p[3] <= 15]
        return sorted(under_15_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(under_15_participants))]
    elif olympiad == 'BaltOI':
        return sorted(participants, key=lambda x: (-x[4], x[0]))[:min(6, len(participants))]
    elif olympiad == 'BalkOI':
        non_11th_grade_participants = [p for p in participants if p[2] != 11]
        return sorted(non_11th_grade_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(non_11th_grade_participants))]
    elif olympiad == 'JBOI':
        non_11th_10th_grade_participants = [p for p in participants if p[2] not in [10, 11]]
        return sorted(non_11th_10th_grade_participants, key=lambda x: (-x[4], x[0]))[:min(4, len(non_11th_10th_grade_participants))]

# Input
n = int(input())
participants = []

for _ in range(n):
    info = input().split()
    participant = (int(info[0]), info[1], int(info[2]), int(info[3]), int(info[4]))
    participants.append(participant)

m = int(input())
olympiads = [input().strip() for _ in range(m)]

# Determine the teams and print the result
for olympiad in olympiads:
    team = determine_team(participants, olympiad)
    print(olympiad)

    members = []
    for member in team:
        members.append(member[0])
    members.sort()

    for member in members:
        print(member)

    print("")