#include <iostream>
#include <vector>
#include <map>

using namespace std;

void find_remaining_and_order(int n, int m, vector<char>& sizes, vector<vector<int>>& quantities, int k, vector<pair<int, char>>& winners) {
    map<char, map<int, int>> remaining;
    vector<vector<int>> to_order(n, vector<int>(m, 0));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            remaining[sizes[j]][i] = quantities[i][j];
        }
    }

    for (int i = 0; i < k; ++i) {
        int color = winners[i].first - 1;
        char size = winners[i].second;

        if (remaining[size][color] > 0) {
            remaining[size][color]--;
        } else {
            bool found = false;
            for (int c = 0; c < n; ++c) {
                if (remaining[size][c] > 0) {
                    to_order[c][color]++;
                    remaining[size][c]--;
                    found = true;
                    break;
                }
            }

            if (!found) {
                for (int s = size + 1; s < m; ++s) {
                    if (remaining[sizes[s]][color] > 0) {
                        remaining[sizes[s]][color]--;
                        to_order[color][s]++;
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    to_order[color][size]++;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[sizes[j]][i] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<char> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> quantities(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> quantities[i][j];
        }
    }

    int k;
    cin >> k;

    vector<pair<int, char>> winners(k);
    for (int i = 0; i < k; ++i) {
        cin >> winners[i].first >> winners[i].second;
    }

    find_remaining_and_order(n, m, sizes, quantities, k, winners);

    return 0;
}