#include <iostream>
#include <vector>
#include <algorithm>

void find_remaining_and_order(int n, int m, std::vector<char>& sizes, std::vector<std::vector<int>>& quantities, int k, std::vector<std::pair<int, char>>& winners) {
    std::vector<std::vector<int>> remaining(n, std::vector<int>(m, 0));
    std::vector<std::vector<int>> to_order(n, std::vector<int>(m, 0));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            remaining[i][j] = quantities[i][j];
        }
    }

    for (int i = 0; i < k; ++i) {
        int color = winners[i].first - 1;
        char size = winners[i].second;

        int size_index = std::distance(sizes.begin(), std::find(sizes.begin(), sizes.end(), size));

        if (remaining[color][size_index] > 0) {
            remaining[color][size_index]--;
        } else {
            bool found = false;
            for (int s = size_index + 1; s < m; ++s) {
                if (remaining[color][s] > 0) {
                    to_order[color][s]++;
                    remaining[color][s]--;
                    found = true;
                    break;
                }
            }
            if (!found) {
                for (int c = color + 1; c < n; ++c) {
                    if (remaining[c][size_index] > 0) {
                        remaining[c][size_index]--;
                        to_order[c][size_index]++;
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    for (int s = size_index + 1; s < m; ++s) {
                        for (int c = color + 1; c < n; ++c) {
                            if (remaining[c][s] > 0) {
                                remaining[c][s]--;
                                to_order[c][s]++;
                                found = true;
                                break;
                            }
                        }
                        if (found) break;
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << remaining[i][j] << " ";
        }
        std::cout << "\n";
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << to_order[i][j] << " ";
        }
        std::cout << "\n";
    }
}

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<char> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    std::vector<std::vector<int>> quantities(n, std::vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> quantities[i][j];
        }
    }

    int k;
    std::cin >> k;

    std::vector<std::pair<int, char>> winners(k);
    for (int i = 0; i < k; ++i) {
        std::cin >> winners[i].first >> winners[i].second;
    }

    find_remaining_and_order(n, m, sizes, quantities, k, winners);

    return 0;
}
