#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

struct Competitor {
    int id, grade, age, score;
    std::string gender;
};

std::vector<int> getIOITeam(const std::vector<Competitor>& competitors) {
    // Реалізуйте функцію для визначення команди для IOI
}

std::vector<int> getCEOITeam(const std::vector<Competitor>& competitors) {
    // Реалізуйте функцію для визначення команди для CEOI
}

std::vector<int> getEGOITeam(const std::vector<Competitor>& competitors) {
    // Реалізуйте функцію для визначення команди для EGOI
}

// Додайте функції для інших олімпіад
// ...

std::map<std::string, std::vector<int>> getTeams(const std::vector<Competitor>& competitors, const std::vector<std::string>& olympiads) {
    std::map<std::string, std::vector<int>> teams;

    for (const auto& olympiad : olympiads) {
        if (olympiad == "IOI") {
            teams[olympiad] = getIOITeam(competitors);
        } else if (olympiad == "CEOI") {
            teams[olympiad] = getCEOITeam(competitors);
        } else if (olympiad == "EGOI") {
            teams[olympiad] = getEGOITeam(competitors);
        }
        // Додайте умови для інших олімпіад
        // ...
    }

    return teams;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Competitor> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::vector<std::string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> olympiads[i];
    }

    std::map<std::string, std::vector<int>> teams = getTeams(participants, olympiads);

    for (const auto& olympiad : olympiads) {
        std::cout << olympiad << std::endl;
        for (const auto& participant : teams[olympiad]) {
            std::cout << participant << std::endl;
        }
    }

    return 0;
}
