from typing import List, Tuple
from collections import defaultdict

def select_participants(participants: List[Tuple[int, str, int, int, int]], event: str) -> List[Tuple[int, str, int, int, int]]:
    selected = []
    
    if event == "IOI" or event == "CEOI":
        selected = sorted(participants, key=lambda x: (-x[4], x[0]))[:4]
    elif event == "EGOI":
        females = [p for p in participants if p[1] == "female"]
        selected = sorted(females, key=lambda x: (-x[4], x[0]))[:4]
    elif event == "EJOI":
        juniors = [p for p in participants if p[3] <= 15]
        selected = sorted(juniors, key=lambda x: (-x[4], x[0]))[:4]
    elif event == "BaltOI":
        selected = sorted(participants, key=lambda x: (-x[4], x[0]))[:6]
    elif event == "BalkOI":
        non_11_graders = [p for p in participants if p[2] != 11]
        selected = sorted(non_11_graders, key=lambda x: (-x[4], x[0]))[:4]
    elif event == "JBOI":
        non_11_10_graders = [p for p in participants if p[2] not in [11, 10]]
        selected = sorted(non_11_10_graders, key=lambda x: (-x[4], x[0]))[:4]
    
    return selected

n = int(input())
participants = []
for _ in range(n):
    participant = input().split()
    participant[0] = int(participant[0])
    participant[3] = int(participant[3])
    participant[4] = int(participant[4])
    participants.append(tuple(participant))

m = int(input())
events = [input() for _ in range(m)]

participants_dict = defaultdict(list)
for participant in participants:
    participants_dict[participant[0]].extend(participant[1:])

for event in events:
    selected_participants = select_participants(participants, event)
    print(event)
    for participant in selected_participants:
        print(participant[0])
