#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareByScore(const Participant &a, const Participant &b) {
    return a.score > b.score;
}

bool compareByAge(const Participant &a, const Participant &b) {
    return a.age < b.age;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    std::vector<std::string> olympiads(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> olympiads[i];
    }

    std::map<std::string, std::vector<int>> teams;

    for (const auto &olympiad : olympiads) {
        if (olympiad == "IOI" || olympiad == "CEOI") {
            std::vector<Participant> temp = participants;
            std::sort(temp.begin(), temp.end(), compareByScore);
            temp.resize(4);
            std::vector<int> teamMembers;
            for (const auto &member : temp) {
                teamMembers.push_back(member.id);
            }
            teams[olympiad] = teamMembers;
        } else if (olympiad == "EGOI") {
            std::vector<Participant> temp;
            for (const auto &participant : participants) {
                if (participant.gender == "female") {
                    temp.push_back(participant);
                }
            }
            std::sort(temp.begin(), temp.end(), compareByScore);
            temp.resize(4);
            std::vector<int> teamMembers;
            for (const auto &member : temp) {
                teamMembers.push_back(member.id);
            }
            teams[olympiad] = teamMembers;
        } else if (olympiad == "EJOI") {
            std::vector<Participant> temp;
            for (const auto &participant : participants) {
                if (participant.age <= 15) {
                    temp.push_back(participant);
                }
            }
            std::sort(temp.begin(), temp.end(), compareByScore);
            temp.resize(4);
            std::vector<int> teamMembers;
            for (const auto &member : temp) {
                teamMembers.push_back(member.id);
            }
            teams[olympiad] = teamMembers;
        } else if (olympiad == "BaltOI") {
            std::vector<Participant> temp = participants;
            std::sort(temp.begin(), temp.end(), compareByScore);
            temp.resize(6);
            std::vector<int> teamMembers;
            for (const auto &member : temp) {
                teamMembers.push_back(member.id);
            }
            teams[olympiad] = teamMembers;
        } else if (olympiad == "BalkOI") {
            std::vector<Participant> temp;
            for (const auto &participant : participants) {
                if (participant.grade != 11) {
                    temp.push_back(participant);
                }
            }
            std::sort(temp.begin(), temp.end(), compareByScore);
            temp.resize(4);
            std::vector<int> teamMembers;
            for (const auto &member : temp) {
                teamMembers.push_back(member.id);
            }
            teams[olympiad] = teamMembers;
        } else if (olympiad == "JBOI") {
            std::vector<Participant> temp;
            for (const auto &participant : participants) {
                if (participant.grade != 11 && participant.grade != 10) {
                    temp.push_back(participant);
                }
            }
            std::sort(temp.begin(), temp.end(), compareByScore);
            temp.resize(4);
            std::vector<int> teamMembers;
            for (const auto &member : temp) {
                teamMembers.push_back(member.id);
            }
            teams[olympiad] = teamMembers;
        }
    }

    for (const auto &olympiad : olympiads) {
        std::cout << olympiad << std::endl;
        for (const auto &id : teams[olympiad]) {
            std::cout << id << std::endl;
        }
    }

    return 0;
}