def main():
    n, m = map(int, input().split())
    color_counts = list(map(int, input().split()))

    max_length = max(color_counts)  # Знаходимо максимальний відтінок

    # Якщо сума кількостей відтінків менша за кількість, яку потрібно вибрати, то
    # максимальною довжиною підвідрізку буде максимальне значення відтінка
    if sum(color_counts) <= n + m:
        print(max_length)
        return

    left, right = 0, max_length * 2

    # Бінарний пошук для знаходження максимальної можливої довжини підвідрізку
    while left < right:
        mid = (left + right) // 2
        count = 0

        # Підраховуємо кількість відтінків, які можна вибрати
        for i in range(n):
            count += min(color_counts[i], mid)

        # Якщо кількість вибраних відтінків більша або рівна сумі n + m, зменшуємо діапазон пошуку
        if count >= n + m:
            right = mid
        else:
            left = mid + 1

    print(left)

if __name__ == "__main__":
    main()