from collections import defaultdict

def determine_teams(ols, pts):

    res = defaultdict(list)

    for p in pts:

        i, g, gr, a, s = p

        for o in ols:

            if o == 'IOI':
                res['IOI'].append((s, i))

            elif o == 'CEOI':
                res['CEOI'].append((s, i))

            elif o == 'EGOI' and g == 'female':
                res['EGOI'].append((s, i))

            elif o == 'EJOI' and a <= 15:
                res['EJOI'].append((s, i))

            elif o == 'BaltOI':
                res['BaltOI'].append((s, i))

            elif o == 'BalkOI' and gr != 11:
                res['BalkOI'].append((s, i))

            elif o == 'JBOI' and gr < 11:
                res['JBOI'].append((s, i))

    tms = {}

    for o in ols:

        sc_ids = res[o]

        sc_ids.sort(key=lambda x: (-x[0], x[1]))  # Sort scores descending, IDs ascending

        t_size = determine_size(o, len(sc_ids))

        tms[o] = [p[1] for p in sc_ids[:t_size]]

        tms[o].sort()

    return tms

def determine_size(ol, num_pts):

    if ol in ['IOI', 'CEOI']:
        return min(4, num_pts)

    elif ol == 'EGOI':
        return min(4, num_pts)

    elif ol == 'EJOI':
        return min(4, num_pts)

    elif ol == 'BaltOI':
        return min(6, num_pts)

    elif ol == 'BalkOI':
        return min(4, num_pts)

    elif ol == 'JBOI':
        return min(4, num_pts)

    else:
        return 0

n = int(input())

pts = []

for _ in range(n):

    dt = input().split()

    i, g, gr, a, s = int(dt[0]), dt[1], int(dt[2]), int(dt[3]), int(dt[4])

    pts.append((i, g, gr, a, s))

m = int(input())

ols = [input().strip() for _ in range(m)]

teams = determine_teams(ols, pts)

for ol in ols:

    print(ol)

    for p in teams[ol]:

        print(p)
