#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>

struct Participant {
    int id, grade, age, score;
    std::string gender;

    Participant() : id(0), grade(0), age(0), score(0), gender("") {}
    Participant(int id, std::string gender, int grade, int age, int score)
        : id(id), gender(gender), grade(grade), age(age), score(score) {}
};

int main() {
    int n, m;
    std::cin >> n;
    std::vector<Participant> participants;

    for (int i = 0; i < n; ++i) {
        int id, grade, age, score;
        std::string gender;
        std::cin >> id >> gender >> grade >> age >> score;
        participants.emplace_back(id, gender, grade, age, score);
    }

    std::cin >> m;
    std::vector<std::string> inputOlympiads(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> inputOlympiads[i];
    }

    for (const auto& olympiad : inputOlympiads) {
        std::vector<Participant> filtered;
        for (const auto& p : participants) {
            if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI" ||
                (olympiad == "EGOI" && p.gender == "female") ||
                (olympiad == "EJOI" && p.age <= 15) ||
                (olympiad == "BalkOI" && p.grade != 11) ||
                (olympiad == "JBOI" && p.grade != 11 && p.grade != 10)) {
                filtered.push_back(p);
            }
        }

        std::sort(filtered.begin(), filtered.end(), [](const Participant& a, const Participant& b) {
            return a.score > b.score;
        });

        int teamSize = (olympiad == "BaltOI") ? 6 : 4;
        if (filtered.size() > teamSize) {
            filtered.resize(teamSize);
        }

        std::sort(filtered.begin(), filtered.end(), [](const Participant& a, const Participant& b) {
            return a.id < b.id;
        });

        std::cout << olympiad << "\n";
        for (const auto& p : filtered) {
            std::cout << p.id << "\n";
        }
    }

    return 0;
}
