def process_gifts(n, m, sizes, available, winners):
    leftover = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for winner in winners:
        color, size = int(winner[0]) - 1, winner[1]
        size_index = sizes.index(size)

        if available[color][size_index] > 0:
            available[color][size_index] -= 1
        else:
            alt_color = min(range(n), key=lambda c: (available[c][size_index], c))
            available[alt_color][size_index] -= 1

        leftover[color][size_index] += 1

    for color in range(n):
        for size in range(m):
            to_order[color][size] = max(0, leftover[color][size] - available[color][size])

    return leftover, to_order


n, m = map(int, input().split())
sizes = input().split()
available = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]

leftover, to_order = process_gifts(n, m, sizes, available, winners)

for row in leftover:
    print(*row)

for row in to_order:
    print(*row)
