import java.util.Scanner;

public class FootballShirts {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int m = scanner.nextInt();

        String[] sizes = new String[m];
        for (int i = 0; i < m; i++) {
            sizes[i] = scanner.next();
        }

        int[][] shirtsAvailable = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                shirtsAvailable[i][j] = scanner.nextInt();
            }
        }

        int k = scanner.nextInt();
        for (int i = 0; i < k; i++) {
            int teamColor = scanner.nextInt() - 1;
            String teamSize = scanner.next();

            int sizeIndex = findSizeIndex(sizes, teamSize);
            int remaining = findAndRemove(shirtsAvailable, teamColor, sizeIndex);

            if (remaining == 0) {
                int nextSizeIndex = findNextSizeIndex(sizes, sizeIndex);
                remaining = findAndRemove(shirtsAvailable, teamColor, nextSizeIndex);
            }

            System.out.print(remaining + " ");
        }

        scanner.close();
    }

    private static int findSizeIndex(String[] sizes, String size) {
        for (int i = 0; i < sizes.length; i++) {
            if (sizes[i].equals(size)) {
                return i;
            }
        }
        return -1;
    }

    private static int findAndRemove(int[][] shirtsAvailable, int color, int sizeIndex) {
        if (shirtsAvailable[color][sizeIndex] > 0) {
            shirtsAvailable[color][sizeIndex]--;
            return shirtsAvailable[color][sizeIndex];
        }
        return 0;
    }

    private static int findNextSizeIndex(String[] sizes, int currentSizeIndex) {
        for (int i = currentSizeIndex + 1; i < sizes.length; i++) {
            if (sizes[i].compareTo(sizes[currentSizeIndex]) > 0) {
                return i;
            }
        }
        return currentSizeIndex;
    }
}