def select_participants(olympiads, participants):
    teams = {
        "IOI": [],
        "CEOI": [],
        "EGOI": [],
        "EJOI": [],
        "BaltOI": [],
        "BalkOI": [],
        "JBOI": []
    }

    for olympiad in olympiads:
        if olympiad == "IOI" or olympiad == "CEOI":
            for participant in participants:
                if len(teams[olympiad]) < 4:
                    teams[olympiad].append(participant)
        elif olympiad == "EGOI":
            female_participants = [p for p in participants if p['gender'] == 'female']
            for participant in female_participants:
                if len(teams[olympiad]) < 4:
                    teams[olympiad].append(participant)
        elif olympiad == "EJOI":
            young_participants = [p for p in participants if p['age'] <= 15]
            for participant in young_participants:
                if len(teams[olympiad]) < 4:
                    teams[olympiad].append(participant)
        elif olympiad == "BaltOI":
            sorted_participants = sorted(participants, key=lambda x: x['score'], reverse=True)
            for participant in sorted_participants:
                if len(teams[olympiad]) < 6:
                    teams[olympiad].append(participant)
        elif olympiad == "BalkOI":
            non_11th_graders = [p for p in participants if p['grade'] != 11]
            for participant in non_11th_graders:
                if len(teams[olympiad]) < 4:
                    teams[olympiad].append(participant)
        elif olympiad == "JBOI":
            non_11th_or_10th_graders = [p for p in participants if p['grade'] != 11 and p['grade'] != 10]
            for participant in non_11th_or_10th_graders:
                if len(teams[olympiad]) < 4:
                    teams[olympiad].append(participant)

    for olympiad in olympiads:
        print(olympiad)
        team_ids = sorted([participant['id'] for participant in teams[olympiad]])
        print(*team_ids)

# Приклад вхідних даних
n = 6
participants = [
    {'id': 1000000, 'gender': 'male', 'grade': 10, 'age': 16, 'score': 87},
    {'id': 1000001, 'gender': 'female', 'grade': 11, 'age': 18, 'score': 92},
    {'id': 1000002, 'gender': 'female', 'grade': 9, 'age': 15, 'score': 80},
    {'id': 1000003, 'gender': 'male', 'grade': 11, 'age': 17, 'score': 90},
    {'id': 1000004, 'gender': 'male', 'grade': 10, 'age': 16, 'score': 85},
    {'id': 1000005, 'gender': 'female', 'grade': 10, 'age': 15, 'score': 88}
]

m = 4
olympiads = ['EGOI', 'IOI', 'BalkOI', 'JBOI']

select_participants(olympiads, participants)
