#include <bits/stdc++.h>
#include <algorithm>
#include <vector>
#include <string>
#include <utility>

void algorithm(
    std::vector<std::vector<int>>& nShirt,
    const std::vector<std::pair<int, int>>& orders
);

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);

    // Read input data
    int nSize, nColor;
    std::cin >> nColor;
    std::cin >> nSize;

    std::vector<std::string> sizes(nSize);
    for (int i = 0; i < nSize; ++i) {
        std::cin >> sizes[i];
    }

    // number of available T-shirts [ color ; size ]
    std::vector<std::vector<int>> nShirt(nColor);
    for (auto& t : nShirt) {
        t.resize(nSize);
        for (auto& p : t) {
            std::cin >> p;
        }
    }

    int nWinner;
    std::cin >> nWinner;

    std::vector<std::pair<int, int>> orders(nWinner);
    for (auto& pair : orders) {
        std::cin >> pair.first;
        --pair.first;
        std::string t;
        std::cin >> t;
        pair.second = std::distance(sizes.begin(), std::find(sizes.begin(), sizes.end(), t));
    }

    // Main algorithm
    algorithm(nShirt, orders);

    // Output
    for (auto& t : nShirt) {
        for (auto& p : t) {
            std::cout << std::max(0, p) << ' ';
            if (p > 0) { p = 0; }
        }
        std::cout << std::endl;
    }
    
    for (auto t : nShirt) {
        for (auto p : t) {
            std::cout << std::max(-p, 0) << ' ';
        }
        std::cout << std::endl;
    }
}

void algorithm(
    std::vector<std::vector<int>>& nShirt,
    const std::vector<std::pair<int, int>>& orders
) {
    for (auto pair : orders) {
        int i0 = pair.first, j0 = pair.second;
        [&] {
            for (int i = i0; i < nShirt.size(); ++i) {
                for (int j = j0; j < nShirt[0].size(); ++j) {
                    if (nShirt[i][j] != 0) {
                        i0 = i, j0 = j;
                        return;
                    }
                }
            }
        }();
        --nShirt[i0][j0];
    }
}