def create_ornament(n, m):
    ornament = [['.' for _ in range(m)] for _ in range(n)]

    # Add the upper rays
    for i in range(min(n, m)):
        ornament[i][i] = 'x'
        ornament[i][m - 1 - i] = 'x'

    # Reflect the rays when they touch the vertical edge
    for i in range(n):
        j = min(i, m - 1 - i)
        while j > 0:
            ornament[i][j] = 'x'
            ornament[i][m - 1 - j] = 'x'
            j -= 1

    # Print the ornament
    for row in ornament:
        print(''.join(row))

# Input
n, m = map(int, input().split())

# Output
create_ornament(n, m)
