def determine_teams(participants, olympiads):
    # Sort participants based on their scores in descending order
    participants.sort(key=lambda x: (-x[4], x[0]))

    team_compositions = {}
    
    for olympiad in olympiads:
        if olympiad == "IOI":
            team_compositions["IOI"] = [participant[0] for participant in participants[:4]]
        elif olympiad == "CEOI":
            team_compositions["CEOI"] = [participant[0] for participant in participants[:4]]
        elif olympiad == "EGOI":
            # Select top 4 female participants
            female_participants = [participant for participant in participants if participant[1] == "female"]
            team_compositions["EGOI"] = [participant[0] for participant in female_participants[:4]]
        elif olympiad == "EJOI":
            # Select top 4 participants at most 15 years old
            young_participants = [participant for participant in participants if participant[3] <= 15]
            team_compositions["EJOI"] = [participant[0] for participant in young_participants[:4]]
        elif olympiad == "BaltOI":
            team_compositions["BaltOI"] = [participant[0] for participant in participants[:6]]
        elif olympiad == "BalkOI":
            # Select top 4 participants who are not in 11th grade
            non_11th_graders = [participant for participant in participants if participant[2] < 11]
            team_compositions["BalkOI"] = [participant[0] for participant in non_11th_graders[:4]]
        elif olympiad == "JBOI":
            # Select top 4 participants who are not in 11th or 10th grade
            non_11th_10th_graders = [participant for participant in participants if participant[2] < 10]
            team_compositions["JBOI"] = [participant[0] for participant in non_11th_10th_graders[:4]]
    
    return team_compositions

def main():
    n = int(input())
    participants = []

    for _ in range(n):
        participant_info = input().split()
        participants.append((int(participant_info[0]), participant_info[1], int(participant_info[2]), int(participant_info[3]), int(participant_info[4])))

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    team_compositions = determine_teams(participants, olympiads)

    for olympiad in olympiads:
        print(olympiad)
        team_ids = team_compositions[olympiad]
        team_ids.sort()
        for participant_id in team_ids:
            print(participant_id)

if __name__ == "__main__":
    main()
