def count_unmarked_colors(mid, color_wheels):
    count = 0
    for wheel in color_wheels:
        wheel_count = min(wheel, mid)
        count += (wheel_count + 1) // 2
    return count

def find_max_length(n, m, color_wheels):
    left, right = 0, max(color_wheels)
    
    while left < right:
        mid = (left + right + 1) // 2
        if count_unmarked_colors(mid, color_wheels) > m:
            right = mid - 1
        else:
            left = mid

    return left

# Input reading
n, m = map(int, input().split())
color_wheels = list(map(int, input().split()))

# Output
result = find_max_length(n, m, color_wheels)
print(result)
