def max_sequence_length(n, m, a):
    a.sort(reverse=True)  # Sort the color wheel sizes in descending order
    total_length = 0  # Total length of unmarked color sequences

    for i in range(n):
        length = a[i] - 1  # Initial length of unmarked color sequence for the current wheel
        total_length += length

        # Update total_length based on whether Miss M will select an odd or even length sequence
        if length % 2 == 0:
            total_length += 1

    # Subtract 1 to account for the initial color that Miss M already selected
    remaining_selections = m - 1

    # Calculate the maximum length of the sequence before selecting the (m + 1)-th color
    max_length = total_length - min(remaining_selections, total_length)

    return max_length

# Input reading
n, m = map(int, input().split())
a = list(map(int, input().split()))

# Output the result
result = max_sequence_length(n, m, a)
print(result)
