def max_sequence_length(n, m, colors):
    # Sort the colors in descending order to make it easier to find the longest sequence
    colors.sort(reverse=True)
    
    # Initialize the maximum sequence length
    max_length = 0
    
    # Iterate until Miss M selects all m colors
    for _ in range(m):
        # Find the index of the longest sequence
        max_index = colors.index(max(colors))
        
        # Get the length of the longest sequence
        length = colors[max_index]
        
        # Update the maximum sequence length if necessary
        if length > max_length:
            max_length = length
        
        # Update the length of the sequence (odd or even)
        if length % 2 == 0:
            colors[max_index] //= 2
        else:
            colors[max_index] = (length // 2) + 1
    
    return max_length

# Read input
n, m = map(int, input().split())
colors = list(map(int, input().split()))

# Calculate and print the maximum length of unmarked color sequences
result = max_sequence_length(n, m, colors)
print(result)
