#include <iostream>
#include <vector>

using namespace std;

void printMatrix(vector<vector<char>> &matrix) {
    for (int i = 0; i < matrix.size(); i++) {
        for (int j = 0; j < matrix[i].size(); j++) {
            cout << matrix[i][j];
        }
        cout << endl;
    }
}

void createOrnament(vector<vector<char>> &matrix, int x, int y) {
    if (x < 0 || y < 0 || x >= matrix.size() || y >= matrix[0].size()) {
        return;
    }

    if (matrix[x][y] == ' ') {
        matrix[x][y] = '*';
        createOrnament(matrix, x - 1, y + 1);
        createOrnament(matrix, x + 1, y + 1);
    }
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<char>> matrix(n, vector<char>(m, ' '));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            createOrnament(matrix, i, j);
        }
    }

    printMatrix(matrix);

    return 0;
}