def find_max_subsequence(n, m, a):
    queue = [(-1, 0)] * n
    result = 0
    left = right = 0

    for i in range(1, n+1):
        left, right = right, right + a[i-1] - 1
        queue[i-1] = (left, right)

    for i in range(n, n+m):
        min_left, max_right = float('inf'), float('-inf')

        for j in range(n):
            left, right = queue[j]
            if right >= i:
                min_left = min(min_left, left)
                max_right = max(max_right, right)

        queue.append((min_left, max_right))
        queue.pop(0)

        if min_left <= i <= max_right:
            result = max(result, i - min_left + 1)

    return result


def main():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))
    result = find_max_subsequence(n, m, a)
    print(result)


if __name__ == "__main__":
    main()