#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

struct Participant {
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant& p1, const Participant& p2) {
    return p1.score > p2.score;
}

int n, m;
unordered_map<string, int> teamSize;
string olympiad;

int main() {
    cin >> n;
    vector<Participant> participants(n);
    for (int i = 0; i < n; i++) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade
            >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    cin >> m;

    teamSize["IOI"] = 4;
    teamSize["CEOI"] = 4;
    teamSize["EGOI"] = 4;
    teamSize["EJOI"] = 4;
    teamSize["BaltOI"] = 6;
    teamSize["BalkOI"] = 4;
    teamSize["JBOI"] = 4;

    for (int i = 0; i < m; i++) {
        cin >> olympiad;

        vector<Participant> selectedParticipants;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            for (const auto& participant : participants) {
                if (selectedParticipants.size() == teamSize[olympiad]) {
                    break;
                }

                selectedParticipants.push_back(participant);
            }
        }
        else if (olympiad == "EGOI") {
            for (const auto& participant : participants) {
                if (selectedParticipants.size() == teamSize[olympiad] && participant.gender == "female") {
                    break;
                }

                if (participant.gender == "female") {
                    selectedParticipants.push_back(participant);
                }
            }
        }
        else if (olympiad == "EJOI" || olympiad == "BalkOI") {
            int ageLimit = (olympiad == "EJOI") ? 15 : 10;

            for (const auto& participant : participants) {
                if (selectedParticipants.size() == teamSize[olympiad] && participant.age >= ageLimit) {
                    break;
                }

                if (participant.age < ageLimit) {
                    selectedParticipants.push_back(participant);
                }
            }
        }
        else if (olympiad == "JBOI") {
            for (const auto& participant : participants) {
                if (selectedParticipants.size() == teamSize[olympiad] && (participant.grade == 11 || participant.grade == 10)) {
                    break;
                }

                if (participant.grade < 10) {
                    selectedParticipants.push_back(participant);
                }
            }
        }

        cout << olympiad << endl;
        for (const auto& participant : selectedParticipants) {
            cout << participant.id << endl;
        }
    }

    return 0;
}
