import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Читання вхідних даних
        int n = scanner.nextInt(); // кількість різних кольорів
        int m = scanner.nextInt(); // кількість розмірів
        String[] sizes = new String[m]; // розміри футболок
        for (int i = 0; i < m; i++) {
            sizes[i] = scanner.next();
        }

        int[][] available = new int[n][m]; // кількість доступних футболок
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                available[i][j] = scanner.nextInt();
            }
        }

        int k = scanner.nextInt(); // кількість переможців

        // Зберігає кількість футболок кожного розміру, які не можна видати
        int[][] notGiven = new int[n][m];

        for (int i = 0; i < k; i++) {
            int c = scanner.nextInt(); // колір
            String s = scanner.next(); // розмір

            int sizeIndex = indexOf(sizes, s);

            // Логіка видачі футболок та оновлення кількості футболок
            if (available[c - 1][sizeIndex] > 0) {
                available[c - 1][sizeIndex]--;
            } else {
                notGiven[c - 1][sizeIndex]++;
            }
        }

        // Виведення результатів
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                System.out.print(notGiven[i][j] + " ");
            }
            System.out.println();
        }
    }

    // Метод для знаходження індексу розміру в масиві розмірів
    private static int indexOf(String[] sizes, String size) {
        for (int i = 0; i < sizes.length; i++) {
            if (sizes[i].equals(size)) {
                return i;
            }
        }
        return -1;
    }
}