def allocate_gifts(n, m, sizes, inventory, winners):
    remaining_inventory = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for i in range(n):
        for j in range(m):
            remaining_inventory[i][j] = inventory[i][j]

    for winner in winners:
        color, size = winner[0], winner[1]
        size_index = sizes.index(size)

        if remaining_inventory[color][size_index] > 0:
            remaining_inventory[color][size_index] -= 1
        else:
            found_alternative = False

            for alt_size_index in range(size_index + 1, m):
                if remaining_inventory[color][alt_size_index] > 0:
                    to_order[color][alt_size_index] += 1
                    remaining_inventory[color][alt_size_index] -= 1
                    found_alternative = True
                    break

            if not found_alternative:
                for alt_size_index in range(size_index):
                    if remaining_inventory[color][alt_size_index] > 0:
                        to_order[color][alt_size_index] += 1
                        remaining_inventory[color][alt_size_index] -= 1
                        found_alternative = True
                        break

            if not found_alternative:
                to_order[color][size_index] += 1

    for i in range(n):
        print(" ".join(map(str, remaining_inventory[i])))

    for i in range(n):
        print(" ".join(map(str, to_order[i])))



n, m = map(int, input().split())
sizes = input().split()

inventory = []
for _ in range(n):
    row = list(map(int, input().split()))
    inventory.append(row)

k = int(input())
winners = []
for _ in range(k):
    winner = input().split()
    winners.append((int(winner[0]) - 1, sizes.index(winner[1])))


allocate_gifts(n, m, sizes, inventory, winners)
