def team_composition(participants, olympiad):
    if olympiad == "IOI" or olympiad == "CEOI":
        sorted_participants = sorted(participants, key=lambda x: x[4], reverse=True)
        team = sorted_participants[:min(4, len(sorted_participants))]
        return team
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        sorted_female_participants = sorted(female_participants, key=lambda x: x[4], reverse=True)
        team = sorted_female_participants[:min(4, len(sorted_female_participants))]
        return team
    elif olympiad == "EJOI":
        under_15_participants = [p for p in participants if p[3] <= 15]
        sorted_under_15_participants = sorted(under_15_participants, key=lambda x: x[4], reverse=True)
        team = sorted_under_15_participants[:min(4, len(sorted_under_15_participants))]
        return team
    elif olympiad == "BaltOI":
        sorted_participants = sorted(participants, key=lambda x: x[4], reverse=True)
        team = sorted_participants[:min(6, len(sorted_participants))]
        return team
    elif olympiad == "BalkOI":
        not_11th_graders = [p for p in participants if p[2] != 11]
        sorted_not_11th_graders = sorted(not_11th_graders, key=lambda x: x[4], reverse=True)
        team = sorted_not_11th_graders[:min(4, len(sorted_not_11th_graders))]
        return team
    elif olympiad == "JBOI":
        not_11th_10th_graders = [p for p in participants if p[2] not in [10, 11]]
        sorted_not_11th_10th_graders = sorted(not_11th_10th_graders, key=lambda x: x[4], reverse=True)
        team = sorted_not_11th_10th_graders[:min(4, len(sorted_not_11th_10th_graders))]
        return team

def main():
    n = int(input())
    participants = []
    for _ in range(n):
        participant_info = input().split()
        participant = (int(participant_info[0]), participant_info[1], int(participant_info[2]),
                       int(participant_info[3]), int(participant_info[4]))
        participants.append(participant)

    m = int(input())
    olympiads = [input().strip() for _ in range(m)]

    for olympiad in olympiads:
        team = team_composition(participants, olympiad)
        team_ids = sorted([member[0] for member in team])
        print(olympiad)
        for participant_id in team_ids:
            print(participant_id)

if __name__ == "__main__":
    main()
