def max_unmarked_sequence(n, m, a):
    total_colors = sum(a)
    
    # If Miss M wants to choose all remaining colors, the maximum length
    # of the sequence of unmarked colors will be the sum of all colors.
    if m == total_colors:
        return total_colors
    
    # Otherwise, find the maximum length of the unmarked sequence
    # considering the possibility that Miss M will choose m additional colors.
    max_length = 0
    remaining_colors = total_colors
    for color_count in a:
        if remaining_colors >= m:
            # The remaining colors are sufficient to choose m additional colors,
            # so the maximum length is the sum of the colors minus m.
            max_length = max(max_length, total_colors - m)
        else:
            # Miss M will choose all remaining colors,
            # and the maximum length is the number of unmarked colors.
            max_length = max(max_length, color_count)
        
        remaining_colors -= color_count
    
    return max_length

def main():
    n, m = map(int, input().split())
    a = list(map(int, input().split()))

    result = max_unmarked_sequence(n, m, a)
    print(result)

if __name__ == "__main__":
    main()
