#include <iostream>
#include <vector>

int findOptimalBox(const std::vector<int>& weights, const std::vector<int>& boxes) {
    int totalWeightBox1 = (boxes[0] == 1) ? weights[0] : 0;
    int totalWeightBox2 = (boxes[0] == 2) ? weights[0] : 0;

    for (int i = 1; i < 4; i++) {
        if (boxes[i] == 1) {
            totalWeightBox1 += weights[i];
        } else {
            totalWeightBox2 += weights[i];
        }
    }

    if (totalWeightBox1 >= totalWeightBox2) {
        return (boxes[0] == 1) ? -1 : 1;
    } else {
        return (boxes[0] == 2) ? -1 : 2;
    }
}

int main() {
    std::vector<int> weights(4);
    std::vector<int> boxes(4);

    for (int i = 0; i < 4; i++) {
        std::cin >> weights[i];
    }

    for (int i = 0; i < 4; i++) {
        std::cin >> boxes[i];
    }

    int optimalBox = findOptimalBox(weights, boxes);
    std::cout << optimalBox << std::endl;

    return 0;
}
