def main():
    # Input
    n, m = map(int, input().split())
    sizes = input().split()
    inventory = [list(map(int, input().split())) for _ in range(n)]
    num_winners = int(input())
    winners = [input().split() for _ in range(num_winners)]

    # Process winners
    remaining_inventory, to_order = process_winners(n, m, sizes, inventory, winners)

    # Output remaining inventory
    for row in remaining_inventory:
        print(" ".join(map(str, row)))

    # Output what to order
    for row in to_order:
        print(" ".join(map(str, row)))


def process_winners(n, m, sizes, inventory, winners):
    remaining_inventory = [[0] * m for _ in range(n)]
    to_order = [[0] * m for _ in range(n)]

    for i in range(n):
        for j in range(m):
            remaining_inventory[i][j] = inventory[i][j]

    for winner in winners:
        color_index = int(winner[0]) - 1
        size = winner[1]

        size_index = sizes.index(size)

        if remaining_inventory[color_index][size_index] > 0:
            remaining_inventory[color_index][size_index] -= 1
        else:
            found = False
            for new_size_index in range(size_index + 1, m):
                if remaining_inventory[color_index][new_size_index] > 0:
                    remaining_inventory[color_index][new_size_index] -= 1
                    to_order[color_index][new_size_index] += 1
                    found = True
                    break

            if not found:
                for new_size_index in range(size_index + 1, m):
                    for new_color_index in range(n):
                        if remaining_inventory[new_color_index][new_size_index] > 0:
                            remaining_inventory[new_color_index][new_size_index] -= 1
                            to_order[new_color_index][new_size_index] += 1
                            found = True
                            break
                    if found:
                        break

    return remaining_inventory, to_order


if __name__ == "__main__":
    main()


