import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        long m = scanner.nextLong();
        long[] a = new long[n];

        for (int i = 0; i < n; i++) {
            a[i] = scanner.nextLong();
        }

        long result = findMaxSubarrayLength(n, m, a);
        System.out.println(result);
    }

    private static long findMaxSubarrayLength(int n, long m, long[] a) {
        long left = 1;
        long right = (long)1e18;

        while (left < right) {
            long mid = (left + right) / 2;

            if (check(n, m, a, mid)) {
                left = mid + 1;
            } else {
                right = mid;
            }
        }

        return left - 1;
    }

    private static boolean check(int n, long m, long[] a, long length) {
        long sum = 0;

        for (int i = 0; i < n; i++) {
            sum += Math.min(a[i], length + 1);
        }

        return sum >= m;
    }
}
