def determine_team(olympiad, participants):
    team = []
    if olympiad == "IOI":
        participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in participants[:4]]
    elif olympiad == "CEOI":
        participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in participants[:4]]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p['gender'] == 'female']
        female_participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in female_participants[:4]]
    elif olympiad == "EJOI":
        junior_participants = [p for p in participants if p['age'] <= 15]
        junior_participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in junior_participants[:4]]
    elif olympiad == "BaltOI":
        participants.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in participants[:6]]
    elif olympiad == "BalkOI":
        non_11th_graders = [p for p in participants if p['grade'] != 11]
        non_11th_graders.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in non_11th_graders[:4]]
    elif olympiad == "JBOI":
        non_11th_10th_graders = [p for p in participants if p['grade'] != 11 and p['grade'] != 10]
        non_11th_10th_graders.sort(key=lambda x: x['score'], reverse=True)
        team = [p['id'] for p in non_11th_10th_graders[:4]]

    return team

n = int(input())
participants = []
for _ in range(n):
    participant_info = input().split()
    participants.append({
        'id': int(participant_info[0]),
        'gender': participant_info[1],
        'grade': int(participant_info[2]),
        'age': int(participant_info[3]),
        'score': int(participant_info[4])
    })

m = int(input())
olympiads = []
for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)

for olympiad in olympiads:
    team = determine_team(olympiad, participants)
    print(olympiad)
    team.sort()
    for participant_id in team:
        print(participant_id)
    print('')
