class Participant:
    def __init__(self, id, gender, grade, age, score):
        self.id = id
        self.gender = gender
        self.grade = grade
        self.age = age
        self.score = score

    def __lt__(self, other):
        return self.score > other.score

def get_team(olympiad, participants):
    if olympiad == "IOI" or olympiad == "CEOI":
        return sorted(participants)[:4]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p.gender == "female"]
        return sorted(female_participants)[:4]
    elif olympiad == "EJOI":
        young_participants = [p for p in participants if p.age <= 15]
        return sorted(young_participants)[:4]
    elif olympiad == "BaltOI":
        return sorted(participants)[:6]
    elif olympiad == "BalkOI":
        non_senior_participants = [p for p in participants if p.grade < 11]
        return sorted(non_senior_participants)[:4]
    elif olympiad == "JBOI":
        non_senior_participants = [p for p in participants if p.grade < 11 and p.grade > 9]
        return sorted(non_senior_participants)[:4]
    return None

n = int(input())
participants = []

for _ in range(n):
    id, gender, grade, age, score = input().split()
    participants.append(Participant(int(id), gender, int(grade), int(age), int(score)))

m = int(input())
olympiads = []

for _ in range(m):
    olympiad = input()
    olympiads.append(olympiad)

for olympiad in olympiads:
    team = get_team(olympiad, participants)
    if team is not None:
        print(olympiad)
        for participant in team:
            print(participant.id)
