def main():
    # Введення кількості учасників
    n = int(input())

    # Зберігання інформації про учасників
    participants = []
    for _ in range(n):
        participant_info = input().split()
        participants.append({
            'id': int(participant_info[0]),
            'gender': participant_info[1],
            'grade': int(participant_info[2]),
            'age': int(participant_info[3]),
            'score': int(participant_info[4])
        })

    # Введення кількості міжнародних олімпіад
    m = int(input())

    # Зберігання назв міжнародних олімпіад
    olympiads = [input().strip() for _ in range(m)]

    # Формування команд для кожної міжнародної олімпіади
    for olympiad in olympiads:
        # Вибір відповідного алгоритму для даної олімпіади
        if olympiad == 'IOI':
            algorithm = ioi_algorithm
        elif olympiad == 'CEOI':
            algorithm = ceoi_algorithm
        elif olympiad == 'EGOI':
            algorithm = egoi_algorithm
        elif olympiad == 'EJOI':
            algorithm = ejoi_algorithm
        elif olympiad == 'BaltOI':
            algorithm = baltoi_algorithm
        elif olympiad == 'BalkOI':
            algorithm = balkoi_algorithm
        elif olympiad == 'JBOI':
            algorithm = jboi_algorithm

        # Виклик алгоритму та вивід результатів
        teams = algorithm(participants)
        print_team(teams)


def ioi_algorithm(participants):
    # Сортування учасників за балами у спадаючому порядку
    sorted_participants = sorted(participants, key=lambda x: x['score'], reverse=True)
    # Вибір топ-4 учасників
    return sorted_participants[:4]


def ceoi_algorithm(participants):
    # Сортування учасників за балами у спадаючому порядку
    sorted_participants = sorted(participants, key=lambda x: x['score'], reverse=True)
    # Вибір топ-4 учасників
    return sorted_participants[:4]


def egoi_algorithm(participants):
    # Відбір топ-4 дівчат
    female_participants = [p for p in participants if p['gender'] == 'female']
    sorted_female_participants = sorted(female_participants, key=lambda x: x['score'], reverse=True)
    return sorted_female_participants[:4]


def ejoi_algorithm(participants):
    # Відбір топ-4 учасників, які не старші 15 років
    under_15_participants = [p for p in participants if p['age'] <= 15]
    sorted_under_15_participants = sorted(under_15_participants, key=lambda x: x['score'], reverse=True)
    return sorted_under_15_participants[:4]


def baltoi_algorithm(participants):
    # Сортування учасників за балами у спадаючому порядку
    sorted_participants = sorted(participants, key=lambda x: x['score'], reverse=True)
    # Вибір топ-6 учасників
    return sorted_participants[:6]


def balkoi_algorithm(participants):
    # Відбір топ-4 учасників, які не є 11-класниками
    non_11th_grade_participants = [p for p in participants if p['grade'] != 11]
    sorted_non_11th_grade_participants = sorted(non_11th_grade_participants, key=lambda x: x['score'], reverse=True)
    return sorted_non_11th_grade_participants[:4]


def jboi_algorithm(participants):
    # Відбір топ-4 учасників, які не є 11 або 10-класниками
    non_11th_or_10th_grade_participants = [p for p in participants if p['grade'] not in {10, 11}]
    sorted_non_11th_or_10th_grade_participants = sorted(
        non_11th_or_10th_grade_participants, key=lambda x: x['score'], reverse=True
    )
    return sorted_non_11th_or_10th_grade_participants[:4]


def print_team(team):
    # Вивід інформації про склад команди
    for participant in team:
        print(participant['id'], end=' ')
    print()


if __name__ == "__main__":
    main()