#include <iostream>
#include <algorithm>

using namespace std;

struct Participant{
    int id;
    string gender;
    int grade;
    int age;
    int score;
};

bool cmp(Participant &p_1, Participant &p_2){
    return p_1.score > p_2.score;
}

int convert_olymp(string olymp){
    if (olymp == "IOI")
        return 1;
    if (olymp == "CEOI")
        return 2;
    if (olymp == "EGOI")
        return 3;
    if (olymp == "EJOI")
        return 4;
    if (olymp == "BaltOI")
        return 5;
    if (olymp == "BalkOI")
        return 6;
    if (olymp == "JBOI")
        return 7;
    return -1;
}

int main() {
    int q_part; cin >> q_part;
    Participant participants[q_part];
    for (Participant &i : participants){
        cin >> i.id >> i.gender >> i.grade >> i.age >> i.score;
    }
    sort(participants, participants + q_part, cmp);

    int q_olymp; cin >> q_olymp;
    string c_olymp;
    for(int q = 0; q < q_olymp; q++){
        cin >> c_olymp;
        int res[6], cnt_part, i;

        switch (convert_olymp(c_olymp)){
            case 1:
                cnt_part = 0, i = 0;
                while (cnt_part < 4 && i < q_part){
                    res[cnt_part] = participants[i].id;
                    ++i; ++cnt_part;
                }

                cout << "IOI\n";
                sort(res, res+cnt_part);
                for (int i = 0; i < cnt_part; i++)
                    cout << res[i] << '\n';
                cout << '\n';

                break;
            case 2:
                cnt_part = 0, i = 0;
                while (cnt_part < 4 && i < q_part){
                    res[cnt_part] = participants[i].id;
                    ++i; ++cnt_part;
                }

                cout << "CEOI\n";
                sort(res, res+cnt_part);
                for (int i = 0; i < cnt_part; i++)
                    cout << res[i] << '\n';
                cout << '\n';

                break;
            case 3:
                cnt_part = 0, i = 0;
                while (cnt_part < 4 && i < q_part){
                    if (participants[i].gender == "female"){
                        res[cnt_part] = participants[i].id;
                        ++cnt_part;
                    }
                    ++i;
                }

                cout << "EGOI\n";
                sort(res, res+cnt_part);
                for (int i = 0; i < cnt_part; i++)
                    cout << res[i] << '\n';
                cout << '\n';

                break;
            case 4:
                cnt_part = 0, i = 0;
                while (cnt_part < 4 && i < q_part){
                    if (participants[i].age <= 15){
                        res[cnt_part] = participants[i].id;
                        ++cnt_part;
                    }
                    ++i;
                }

                cout << "EJOI\n";
                sort(res, res+cnt_part);
                for (int i = 0; i < cnt_part; i++)
                    cout << res[i] << '\n';
                cout << '\n';

                break;
            case 5:
                cnt_part = 0, i = 0;
                while (cnt_part < 6 && i < q_part){
                    res[cnt_part] = participants[i].id;
                    ++cnt_part;
                    ++i;
                }

                cout << "BaltOI\n";
                sort(res, res+cnt_part);
                for (int i = 0; i < cnt_part; i++)
                    cout << res[i] << '\n';
                cout << '\n';

                break;
            case 6:
                cnt_part = 0, i = 0;
                while (cnt_part < 4 && i < q_part){
                    if (participants[i].grade <= 10){
                        res[cnt_part] = participants[i].id;
                        ++cnt_part;
                    }
                    ++i;
                }

                cout << "BalkOI\n";
                sort(res, res+cnt_part);
                for (int i = 0; i < cnt_part; i++)
                    cout << res[i] << '\n';
                cout << '\n';

                break;
            case 7:
                cnt_part = 0, i = 0;
                while (cnt_part < 4 && i < q_part){
                    if (participants[i].grade <= 9){
                        res[cnt_part] = participants[i].id;
                        ++cnt_part;
                    }
                    ++i;
                }

                cout << "JBOI\n";
                sort(res, res+cnt_part);
                for (int i = 0; i < cnt_part; i++)
                    cout << res[i] << '\n';
                cout << '\n';

                break;
        }
    }

    return 0;
}
