#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

struct Participant {
    int id, grade, age, score;
    string gender;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score || (a.score == b.score && a.id < b.id);
}

int main() {
    int n;
    cin >> n;

    vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        string olympiad;
        cin >> olympiad;

        vector<int> team;

        if (olympiad == "IOI" || olympiad == "CEOI" || olympiad == "BaltOI") {
            for (int j = 0; j < min(4, n); ++j) {
                team.push_back(participants[j].id);
            }
        } else if (olympiad == "EGOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].gender == "female") {
                    team.push_back(participants[j].id);
                    count++;
                }
            }
        } else if (olympiad == "EJOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].age <= 15) {
                    team.push_back(participants[j].id);
                    count++;
                }
            }
        } else if (olympiad == "BalkOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].grade != 11) {
                    team.push_back(participants[j].id);
                    count++;
                }
            }
        } else if (olympiad == "JBOI") {
            int count = 0;
            for (int j = 0; j < n && count < 4; ++j) {
                if (participants[j].grade != 11 && participants[j].grade != 10) {
                    team.push_back(participants[j].id);
                    count++;
                }
            }
        }

        cout << olympiad << endl;
        for (int id : team) {
            cout << id << endl;
        }
    }

    return 0;
}