def process_gifts(colors, sizes, initial_inventory, winners):
    remaining_inventory = {color: {size: count for size, count in sizes.items()} for color, sizes in initial_inventory.items()}
    missing_inventory = {color: {size: 0 for size in sizes} for color, sizes in initial_inventory.items()}

    for winner in winners:
        color, size = winner[0], winner[1]
        if remaining_inventory[color][size] > 0:
            remaining_inventory[color][size] -= 1
        else:
            found = False
            for next_size in sizes[size:]:
                if any(remaining_inventory[color][next_size] > 0 for color in remaining_inventory):
                    found = True
                    selected_color = min(remaining_inventory, key=lambda c: (remaining_inventory[c][next_size], c))
                    remaining_inventory[selected_color][next_size] -= 1
                    break
            if not found:
                for next_size in sizes[size:]:
                    if any(remaining_inventory[color][next_size] > 0 for color in remaining_inventory):
                        found = True
                        selected_color = min(remaining_inventory, key=lambda c: (remaining_inventory[c][next_size], c))
                        remaining_inventory[selected_color][next_size] -= 1
                        break
            if not found:
                missing_inventory[color][size] += 1

    return remaining_inventory, missing_inventory

def print_inventory(inventory):
    for color, sizes in inventory.items():
        print(" ".join(str(sizes[size]) for size in sizes))

# Зчитування вхідних даних
n, m = map(int, input().split())
sizes = input().split()
initial_inventory = {i + 1: {size: int(count) for size, count in enumerate(input().split())} for i in range(n)}
k = int(input())
winners = [input().split() for _ in range(k)]

# Обробка та виведення результатів
remaining_inventory, missing_inventory = process_gifts(initial_inventory=initial_inventory, winners=winners, colors=range(1, n+1), sizes=sizes)

print_inventory(remaining_inventory)
print_inventory(missing_inventory)