def solve_tshirt_problem(n, m, sizes, initial_counts, k, requests):
    remaining_counts = [[0] * m for _ in range(n)]
    order_counts = [[0] * m for _ in range(n)]

    for i in range(n):
        for j in range(m):
            remaining_counts[i][j] = initial_counts[i][j]

    for _ in range(k):
        color, size = int(requests[_][0]), requests[_][1]

        size_index = sizes.index(size)

        found = False

        for j in range(size_index, m):
            if remaining_counts[color - 1][j] > 0:
                remaining_counts[color - 1][j] -= 1
                found = True
                break

        if not found:
            for j in range(m):
                if remaining_counts[color - 1][j] > 0:
                    remaining_counts[color - 1][j] -= 1
                    order_counts[color - 1][j] += 1
                    found = True
                    break

        if not found:
            for j in range(size_index, m):
                if remaining_counts[1 - color][j] > 0:
                    remaining_counts[1 - color][j] -= 1
                    order_counts[1 - color][j] += 1
                    break

    return remaining_counts, order_counts

# Input
n, m = map(int, input().split())
sizes = input().split()

initial_counts = [list(map(int, input().split())) for _ in range(n)]

k = int(input())
requests = [input().split() for _ in range(k)]

# Solve the problem
remaining_counts, order_counts = solve_tshirt_problem(n, m, sizes, initial_counts, k, requests)

# Output
for row in remaining_counts:
    print(" ".join(map(str, row)))

for row in order_counts:
    print(" ".join(map(str, row)))
