#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
long long findMaxSubsegment(const std::vector<long long>& a, long long m) {
    long long n = a.size();
    long long left = 0, right = n + m;
    long long result = 0;

    while (left <= right) {
        long long mid = (left + right) / 2;
        vector<long long> b = a;

        for (int i = 0; i < n; ++i) {
            if (i < mid) {
                b[i] += m;
            }
        }

        sort(b.begin(), b.end());
        long long sum = 0;
        bool valid = true;

        for (int i = 0; i < n; ++i) {
            sum += b[i];
            if (sum < i + 1) {
                valid = false;
                break;
            }
        }

        if (valid) {
            result = mid;
            left = mid + 1;
        } else {
            right = mid - 1;
        }
    }

    return result;
}

int main() {
    long long n, m;
    cin >> n >> m;

    vector<long long> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    sort(a.begin(), a.end());

    long long result = findMaxSubsegment(a, m);
    cout << result << endl;

    return 0;
}
