#include <iostream>
#include <vector>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<std::string> sizes(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> sizes[i];
    }

    std::vector<std::vector<int>> available(n, std::vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cin >> available[i][j];
        }
    }

    int k;
    std::cin >> k;

    std::vector<std::vector<int>> needed(n, std::vector<int>(m));
    for (int i = 0; i < k; ++i) {
        int c;
        char s;
        std::cin >> c >> s;

        int sizeIndex = -1;
        for (int j = 0; j < m; ++j) {
            if (sizes[j][0] == s) {
                sizeIndex = j;
                break;
            }
        }

        needed[c - 1][sizeIndex]++;
    }

    std::vector<std::vector<int>> remaining(n, std::vector<int>(m));
    std::vector<std::vector<int>> toOrder(n, std::vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            remaining[i][j] = available[i][j] - needed[i][j];

            if (remaining[i][j] < 0) {
                int sizeIndex = j;
                while (sizeIndex < m && remaining[i][sizeIndex] < 0) {
                    sizeIndex++;
                }

                if (sizeIndex < m) {
                    remaining[i][sizeIndex]--;
                    toOrder[i][sizeIndex]++;
                } else {
                    int colorIndex = i;
                    while (colorIndex < n && remaining[colorIndex][j] < 0) {
                        colorIndex++;
                    }

                    if (colorIndex < n) {
                        remaining[colorIndex][j]--;
                        toOrder[colorIndex][j]++;
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << remaining[i][j] << " ";
        }
        std::cout << std::endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            std::cout << toOrder[i][j] << " ";
        }
        std::cout << std::endl;
    }

    return 0;
}
