#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;

    vector<string> sizes(m);
    for (int i = 0; i < m; ++i) {
        cin >> sizes[i];
    }

    vector<vector<int>> available(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> available[i][j];
        }
    }

    int k;
    cin >> k;

    vector<vector<int>> remaining(n, vector<int>(m, 0));
    vector<vector<int>> to_order(n, vector<int>(m, 0));

    for (int i = 0; i < k; ++i) {
        int c;
        char size;
        cin >> c >> size;

        int size_index = find(sizes.begin(), sizes.end(), string(1, size)) - sizes.begin();

        bool found = false;
        for (int j = 0; j <= size_index; ++j) {
            for (int color = 0; color < n; ++color) {
                if (available[color][j] > 0) {
                    --available[color][j];
                    found = true;
                    break;
                }
            }
            if (found) {
                break;
            }
        }

        if (!found) {
            for (int j = size_index + 1; j < m; ++j) {
                for (int color = 0; color < n; ++color) {
                    if (available[color][j] > 0) {
                        --available[color][j];
                        ++to_order[color][j];
                        found = true;
                        break;
                    }
                }
                if (found) {
                    break;
                }
            }
        }

        if (!found) {
            ++remaining[c - 1][size_index];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << remaining[i][j] << " ";
        }
        cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << to_order[i][j] << " ";
        }
        cout << endl;
    }

    return 0;
}
