#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);

    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade >> participants[i].age >> participants[i].score;
    }

    int m;
    std::cin >> m;

    for (int i = 0; i < m; ++i) {
        std::string olympiad;
        std::cin >> olympiad;

        std::vector<int> selectedIds;

        if (olympiad == "IOI" || olympiad == "BaltOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant &a, const Participant &b) {
                return a.score > b.score || (a.score == b.score && a.id < b.id);
            });
        } else if (olympiad == "EGOI") {
            std::sort(participants.begin(), participants.end(), [](const Participant &a, const Participant &b) {
                return a.score > b.score || (a.score == b.score && a.id < b.id) || (a.gender == "female" && b.gender == "male");
            });
        }

        for (const auto &participant : participants) {
            if (participant.gender == "female" && olympiad == "BaltOI") {
                continue;
            }

            if (selectedIds.size() == 0 || selectedIds.back() != participant.id) {
                selectedIds.push_back(participant.id);
            }
        }

        std::cout << olympiad << std::endl;
        for (const auto &id : selectedIds) {
            std::cout << id << std::endl;
        }
    }

    return 0;
}
