#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, m;
    std::cin >> n >> m;

    std::vector<int> colors(n);
    std::vector<bool> used(n, false);

    for (int i = 0; i < n; ++i) {
        std::cin >> colors[i];
    }

    // Сортуємо кольори в порядку зростання
    std::sort(colors.begin(), colors.end());

    int max_subrange_length = 0;

    for (int i = 1; i < n; ++i) {
        if (!used[i] && !used[i - 1]) {
            // Якщо попередній та поточний кольори незакреслені, обираємо будь-який з них
            used[i] = true;
            used[i - 1] = true;

            int subrange_length = 2;

            // Знаходимо максимальну парну довжину піддіапазону
            while (i + subrange_length < n && colors[i + subrange_length] == colors[i + subrange_length - 1]) {
                used[i + subrange_length] = true;
                used[i + subrange_length - 1] = true;
                subrange_length += 2;
            }

            max_subrange_length = std::max(max_subrange_length, subrange_length);
        }
    }

    // Друкуємо максимальну довжину піддіапазону перед вибором (m+1)-го кольору
    std::cout << max_subrange_length << std::endl;

    return 0;
}
