def distribute_tshirts(n, m, sizes, available_tshirts, k, winners):
    remaining_tshirts = [[0] * m for _ in range(n)]
    needed_tshirts = [[0] * m for _ in range(n)]

    for color, size in winners:
        size_index = sizes.index(size)

        found_tshirt = False

        # Check for the exact color and size
        if available_tshirts[int(color) - 1][size_index] > 0:
            available_tshirts[int(color) - 1][size_index] -= 1
            found_tshirt = True

        # Check for larger sizes with priority to the specified color
        else:
            for s in range(size_index + 1, m):
                if any(available_tshirts[c][s] > 0 for c in range(n)):
                    for c in range(n):
                        if available_tshirts[c][s] > 0:
                            available_tshirts[c][s] -= 1
                            found_tshirt = True
                            break
                    break

        if not found_tshirt:
            needed_tshirts[int(color) - 1][size_index] += 1

    return available_tshirts, needed_tshirts

# Input processing
n, m = map(int, input().split())
sizes = input().split()
available_tshirts = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [tuple(map(str, input().split())) for _ in range(k)]

# Run the algorithm
remaining, needed = distribute_tshirts(n, m, sizes, available_tshirts, k, winners)

# Output the results
for row in remaining:
    print(*row)

for row in needed:
    print(*row)
