#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

// Глобальні змінні для висоти та ширини вишиванки
int n, m;

// Функція, яка перевіряє, чи є координати в межах вишиванки
bool is_valid(int x, int y) {
  return 0 <= x && x < n && 0 <= y && y < m;
}

// Функція, яка малює промінь з верхнього лівого кута
void draw_ray_left(vector<vector<char>>& embroidery, int x, int y, int dx, int dy) {
  // Поки координати в межах вишиванки
  while (is_valid(x, y)) {
    // Малюємо хрестик
    embroidery[x][y] = 'x';
    // Рухаємося за напрямком променя
    x += dx;
    y += dy;
    // Якщо промінь доторкнувся до вертикального краю, але не до нижнього
    if (!is_valid(x, y) && is_valid(x, y - 2 * dy) && is_valid(x - dx, y)) {
      // Змінюємо напрямок по осі y
      dy = -dy;
      // Рухаємося за новим напрямком
      x += dx;
      y += dy;
    }
  }
}

// Функція, яка малює промінь з верхнього правого кута
void draw_ray_right(vector<vector<char>>& embroidery, int x, int y, int dx, int dy) {
  // Поки координати в межах вишиванки
  while (is_valid(x, y)) {
    // Малюємо хрестик
    embroidery[x][y] = 'x';
    // Рухаємося за напрямком променя
    x += dx;
    y += dy;
    // Якщо промінь доторкнувся до вертикального краю, але не до нижнього
    if (!is_valid(x, y) && is_valid(x, y + 2 * dy) && is_valid(x - dx, y)) {
      // Змінюємо напрямок по осі y
      dy = -dy;
      // Рухаємося за новим напрямком
      x += dx;
      y += dy;
    }
  }
}

int main() {
  // Вхідні дані
  cin >> n >> m; // Висота та ширина відповідно

  // Створення порожньої вишиванки
  vector<vector<char>> embroidery(n, vector<char>(m, '.'));

  // Малюємо промені з верхніх кутів
  draw_ray_left(embroidery, 0, 0, 1, 1); // З верхнього лівого кута
  draw_ray_right(embroidery, 0, m - 1, 1, -1); // З верхнього правого кута

  // Вивід вишиванки
  for (auto row : embroidery) {
    for (auto c : row) {
      cout << c;
    }
    cout << endl;
  }

  return 0;
}
