# Вхідні дані
n, m = map(int, input().split()) # Висота та ширина відповідно

# Створення порожньої вишиванки
embroidery = [['.'] * m for _ in range(n)]

# Функція, яка перевіряє, чи є координати в межах вишиванки
def is_valid(x, y):
  return 0 <= x < n and 0 <= y < m

# Функція, яка малює промінь з верхнього лівого кута
def draw_ray_left(x, y, dx, dy):
  # Поки координати в межах вишиванки
  while is_valid(x, y):
    # Малюємо хрестик
    embroidery[x][y] = 'x'
    # Рухаємося за напрямком променя
    x += dx
    y += dy
    # Якщо промінь доторкнувся до вертикального краю
    if not is_valid(x, y) and is_valid(x, y - 2 * dy):
      # Змінюємо напрямок по осі y
      dy = -dy
      # Рухаємося за новим напрямком
      x += dx
      y += dy

# Функція, яка малює промінь з верхнього правого кута
def draw_ray_right(x, y, dx, dy):
  # Поки координати в межах вишиванки
  while is_valid(x, y):
    # Малюємо хрестик
    embroidery[x][y] = 'x'
    # Рухаємося за напрямком променя
    x += dx
    y += dy
    # Якщо промінь доторкнувся до вертикального краю
    if not is_valid(x, y) and is_valid(x, y + 2 * dy):
      # Змінюємо напрямок по осі y
      dy = -dy
      # Рухаємося за новим напрямком
      x += dx
      y += dy

# Малюємо промені з верхніх кутів
draw_ray_left(0, 0, 1, 1) # З верхнього лівого кута
draw_ray_right(0, m - 1, 1, -1) # З верхнього правого кута

# Вивід вишиванки
for row in embroidery:
  print(''.join(row))
