#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

struct Participant {
    int id;
    std::string gender;
    int grade;
    int age;
    int score;
};

bool compareParticipants(const Participant &a, const Participant &b) {
    return a.score > b.score;
}

int main() {
    int n;
    std::cin >> n;

    std::vector<Participant> participants(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> participants[i].id >> participants[i].gender >> participants[i].grade
                 >> participants[i].age >> participants[i].score;
    }

    std::sort(participants.begin(), participants.end(), compareParticipants);

    int m;
    std::cin >> m;

    for (int i = 0; i < m; ++i) {
        std::string olympiad;
        std::cin >> olympiad;

        std::vector<int> selectedParticipants;

        if (olympiad == "IOI" || olympiad == "CEOI") {
            // Вибір 4 учасників з найвищим балом
            for (int j = 0; j < std::min(4, n); ++j) {
                selectedParticipants.push_back(participants[j].id);
            }
        } else if (olympiad == "EGOI") {
            // Вибір 4 учасників (дівчат) з найвищим балом
            for (int j = 0; j < std::min(4, n); ++j) {
                if (participants[j].gender == "female") {
                    selectedParticipants.push_back(participants[j].id);
                }
            }
        } else if (olympiad == "EJOI") {
            // Вибір 4 учасників (до 15 років) з найвищим балом
            for (int j = 0; j < std::min(4, n); ++j) {
                if (participants[j].age <= 15) {
                    selectedParticipants.push_back(participants[j].id);
                }
            }
        } else if (olympiad == "BaltOI" || olympiad == "BalkOI" || olympiad == "JBOI") {
            // Вибір 6 (BaltOI), 4 (BalkOI), або 4 (JBOI) учасників з найвищим балом
            int maxParticipants = (olympiad == "BaltOI") ? 6 : 4;
            for (int j = 0; j < std::min(maxParticipants, n); ++j) {
                selectedParticipants.push_back(participants[j].id);
            }
        }

        // Виведення результатів
        std::cout << olympiad << '\n';
        for (int id : selectedParticipants) {
            std::cout << id << '\n';
        }
    }

    return 0;
}
