

def distribute_tshirts(n, m, sizes, available, winners):
    remaining_tshirts = [[0] * m for _ in range(n)]
    needed_tshirts = [[0] * m for _ in range(n)]

    for i in range(n):
        for j in range(m):
            remaining_tshirts[i][j] = available[i][j]

    for winner in winners:
        color, size = winner
        color = int(color) - 1  # Convert color to integer and make it 0-indexed
        size_index = sizes.index(size)

        found = False
        for i in range(size_index, m):
            if remaining_tshirts[color][i] > 0:
                remaining_tshirts[color][i] -= 1
                found = True
                break

        if not found:
            for i in range(size_index):
                if remaining_tshirts[color][i] > 0:
                    remaining_tshirts[color][i] -= 1
                    needed_tshirts[color][i] += 1
                    found = True
                    break

        if not found:
            for i in range(m):
                if remaining_tshirts[color][i] > 0:
                    remaining_tshirts[color][i] -= 1
                    needed_tshirts[color][i] += 1
                    break

    return remaining_tshirts, needed_tshirts

n, m = map(int, input().split())
sizes = input().split()
sizes_dict = {size: i for i, size in enumerate(sizes)}

available = [list(map(int, input().split())) for _ in range(n)]

k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]


remaining, needed = distribute_tshirts(n, m, sizes, available, winners)

for i in range(n):
    print(" ".join(map(str, remaining[i])))

for i in range(n):
    print(" ".join(map(str, needed[i])))
