def determine_team(olympiad, participants):
    if olympiad == 'IOI' or olympiad == 'CEOI':
        team_size = 4
        sorted_participants = sorted(participants, key=lambda x: x[4], reverse=True)
    elif olympiad == 'EGOI':
        team_size = 4
        female_participants = [p for p in participants if p[1] == 'female']
        sorted_participants = sorted(female_participants, key=lambda x: x[4], reverse=True)
    elif olympiad == 'EJOI':
        team_size = 4
        young_participants = [p for p in participants if p[3] <= 15]
        sorted_participants = sorted(young_participants, key=lambda x: x[4], reverse=True)
    elif olympiad == 'BaltOI':
        team_size = 6
        sorted_participants = sorted(participants, key=lambda x: x[4], reverse=True)
    elif olympiad == 'BalkOI':
        team_size = 4
        non_11th_grade_participants = [p for p in participants if p[2] != 11]
        sorted_participants = sorted(non_11th_grade_participants, key=lambda x: x[4], reverse=True)
    elif olympiad == 'JBOI':
        team_size = 4
        non_11th_10th_grade_participants = [p for p in participants if p[2] != 11 and p[2] != 10]
        sorted_participants = sorted(non_11th_10th_grade_participants, key=lambda x: x[4], reverse=True)
    
    team_members = sorted_participants[:team_size]
    team_members_ids = sorted([member[0] for member in team_members])
    
    return team_members_ids

n = int(input())
participants = []

for _ in range(n):
    participant_info = input().split()
    participant_id = int(participant_info[0])
    gender = participant_info[1]
    grade = int(participant_info[2])
    age = int(participant_info[3])
    score = int(participant_info[4])
    participants.append([participant_id, gender, grade, age, score])

m = int(input())
olympiads = [input().strip() for _ in range(m)]

for olympiad in olympiads:
    team = determine_team(olympiad, participants)
    print(olympiad)
    print(*team)