def create_embroidery_pattern(n, m):
    pattern = [['.' for _ in range(m)] for _ in range(n)]

    for i in range(min(n, m)):
        pattern[i][i] = '*'
        pattern[i][m - i - 1] = '*'

    return pattern

def print_embroidery_pattern(pattern):
    for row in pattern:
        print(' '.join(row))

def main():
    n, m = map(int, input().split())

    if n < 3 or m < 3 or n > 1000 or m > 1000:
        print("Invalid input. n and m should be between 3 and 1000.")
        return

    embroidery_pattern = create_embroidery_pattern(n, m)
    print_embroidery_pattern(embroidery_pattern)

if __name__ == "__main__":
    main()

