def process_gifts(n, m, sizes, quantities, k, requests):
    # Initialize the inventory
    inventory = [[quantities[i][j] for j in range(m)] for i in range(n)]

    # Initialize lists to track excess and missing shirts
    excess_shirts = [[0] * m for _ in range(n)]
    missing_shirts = [[0] * m for _ in range(n)]

    for i in range(k):
        color, size = requests[i]

        # Convert color and size to integers
        color = int(color)
        size_index = sizes.index(size)

        # Check if there is a shirt of the requested size and color
        if inventory[color - 1][size_index] > 0:
            inventory[color - 1][size_index] -= 1
        else:
            # Find a replacement shirt following the given rules
            found = False
            for new_size_index in range(size_index + 1, m):
                if inventory[color - 1][new_size_index] > 0:
                    inventory[color - 1][new_size_index] -= 1
                    excess_shirts[color - 1][new_size_index] += 1
                    found = True
                    break

            if not found:
                for new_color in range(color, n):
                    for new_size_index in range(m):
                        if inventory[new_color][new_size_index] > 0:
                            inventory[new_color][new_size_index] -= 1
                            excess_shirts[new_color][new_size_index] += 1
                            found = True
                            break
                    if found:
                        break

            if not found:
                missing_shirts[color - 1][size_index] += 1

    # Output excess and missing shirts
    for row in excess_shirts:
        print(" ".join(map(str, row)))
    for row in missing_shirts:
        print(" ".join(map(str, row)))


# Example usage
n, m = map(int, input().split())
sizes = input().split()
quantities = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
requests = [tuple(map(str, input().split())) for _ in range(k)]

process_gifts(n, m, sizes, quantities, k, requests)
