def process_requests(n, m, sizes, inventory, winners):
    remaining_inventory = {size: {color: 0 for color in range(1, n + 1)} for size in sizes}
    required_orders = {size: {color: 0 for color in range(1, n + 1)} for size in sizes}
    winners_inventory = {size: {color: 0 for color in range(1, n + 1)} for size in sizes}

    for color, size, count in inventory:
        remaining_inventory[size][color] += count

    for winner in winners:
        color, size = int(winner[1]), winner[0]
        if remaining_inventory[size][color] > 0:
            remaining_inventory[size][color] -= 1
            winners_inventory[size][color] += 1
        else:
            found_alternative = False
            for alt_size in sizes[sizes.index(size):]:
                for alt_color in sorted(remaining_inventory[alt_size]):
                    if remaining_inventory[alt_size][alt_color] > 0:
                        remaining_inventory[alt_size][alt_color] -= 1
                        winners_inventory[alt_size][alt_color] += 1
                        found_alternative = True
                        break
                if found_alternative:
                    break
            else:
                # Якщо альтернативу не знайдено, то заповнюємо пропуск
                required_orders[size][color] += 1

    for size in sizes:
        for color in remaining_inventory[size]:
            required_orders[size][color] += remaining_inventory[size][color]

    return winners_inventory, required_orders

def print_table(table):
    for row in table:
        print(" ".join(map(str, row)))

# Вхідні дані
n, m = map(int, input().split())
sizes = input().split()
inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(input().split()) for _ in range(k)]

# Обробка запитів переможців
winners_inventory, required_orders = process_requests(n, m, sizes, inventory, winners)

# Виведення результатів
print_table([list(row.values()) for row in winners_inventory.values()])
print_table([list(row.values()) for row in required_orders.values()])
