def distribute_gifts(n, m, sizes, quantities, winners):
    remaining_gifts = [[quantity for quantity in row] for row in quantities]
    missing_gifts = [[0] * m for _ in range(n)]

    for winner in winners:
        color, size = int(winner[0]) - 1, sizes.index(winner[1])
        found = False

        for i in range(size, m):
            if remaining_gifts[color][i] > 0:
                remaining_gifts[color][i] -= 1
                found = True
                break

        if not found:
            for i in range(m):
                for j in range(color + 1, n):
                    if remaining_gifts[j][i] > 0:
                        remaining_gifts[j][i] -= 1
                        found = True
                        break
                if found:
                    break

        if not found:
            missing_gifts[color][size] += 1

    return remaining_gifts, missing_gifts


def main():
    n, m = map(int, input().split())
    sizes = input().split()
    quantities = [list(map(int, input().split())) for _ in range(n)]
    k = int(input())
    winners = [list(map(str, input().split())) for _ in range(k)]

    remaining, missing = distribute_gifts(n, m, sizes, quantities, winners)

    for row in remaining:
        print(" ".join(map(str, row)))

    for row in missing:
        print(" ".join(map(str, row)))


if __name__ == "__main__":
    main()
