import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int n = scanner.nextInt();
        int m = scanner.nextInt();

        char[] sizes = new char[m];
        for (int i = 0; i < m; ++i) {
            sizes[i] = scanner.next().charAt(0);
        }

        int[][] quantities = new int[n][m];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                quantities[i][j] = scanner.nextInt();
            }
        }

        int k = scanner.nextInt();

        int[][] winners = new int[k][2];
        for (int i = 0; i < k; ++i) {
            winners[i][0] = scanner.nextInt();
            winners[i][1] = sizes[scanner.next().charAt(0) - 'S'];
        }

        distributeGifts(n, m, sizes, quantities, winners);

        scanner.close();
    }

    static void distributeGifts(int n, int m, char[] sizes, int[][] quantities, int[][] winners) {
        int[][] remainingGifts = new int[n][m];
        int[][] missingGifts = new int[n][m];

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                remainingGifts[i][j] = quantities[i][j];
            }
        }

        for (int[] winner : winners) {
            int color = winner[0] - 1;
            char size = (char) winner[1];
            int sizeIndex = size - 'S';

            boolean found = false;

            for (int i = sizeIndex; i < m; ++i) {
                if (remainingGifts[color][i] > 0) {
                    remainingGifts[color][i]--;
                    found = true;
                    break;
                }
            }

            if (!found) {
                for (int i = 0; i < m; ++i) {
                    for (int j = color + 1; j < n; ++j) {
                        if (remainingGifts[j][i] > 0) {
                            remainingGifts[j][i]--;
                            found = true;
                            break;
                        }
                    }
                    if (found) {
                        break;
                    }
                }
            }

            if (!found) {
                missingGifts[color][sizeIndex]++;
            }
        }

        // Вивід залишкових та відсутніх футболок
        for (int[] row : remainingGifts) {
            for (int gift : row) {
                System.out.print(gift + " ");
            }
            System.out.println();
        }

        for (int[] row : missingGifts) {
            for (int missing : row) {
                System.out.print(missing + " ");
            }
            System.out.println();
        }
    }
}
