def select_team(olympiad, participants):
    selected_participants = []

    if olympiad == "IOI":
        team_size = min(4, len(participants))
        selected_participants = sorted(participants, key=lambda x: x[4], reverse=True)[:team_size]
    elif olympiad == "CEOI":
        team_size = min(4, len(participants))
        selected_participants = sorted(participants, key=lambda x: x[4], reverse=True)[:team_size]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        team_size = min(4, len(female_participants))
        selected_participants = sorted(female_participants, key=lambda x: x[4], reverse=True)[:team_size]
    elif olympiad == "EJOI":
        under_15_participants = [p for p in participants if p[3] <= 15]
        team_size = min(4, len(under_15_participants))
        selected_participants = sorted(under_15_participants, key=lambda x: x[4], reverse=True)[:team_size]
    elif olympiad == "BaltOI":
        team_size = min(6, len(participants))
        selected_participants = sorted(participants, key=lambda x: x[4], reverse=True)[:team_size]
    elif olympiad == "BalkOI":
        not_11th_graders_participants = [p for p in participants if p[2] != 11]
        team_size = min(4, len(not_11th_graders_participants))
        selected_participants = sorted(not_11th_graders_participants, key=lambda x: x[4], reverse=True)[:team_size]
    elif olympiad == "JBOI":
        not_11th_or_10th_graders_participants = [p for p in participants if p[2] not in [10, 11]]
        team_size = min(4, len(not_11th_or_10th_graders_participants))
        selected_participants = sorted(not_11th_or_10th_graders_participants, key=lambda x: x[4], reverse=True)[:team_size]

    return selected_participants


def main():
    n = int(input())
    participants = [list(input().split()) for _ in range(n)]
    participants = [(int(p[0]), p[1], int(p[2]), int(p[3]), int(p[4])) for p in participants]

    m = int(input())
    olympiads = [input() for _ in range(m)]

    for olympiad in olympiads:
        selected_team = select_team(olympiad, participants)
        print(olympiad)
        for participant in sorted(selected_team, key=lambda x: x[0]):
            print(participant[0])


if __name__ == "__main__":
    main()
