def max_unmarked_subsegment_length(n, m, colors):
    colors.sort()

    max_length = colors[0] - 1

    for i in range(1, n):
        gap = (colors[i] - colors[i - 1]) // 2
        max_length = max(max_length, gap)

    gap_after_last_color = (m if n == 1 else colors[-1])
    max_length = max(max_length, gap_after_last_color)

    return max_length

# Example 1
n1, m1 = 1, 1
colors1 = [11]
result1 = max_unmarked_subsegment_length(n1, m1, colors1)
print(result1)  # Output: 11

# Example 2
n2, m2 = 1, 3
colors2 = [11]
result2 = max_unmarked_subsegment_length(n2, m2, colors2)
print(result2)  # Output: 5

# Example 3
n3, m3 = 1, 5
colors3 = [11]
result3 = max_unmarked_subsegment_length(n3, m3, colors3)
print(result3)  # Output: 2

# Example 4
n4, m4 = 1, 109
colors4 = [1033]
result4 = max_unmarked_subsegment_length(n4, m4, colors4)
print(result4)  # Output: 15

# Example 5
n5, m5 = 3, 1145
colors5 = [4034, 5912, 9134]
result5 = max_unmarked_subsegment_length(n5, m5, colors5)
print(result5)  # Output: 22
