def get_team_members(olympiad, participants):
    if olympiad == "IOI":
        participants.sort(key=lambda x: x[4], reverse=True)
        return participants[:4]
    elif olympiad == "CEOI":
        participants.sort(key=lambda x: x[4], reverse=True)
        return participants[:4]
    elif olympiad == "EGOI":
        female_participants = [p for p in participants if p[1] == "female"]
        female_participants.sort(key=lambda x: x[4], reverse=True)
        return female_participants[:4]
    elif olympiad == "EJOI":
        young_participants = [p for p in participants if p[3] <= 15]
        young_participants.sort(key=lambda x: x[4], reverse=True)
        return young_participants[:4]
    elif olympiad == "BaltOI":
        participants.sort(key=lambda x: x[4], reverse=True)
        return participants[:6]
    elif olympiad == "BalkOI":
        non_11th_graders = [p for p in participants if p[2] != 11]
        non_11th_graders.sort(key=lambda x: x[4], reverse=True)
        return non_11th_graders[:4]
    elif olympiad == "JBOI":
        non_11th_10th_graders = [p for p in participants if p[2] not in [11, 10]]
        non_11th_10th_graders.sort(key=lambda x: x[4], reverse=True)
        return non_11th_10th_graders[:4]

def main():
    n = int(input())
    participants = []
    for _ in range(n):
        data = input().split()
        participants.append((int(data[0]), data[1], int(data[2]), int(data[3]), int(data[4])))

    m = int(input())
    olympiads = [input() for _ in range(m)]

    for olympiad in olympiads:
        team_members = get_team_members(olympiad, participants)
        print(olympiad)
        for member in sorted(team_members):
            print(member[0])

main()