from collections import defaultdict

def process_gifts(n, m, sizes, inventory, winners):
    # Ініціалізуємо початковий інвентар футболок
    gift_inventory = defaultdict(lambda: defaultdict(int))
    for i in range(n):
        for j in range(m):
            gift_inventory[i][sizes[j]] += inventory[i][j]

    # Ініціалізуємо змінні для футболок, що залишилися та що потрібно замовити
    remaining_gifts = [[gift_inventory[i][sizes[j]] for j in range(m)] for i in range(n)]
    needed_gifts = [[0 for _ in range(m)] for _ in range(n)]

    # Перевіряємо запити переможців та видаємо футболки
    for winner in winners:
        color, size = int(winner[0]) - 1, sizes.index(winner[1])
        if remaining_gifts[color][size] > 0:
            remaining_gifts[color][size] -= 1
        else:
            found = False
            for i in range(size + 1, m):
                if gift_inventory[color][sizes[i]] > 0:
                    gift_inventory[color][sizes[i]] -= 1
                    needed_gifts[color][i] += 1
                    found = True
                    break
            if not found:
                for i in range(color + 1, n):
                    for j in range(m):
                        if gift_inventory[i][sizes[j]] > 0:
                            gift_inventory[i][sizes[j]] -= 1
                            needed_gifts[i][j] += 1
                            found = True
                            break
                    if found:
                        break
                if not found:
                    needed_gifts[color][size] += 1

    return remaining_gifts, needed_gifts

# Отримуємо вхідні дані
n, m = map(int, input().split())
sizes = input().split()
inventory = [list(map(int, input().split())) for _ in range(n)]
k = int(input())
winners = [list(map(str, input().split())) for _ in range(k)]

# Обробляємо подарунки та виводимо результат
remaining, needed = process_gifts(n, m, sizes, inventory, winners)

# Виводимо залишок футболок та ті, які потрібно замовити
for row in remaining:
    print(*row)

for row in needed:
    print(*row)
