from collections import defaultdict

def determine_team_participants(olympiads, participants):
    results = defaultdict(list)

    for participant in participants:
        id, gender, grade, age, score = participant
        for olympiad in olympiads:
            if olympiad == 'IOI':
                results['IOI'].append((score, id))
            elif olympiad == 'CEOI':
                results['CEOI'].append((score, id))
            elif olympiad == 'EGOI' and gender == 'female':
                results['EGOI'].append((score, id))
            elif olympiad == 'EJOI' and age <= 15:
                results['EJOI'].append((score, id))
            elif olympiad == 'BaltOI':
                results['BaltOI'].append((score, id))
            elif olympiad == 'BalkOI' and grade != 11:
                results['BalkOI'].append((score, id))
            elif olympiad == 'JBOI' and grade < 11:
                results['JBOI'].append((score, id))

    teams = {}
    for olympiad in olympiads:
        scores_ids = results[olympiad]
        scores_ids.sort(reverse=True)
        team_size = determine_team_size(olympiad, len(scores_ids))
        teams[olympiad] = [participant[1] for participant in scores_ids[:team_size]]
        teams[olympiad].sort()

    return teams

def determine_team_size(olympiad, num_participants):
    if olympiad in ['IOI', 'CEOI']:
        return min(4, num_participants)
    elif olympiad == 'EGOI':
        return min(4, num_participants)
    elif olympiad == 'EJOI':
        return min(4, num_participants)
    elif olympiad == 'BaltOI':
        return min(6, num_participants)
    elif olympiad == 'BalkOI':
        return min(4, num_participants)
    elif olympiad == 'JBOI':
        return min(4, num_participants)
    else:
        return 0

n = int(input())
participants = []
for _ in range(n):
    data = input().split()
    id, gender, grade, age, score = int(data[0]), data[1], int(data[2]), int(data[3]), int(data[4])
    participants.append((id, gender, grade, age, score))

m = int(input())
olympiads = [input().strip() for _ in range(m)]

teams = determine_team_participants(olympiads, participants)

for olympiad in olympiads:
    teams[olympiad].sort()
    print(olympiad)
    for participant in teams[olympiad]:
        print(participant)
