import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt(); // кількість кольорових кіл
        long m = scanner.nextLong(); // кількість кольорів, які ще треба взяти

        long[] colors = new long[n];
        for (int i = 0; i < n; i++) {
            colors[i] = scanner.nextLong();
        }

        long maxSubsequenceLength = calculateMaxSubsequenceLength(n, m, colors);
        System.out.println(maxSubsequenceLength);
    }

    public static long calculateMaxSubsequenceLength(int n, long m, long[] colors) {
        Arrays.sort(colors); // Сортуємо масив кольорів

        long left = 0;
        long right = (long) 1e18; // Максимальне можливе значення для пошуку
        long ans = 0;

        while (left <= right) {
            long mid = (left + right) / 2;
            long count = 0;

            for (int i = 0; i < n; i++) {
                if (colors[i] <= mid) {
                    count += (mid - colors[i]);
                } else {
                    break;
                }
            }

            if (count >= m) {
                ans = mid;
                right = mid - 1;
            } else {
                left = mid + 1;
            }
        }

        return ans;
    }
}
